# Release version 4.0.20191.624 - 02/14/2019

## C1.WPF.DateTime

### Bug fixes

- [C1DateTimePicker][C1DatePicker][C1TimeEditor] Items can not be navigated using "TAB" key from keyboard (TFS-365272)

## C1.WPF.RichTextBox

### Bug fixes

- C1RichTextBox - Scroll into view doesn't work properly when tabbing between table cells (TFS-42068)

## C1.WPF.TileView

### Bug fixes

- [C1TileView] C1TileView Item's layout in default state is changed by setting MinimizedItemsPosition to Top/Bottom. (TFS-365987)

# Release version 4.0.20191.623 - 02/13/2019

## C1.WPF

### Bug fixes

- [VS 2019][ProjectTemplate] C1ProjectType.vsix can not be installed on VS 2019 Preview 2. (TFS-364763)

## C1.WPF.FlexChart

### Bug fixes

- Fixed problem with hidden legend group's titles under several conditions (TFS:361061).
- Reversed legend now works correctly with pie chart (TFS:365922).
- Fixed problem with incorrect line chart clipping (TFS:364969).
- Fixed problem with exception when DataLabel.Position = Auto for empty pie chart (TFS:365745).
- Fixed problem with scrollbar layout for auxiliary axes (TFS:276828).

## C1.WPF.FlexSheet

### Bug fixes

- [Themes] Text are not seen clearly in edit mode of FlexSheet with Office2016DarkGray Themes (TFS-363808)

## C1.WPF.Pdf

### Bug fixes

- C1PdfDocument.DrawString's output is clipped (... at the end of line) when text length is greater than page's width. (TFS:366575)

## C1.WPF.Toolbar

### Bug Fixes

- [SimplifiedRibbon] Corrected issues in themes. (TFS-355542, 355540)
- [SimplifiedRibbon] Dropdown width of SimplifiedRibbongroup is shown as full width of the screen even after the form to minimum width. (TFS-363760)
- [SimplifiedRibbon]System.ArgumentException occurs on loading SimplifiedRibbon with SimplifiedTabItem if WindowState is set Minimized at design time (TFS-366449)

### Improvements:

- [SimplifiedRibbon][Internal] Adjusted appearance in all themes.

# Release version 4.0.20191.622 - 02/01/2019

## C1.WPF

### Bug fixes

- [C1TabControl] 'System.InvalidOperationException' occurred in PresentationFramework.dll when opening the dropdown of the SimplifiedRibbonGroup after changing the form size to minimum and change the Themes. (TFS-363785)
- [C1NumericBox] Setting IsTabStop to False in Input and Editor based UWP controls not working correctly. (TFS-364216)

## C1.WPF.DateTime

### Bug fixes

- [C1DatePicker][C1TimeEditor][C1DateTimePicker] Setting IsTabStop to False in Input and Editor based UWP controls not working correctly. (TFS-364216)

## C1.WPF.Toolbar

### Bug Fixes

- [SimplifiedRibbon] Collapsed/Expand button of SimplifiedRibbon does not change accordingly when IsCollapsed property is changed at DesignTime and RunTime. (TFS-364543)

# Release version 4.0.20191.621 - 01/28/2019

## C1.WPF

### Bug fixes

- [C1TileListBox] C1TileListBox freezes upon scrolling/window resize. (TFS-362615)
- [C1TileListBox] Number of Items Displayed are being affected by the size of Items in C1TileListBox. (TFS-363079)
- [C1Combobox] Null is saved back to the bound property after editing completed in a C1ComboBox cell of a TemplatedColumn in C1DataGrid. (TFS-362841)

### Improvements

- Update project template to support VS 2019.

## C1.WPF.DataGrid

### Bug fixes

- [C1DataGrid] Remove the paste capability over a read-only gridcell. (TFS-361502)

## C1.WPF.FlexChart

### Improvements

- Added automatic data label positioning for pie chart (new enum member PieLabelPosition.Auto).
- Added localization mechanism for text and localizations for ja,ko and zh.

## C1.WPF.RichTextBox

### Bug fixes

- C1RichTextBox does not show complete content after vertical scrollbar hides (TFS-362536)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- "Tools" menu of C1RichTextBoxToolbar still open even when "Spelling" dialog is opened.(TFS-40736)

## C1.WPF.Toolbar

### Bug Fixes

- [SimplifiedRibbon] 'System.NullReferenceException' in PresentationFramework.dll when IsCollapsed property is set FALSE at design time (TFS-364263)

## C1.WPF.Zip

### Breaking Changes:

- [C1Zip] The default encoding for file names has been changed to UTF8. (TFS-362746)

### Bug Fixes:

- [C1Zip] Umlaut renders incorrectly when viewing a zipped file. (TFS-362746)

### Improvements:

- Added new ZipEncoding class. The ZipEncoding.Encoding property specifies encoding used for zip entry names and comments.
  The default encoding is UTF8. (TFS-362746)

# Release version 4.0.20191.620 - 01/18/2019

## C1.WPF

### Breaking Changes

- C1PathIcon class has been renamed to C1PolygonIcon.
- C1SVGIcon class has been renamed to C1PathIcon.

## C1.WPF.FlexGridFilter

### Improvements

- Apply full text filter for C1FlexGrid (TFS-356165)

## C1.WPF.FlexSheet

### Improvements

- Support edit and delete a comment in FlexSheet (TFS-355550)(TFS-352602)

## C1.WPF.Toolbar

### Breaking Changes

- C1PathIcon class has been renamed to C1PolygonIcon.
- C1SVGIcon class has been renamed to C1PathIcon.

# Release version 4.0.20191.619 - 01/16/2019

## C1.WPF

### Bug fixes

- [C1ComboBox] Selected item getting reset in C1ComboBox after the view is changed. (TFS:79861)

### Improvements

- [C1FontIcon] Added TextDecorations property.

## C1.WPF.DataGrid.Filters

### Improvements:

- Extended FullTextSearchBehavior functionality. Added new properties: MatchWholeWord, MatchCase, MatchNumbers and TreatSpacesAsAndOperator. (TFS-356166)

## C1.WPF.Excel

### Bug fixes

- Request to provide information on format and input rule in C1Excel. (TFS:339348)
- Error at loading Excel Spreadsheet: "Input string was not in a correct format". (TFS:355352)

### Improvements

- Support data validations of C1Excel.

## C1.WPF.FlexGrid

### Bug fixes

- AutoSizeColumns method with allCells argument=true not working correctly. (TFS-350598)
- Vertical scrollbar overlapping last column's content. (TFS-358439)

### Improvements

- [C1Icon] apply for all FlexGrid icons. (TFS-349524)

## C1.WPF.FlexSheet

### Bug fixes

- [FlexSheet]SortDialog still displays over other windows even focus lost from that dialog. (TFS-361601)

## C1.WPF.Input

### Bug Fixes:

- [C1MultiSelect] Focus cursor is moved to infornt of the text and last selected item is lost when pressing the "Spacebar" key in C1MultiSelect. (TFS-345582)
- [C1MultiSelect] NullReferenceException thrown when pressing 'Up' key after deleting some characters of item in text display mode using 'Backspace' key. (TFS-348023)
- [C1MultiSelect][C1Checklist] SelectedItems can't be added through SelectedItemsCollectionEditor from properties window of InputSamples. (TFS-345594)

# Release version 4.0.20183.618 - 01/15/2019

## C1.WPF.RichTextBox

### Bug fixes

- Clipboard getting cleared on application closure (TFS-361388)
- Japanese text containing one-byte spaces does not wrap correctly, display a haft of Japanese word in WrapWithOverflow (TFS-360611)
- Text entered below Table shows on wrong side in output HTML file (TFS-361043)

# Release version 4.0.20183.616 - 01/09/2019

## C1.WPF.DataGrid.Excel

### Bug Fixes

- DataGrid Bound Columns do not use Binding Converter while exporting/saving DataGrid. (TFS-359326)

## C1.WPF.RichTextBox

### Bug fixes

- Japanese text containing one-byte spaces does not wrap correctly (TFS-360611)
- System.IndexOutOfRangeException is thrown in C1.WPF.RichTextBox.4.dll when changing the font size in C1RichTextBox (TFS-360425)

# Release version 4.0.20183.615 - 01/02/2019

## C1.WPF

### Bug fixes

- [C1DataGrid] ComboBox Editor cell in DataGrid does not always show the selected item in scrollable view when drop down opened (TFS-358230)

## C1.WPF.Binding

### Improvements

- [CalcEngine] Add new formulas NOW, TODAY. (TFS-356967)

## C1.WPF.DataGrid

### Bug fixes

- [C1DataGrid] Increasing Column Width after few Horizontal Scrollings (back and forth). (TFS-356957)

## C1.WPF.Docking

### Bug Fixes:

- The DockTabControl is shown at some random location for a while when Dragged out from Docked to Floating mode. (TFS-357283)
- Not possible to change the size of the dock through mouse. (TFS-359243)
- Queries regarding restored layout and display of tabs in C1DockControl. (TFS-359246)

## C1.WPF.FlexChart

### Bug fixes

- Axis.MajorGrid synced with MajorUnit for categorical data (TFS:357119).
- Axis.LabelMin/LabelMax works correctly along with MajorUnit (TFS:359112).
- Plot areas are hidden if they are not fit into plot rectangle (TFS:355507).
- Fixed issue with incorrect mouse wheel scrolling in legend (TFS:350726).
- Plot areas are hidden if they are not fit into plot rectangle (TFS:355507).
- Plot margin applied correctly for multiple plot area (TFS:353856).
- Fixed exception during animation after adding data point to empty collection (TFS:351119).

## C1.WPF.FlexGrid

### Bug fixes

- If window's IsEnable is set to false followed by true upon grid's MouseUp event, grid does not scroll till next cell click. (TFS-356213)

## C1.WPF.FlexSheet

### Improvements

- [CalcEngine] Add new formulas LOOKUP, VLOOKUP, HLOOKUP, Public C1FlexSheet.CalcEngine API. (TFS-356967)

## C1.WPF.RichTextBox

### Bug fixes

- Applied font family and font size are not displayed in FontFamily and FontSize dropdowns if selected text range contains images (TFS-355793)

### Improvements:

- C1RichTextBox TextWrapping with Japanese enhancement (TFS-359317)

# Release version 4.0.20183.614 - 12/06/2018

## C1.WPF.Excel

### Bug fixes

- 'Excel found unreadable content in new1.xlsx. Do you want to recover the contents of
  this workbook?...' Error message box is shown when loading saved excel file. (TFS:355783)

## C1.WPF.Input

### Bug Fixes:

- [C1MultiSelect] 'System.NullReferenceException' is thrown when SelectAll() is used before applying template. (TFS-356046)

## C1.WPF.RichTextBox

### Bug fixes:

- [RichTextBox]Line break does not occurs although HTML contents contains <br> tag (TFS-355997)

# Release version 4.0.20183.613 - 11/30/2018

## C1.WPF

### Bug fixes

- [Menu][Regression] NullReferenceException is thrown when dragdrop the C1Menu to the form (TFS-355373)
- [C1DockControl] Map control placed inside C1DockControl not working. (TFS-355414)

## C1.WPF.RichTextBox

### Bug fixes:

- Some formatted text and images are lost when loading HTML file in RichTextBox (TFS-355375)
- Table cell contents are getting exceeds to next column cell instead of wrapping text as new line (TFS-355538)

## C1.WPF.Toolbar

### Bug Fixes

- [SimplifiedRibbon]"Cannot find resource named 'PopupBackgroundBrush'" error. (TFS-355487)

# Release version 4.0.20183.612 - 11/23/2018

## C1.WPF

### Bug fixes

- C1RangeSlider's thumbs never stick together when used inside C1DataGrid's Filter. (TFS-353979)
- Submenu items do not auto close when resize window, change position of window and focus is moved to other windows even AutoClose property is set True. (TFS-341141)

## C1.WPF.DataGrid

### Bug fixes

- Selected Row changes when sorting or filtering is applied and Filter Row is added in C1DataGrid. (TFS-351255)
- When a hidden Freeze column is included, the grid may stop responding when the freeze bar is dragged. (TFS-354710)

## C1.WPF.Excel

### Bug fixes

- PrintSettings.AutoScale changing value in case of zero being set as FitPagesAcross,
  FitPagesDown value. (TFS:349708)
- All images are not saved when saving Grid to multiple sheet XLS (BIFF8 format)
  excel file. (TFS:352600)
- Sheets may not be loaded correctly in certain xlsx files. (TFS:343265)
- NumberFormat Style is lost and saved excel file required to Repair when opened
  in MS Excel. (TFS:343056)

## C1.WPF.FlexGrid

### Bug fixes

- AutoSizeColumns method with allCells argument=true not working correctly. (TFS-350598)

## C1.WPF.RichTextBox

### Bug fixes:

- Incorrect behavior observed by setting C1RichTextBox's TextWrapping property to WrapWithOverflow. (TFS-353262)

# Release version 4.0.20183.611 - 11/05/2018

## C1.WPF.RichTextBox

### Bug fixes:

- Unlike Microsoft Word, text in superscripted form and text in subscripted form can't be directly changed. (TFS-352250)
- [RichTextbox][Regression] Only one character can't be selected in C1RichTextBox. (TFS-352253)

# Release version 4.0.20183.610 - 10/25/2018

## C1.WPF.RichTextBox

### Bug fixes:

- [C1RichTextBox] Memory leak in C1RichTextBox.(TFS-349660)
- [C1RichTextBox] Character/Image getting inserted before/after cursor, depending on the clicked location. (TFS-349614)

# Release version 4.0.20183.609 - 10/20/2018

## C1.WPF

### Bug fixes

- [C1MaskedTextBox] Selecting an existing value and entering value starting with 0 does not work with C1MaskedTextBox with Mask property set. (TFS-348620)

## C1.WPF.FlexChart

### Bug fixes

- Fixed exception that may happen when using auxiliary axes (TFS:347851).
- Fixed problem with incorrect clipping (TFS:348812).

## C1.WPF.RichTextBox

### Bug fixes:

- [RichTextBox]Images and horizontal lines are not selected/removed after select all content by pressing Ctrl+A and press Delete/Backspace key. (TFS-349110)
- [RichTextBox]Non editable element disappears when trying to select by mouse dragging and appear only after release from mouse dragging. (TFS-349143)
- [RichTextBox]Tabel cannot be deleted if table is added before and under the text or only table is added in the page. (TFS-349147)

# Release version 4.0.20183.608 - 10/18/2018

## C1.WPF

### Bug fixes

- [C1TreeView] Dragging an item outside the bounds of C1TreeView throws InvalidCastException in product sample "C1TreeViewDragDropSample". (TFS-348700)

## C1.WPF.Excel

### Bug fixes

- C1Excel generates ArgumentOutOfRangeException on loading with file created in Colombian Spanish culture. (TFS:346224)

## C1.WPF.Input

### Bug Fixes:

- [C1MultiSelect] Text Of Tag cannot be able to deleted and automatically replaced with other word in Tag when delete the text in Tag by using Backspace key in "Append/SuggestAppend" AutoCompleteMode. (TFS-323932)
- [C1TagEditor] tag can't be deleted by clicking cross button of that tag when InsertTag()method or controlName.Tags.Add() method is used under InitializedComponent() in C1TagEditor. (TFS-348611)

## C1.WPF.RichTextBox

### Bug fixes:

- [C1RichTextBox] Grab handlers do not change after deleting a column from Table. (TFS-348163)
- [C1RichTextBox] Even after setting element's IsEditable to false, we can select it. (TFS-347085)

# Release version 4.0.20183.607 - 10/17/2018

## C1.WPF.Input

### Bug Fixes:

- [C1MultiSelect] Focus cursor is moved to infornt of the text and last selected item is lost when pressing the "Spacebar" key in C1MultiSelect. (TFS-345582)
- [C1MultiSelect] NullReferenceException thrown when pressing 'Up' key after deleting some characters of item in text display mode using 'Backspace' key. (TFS-348023)

## C1.WPF.RichTextBox

### Bug fixes:

- [SL][C1RichTextBox] Html content does not rendered correctly in C1RichTextBox. (TFS-136882)
- [C1RichTextBox] Loading images in C1RichTextBox asynchronous. (TFS-347990)

# Release version 4.0.20183.606 - 10/16/2018

## C1.WPF.FlexChart

### Bug fixes

- Tooltips displayed correctly when complex binding string contains spaces (TFS:347548).
- FinancialChart's default tooltip content is now consistent with FlexChart (TFS:347591).
- Fixed exception when resizing chart with legend with scrollbar (TFS:347864).

# Release version 4.0.20183.605 - 10/12/2018

## C1.WPF.DataGrid

### Bug fixes

- [C1DataGrid] System.ArguementException thrown while scrolling grid horizontally. (TFS-347571)

## C1.WPF.Extended

### Bug fixes

- [C1Propertygrid] If C1PropertyGrid is put inside floating C1DockControl and collection editor is opened then it shows below C1Propertygrid. (TFS-345935)

## C1.WPF.FlexChart

### Bug fixes

- Added support of animation when toggling legend items (TFS:345247).
- Binding fields with spaces parsed correctly now (TFS:346082).

## C1.WPF.FlexGrid

### Bug fixes

- NullReferenceException occurs when sorting is applied if IsClosed property of C1PolygonIcon used in sort icon template is set FALSE. (TFS-345967)

## C1.WPF.FlexSheet

### Bug fixes

- FilterDialog does not attach its column and moves along mouse dragging when trying to resize it. (TFS-345534)
- ArgumentOutOfRangeException occurs when trying to resize columns of FlexSheet. (TFS-345506)
- "Delete Level" and "Copy Level" buttons in SortDialog are still enable although there is no added level and ArgumentOutOfRangeException occurs on clicking these buttons. (TFS-345552)

## C1.WPF.Input

### Bug Fixes:

- [C1MultiSelect] Incorrect behaviors are observed when setting AutocompleteMode to "Append". (TFS-323327)
- [C1MultiSelect] Incorrect behaviors are observed when setting AutoCompleteMode to SuggestAppend. (TFS-323621)
- [C1MultiSelect][C1CheckList] Same data items are not selected although checking ‘SelectAll’ checkbox when same value data items are binded in C1MultiSelect dropdown. (TFS-310780)
- [C1MultiSelect][Regression] Newly added items are not shown in C1listviewer when adding items from C1MultiSelect dropdown. (TFS-345883)

## C1.WPF.Maps

### Bug fixes:

- [Maps]"System.NullReferenceException" occurred in C1.WPF.Maps.4.dll when navigation to the "Analysis" tab of DashboardDemo.(TFS-347512)

# Release version 4.0.20183.604 - 10/06/2018

## C1.WPF

### Bug fixes

- [ComboBox]Previous selected item still remains in text area when ItemsSource is changed or set null value. (TFS-340217)

## C1.WPF.DataGrid

### Bug fixes

- [C1DataGrid] Request to add "Not contains" value in DataGridFilterOperation enum in C1Datagrid. (TFS-343921)

## C1.WPF.FlexChart

### Bug fixes

- Fixed exception during pie chart animation (TFS:345579).
- Legend items rendered correctly after adding series (TFS:344593).
- Fixed exception during legend rendering (TFS:344722).
- Fixed legend scrollbar visibilty issues (TFS:344782).
- Fixed incorrect legend toggling when legend has a scrollbar (TFS:344814).
- Fixed problem with showing axis grid lines during animation (TFS:345076).
- Add support of mouse wheel for legend scrolling (TFS:345292).
- Size of legend is limited to provide a space for plot (TFS:345544).

## C1.WPF.Input

### Bug Fixes:

- [C1MultiSelect][C1TagEditor] System.IndexOutOfRangeException occurred when deleting all text and press up key from keyboard. (TFS-345583)
- [C1MultiSelect][C1TagEditor] PlaceHolder Text is shown when click on DisplayArea that is set "IsEditable=False" after selecting items in Tag DisplayMode. (TFS-327017)
- [C1MultiSelect][C1TagEditor] Item text in DisplayArea are selected when click on DisplayArea even setting IsEditable=False (TFS-327027)
- [C1MultiSelect][C1TagEditor] Unlike UWP, Cursor is not properly shown in Text DisplayMode when click on the DisplayArea (TFS-326900)
- [C1MultiSelect] Text Of Tag cannot be able to deleted and automatically replaced with other word in Tag when delete the text in Tag by using Backspace key in "Append/SuggestAppend" AutoCompleteMode. (TFS-323932)

## C1.WPF.RichTextBox

### Bug fixes:

- [C1RichTextBox] TextChanged event firing incorrectly. (TFS-344946)
- [C1RichTextBox] Scrolling RichTextBox, few lines at bottom appear/disappear incorrectly. (TFS-345417)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Find and Replace function does not scroll.(TFS-343214)

## C1.WPF.Sparkline

### Bug fixes

- Sparkline binding get lost when it is used in CellTemplate of the C1FlexGrid control. (TFS-345284)

# Release version 4.0.20183.603 - 09/21/2018

## C1.WPF.DataGrid

### Bug fixes

- 'System.NullReferenceException' in C1.WPF.DataGrid.4.dll while Printing of DataGrid with 5000 rows by using Print(). (TFS 342993)

## C1.WPF.Document

### Bug fixes:

- Text displaying incorrectly after export to PDF. (TFS:342881)

## C1.WPF.FlexChart

### Bug fixes

- Histogram series is not rendered when binding with null value contained data (TFS:332595)

### Improvements

- Improve the performance when loading large data and custom palette is used (TFS:261629)
- Added additional information in the default Tooltips (TFS:153475)
- Added chart animation, the basic animation options is controlled by AnimationSettings
  property. To enable animation just set chart.AnimationSettings = AnimationSettings.All,
  use AnimationLoad and AmimationUpdate properties for advanced settings.
- Add vertical scrolling to legend (FlexChartBase.LegendScrollBars and
  FlexChartBase.LegendScrollBarStyle properties).

## C1.WPF.FlexGrid

### Bug fixes

- RowDetailsVisibilityMode is not work correctly at RunTimes. (TFS-341237)

## C1.WPF.Input

### Bug Fixes:

- [C1MultiSelect][C1TagEditor] Extra separator value is added after the last selected item when setting more than one character or string value to the separator value. (TFS-313805)
- [C1MultiSelect] Selected Items are automatically unchecked when click multiple times on the MultiSelect DisplayArea. (TFS-326937)
- [C1MultiSelect][C1TagEditor] Do not allow set seperator is empty string. (TFS-342455)
- [C1MultiSelect] Content of SelectedItem is not correctly showed in C1MultiSelect display area when adding item to C1MultiSelect using Collection Editor at Design Time. (TFS-314141)

## C1.WPF.RichTextBox

### Bug fixes:

- Inserting an image in C1RichTextBox at run time, shows the resizer of image at incorrect position. (TFS-343147)

# Release version 4.0.20183.601 - 09/11/2018

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] NullReferenceException occurs on tapping multiple times on empty dock control area after all dock tab items are floated/slided/closed. (TFS-341258)
- [C1DockControl] Exception thrown in docking-floating C1DockTabItems. (TFS-341622)

## C1.WPF.Document

### Bug fixes:

- Last row of the detail section is not exported to excel format correctly when there are blank fields in the detail section. (TFS:341531)
- PDF files with semitransparent text can be rendered incorrectly in some cases. (TFS:318022)

## C1.WPF.ExpressionEditor

### Bug fixes

- [C1ExpressionEditor] "ButtonForeground" color is not worked in "Quotes" buttons on Operator button bar of ExpressionEditorPanel. (TFS-341873)

## C1.WPF.FlexGrid

### Bug fixes

- [FlexGrid] Horizontal and Vertical Scrollbar are not shown when Flexgrid is enclosed in a StackPanel.(TFS-341231)

## C1.WPF.Input

### Bug Fixes:

- [C1MultiSelect] Item is still shown in header part of C1MultiSelect when using remove() method. (TFS-310269)
- [C1MultiSelect][C1CheckList] "UnSelectAll" text is shown instead of "SelectAll" text in C1MultiSelect when no data is binding and ShowSelectAll = "True" at Design Time/RunTime (TFS-311407)

### Improvements

- [C1MultiSelect] Enhancement: Request to add feature for limiting the maximum number of checked items. (TFS-318496)

## C1.WPF.Maps

### Improvements

- [C1Maps] Request to provide a way to rotate the C1Maps. (TFS 203133)

## C1.WPF.RichTextBox

### Bug fixes:

- Show borders for bottom/top cells of C1Table when table splits into multiple pages.(TFS-341961)

## C1.WPF.Schedule

### Bug Fixes:

- Appointment set for the last time slot gets extended to the next day. (Tfs 341064).

# Release version 4.0.20183.600 - 08/28/2018

## C1.WPF

### Bug fixes

- [C1TabControl] The left corner of tab header not rendered at correct location. (TFS-333662)
- [C1Combobox] Applying theme removes all columns except DisplayMemberPath column, in Multi-column Combobox. (TFS-334371)
- [C1Menu] Clicking Menu-SubMenus quickly, sometimes the menu closes and reopens immediately. (TFS-337306)

## C1.WPF.DataGrid

### Bug fixes

- Text in Row Headers are ignored while using GetPageImage() method of C1DataGrid. (TFS 131144)
- Filter Dialog does not close automatically when opening the filter dialog and resizing the DataGrid's column header. (TFS 320765)
- Setting style for a column using LoadedCellPresenter applies the same style to another column on sort. (TFS-334765)
- MouseOverBrush not applied properly on scroll (TFS 337778)

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Request to add ShowPreview property to C1DockSplitter. (TFS-327678)
- [C1DockControl] Save/Load layout not working properly. (TFS-327766)
- [C1DockControl] The left corner of tab header not rendered at correct location. (TFS-333662)

## C1.WPF.ExpressionEditor

### Bug fixes

- [C1ExpressionEditor] Tooltips does not disappeared immediately although deleting all text in ExpresionTextBox. (TFS-326895)
- [ExpressionEditor] Function in Categories Selection's Items List cannot be chosen by pressing "Enter" key. (TFS-327546)
- [ExpressionEditor][Sample] "Log 10" Intelligence box and tooltip is shown when apply filtering in "FlexChart Filter" Page of ExpressionEditor Sample. (TFS-327539)
- [ExpressionEditor] Categories Selection's Item List of ExpressionEditor Panel is not refresh immediately when remove the function of Categories Selection's Item List. (TFS-327556)

## C1.WPF.FlexGrid

### Improvements

- Added SortAscendingIconTemplate/SortDescendingIconTemplate to present the sort icon when the column is sorted.
- Added ActiveFilterIconTemplate/InactiveFilterIconTemplate to present the filter icon.
- Added new GroupHeaderConverter class. You can use this converter to customize default formatting.

## C1.WPF.FlexViewer

### Improvements

- Added C1FlexViewerPane.NavigateToOutlineNode method that allows to navigate to a specific outline node from code. (TFS:342529)

## C1.WPF.RichTextBox

### Bug fixes:

- Setting MaxWidth for table cell does not work.(TFS-327552)
- Incorrect Font size for suggestion when C1RichTextBox contains multiple sized JP text.(TFS-338430)
- [C1RichTextBox] Incorrect Font size for suggestion when C1RichTextBox when zoom value is changed.(TFS-339376)

## C1.WPF.Schedule

### Improvements:

- Added new appointment availability status "Working Elsewhere".

## C1.WPF.Toolbar

### Bug Fixes

- [C1ToolbarTabControl] The left corner of tab header not rendered at correct location. (TFS-333662)
- [C1SimplifiedRibbon] Implementation of new control Simplified Ribbon. (TFS-333769)

## C1.WPF.Word

### Bug fixes

- Exported text styles are difference when saving the GraphicsPage content into .docx and .rtf files. (TFS:357121)
- Exported pages number and format are different when saving the contents into .docx and .rtf files. (TFS:357135)

### Improvements

- Support TOC objects (added RtfSdtContent, RtfTocField and RtfPageRefField calsses).

# Release version 4.0.20182.599 - 08/31/2018

## C1.WPF

### Bug fixes

- [C1Combobox] Performance issue in C1Combobox. (TFS-336741)

## C1.WPF.Schedule

### Bug Fixes:

- Appointment set for the last time slot gets extended to the next day. (Tfs 341064).

# Release version 4.0.20182.597 - 07/30/2018

## C1.WPF

### Bug fixes

- [C1TileListBox] Items do not wrap correctly when the maximum height/width of the control is reached. (TFS-335793)

## C1.WPF.FlexGrid

### Bug fixes

- [FlexGrid] Row/Column still can be resized even setting of "e.Cancel = true" in ResizingRow/ResizingColumn event. (TFS-256534)
- [FlexGrid] Row/Column still can be resized even setting of "e.Cancel = true" in ResizingRow/ResizingColumn event. (TFS-256534)

# Release version 4.0.20182.592 - 06/25/2018

## C1.WPF.Document

### Bug fixes:

- Certain PDF files can not be exported to HTML. (TFS:328491)
- Certain PDF files can not be loaded by C1PdfDocumentSource. (TFS:250109)

## C1.WPF.Input

### Bug Fixes:

- [C1MultiSelect][C1TagEditor] Selected Item can be removed by backspace in DisplayMode=Tag when setting IsEditable=false at Design Time.(TFS-310087)
- [C1TagEditor] Tag are wrapped in Display Area although TagWrapping is unckecked in Tag DisplayMode.(TFS-324462)

# Release version 4.0.20182.591 - 06/19/2018

## C1.WPF.FlexChart

### Bug fixes

- "NullReferenceException" is thrown in designer when adding MACD indicator series (MACD and MACD Histogram) (TFS:291258).
- ArgumentException is thrown by re-sizing window if an item is selected in TreeMap Chart (TFS:267538).
- Clicking on Legend items of FlexPie does not getting selected the corresponding point in FlexPie (TFS:152465).
- LineMarker does not parses the Content string to replace keywords with corresponding values (TFS:271136).
- Fixed incorrect property spelling (TFS:328057).
- Lines cropped on stacked Y plot (TFS:308503).

## C1.WPF.Input

### Bug Fixes:

- [C1MultiSelect][C1TagEditor] Editing of Selected Item cannot be able to cancel by pressing "Esc" Key in DisplayArea.(TFS-323956)
- [C1MultiSelect] SelectedIndex is not shown correctly when SelectAll the MultiSelect Dropdown items.(TFS-309028)
- [C1MultiSelect] Unlike WinForm, KeyBoard Navigation of MultiSelect cannot properly work in "Single" Selection Mode. (TFS-323133)
- [C1TagEditor] No scrollbar is shown when the Text/Tag DisplayMode texts are exceed the display area although TapWrapping is checked.(TFS-308420)

## C1.WPF.PdfViewer

### Bug Fixes

- PageSeparation property set not work in C1PdfViewer. (TFS-256120)
- Black spot observed while loading a pdf in C1PdfViewer. (TFS-327010)

# Release version 4.0.20182.590 - 06/07/2018

## C1.WPF

### Bug fixes

- [C1TreeView] C1TreeView does not display after applying C1Theme. (TFS-323962)
- [C1TreeView] C1TreeView cannot be expanded / collapsed by using keyboard when it has been focused by tabulation. (TFS-15883)
- [C1TreeView] ArgumentOutOfRangeException occurs when data item is removed if C1TreeView contains disabled items. (TFS-108711)
- [C1TreeView] ArgumentOutofRangeException occurs when item is removed from the underlying data source if both parent and child nodes are selected. (TFS-106777)
- [C1RadialMenu] The C1RadialMenu control works as evaluation version under valid license.(TFS-325932)

## C1.WPF.BarCode

### Bug fixes

- 'System.NullReferenceException' occurred in C1.WPF.BarCode.4.dll when "Code25intlv" CodeType is set at Design Time.(TFS-324724)

## C1.WPF.DataGrid

### Bug fixes

- Long text in the merged header gets trimmed even when there is enough space to accommodate the same. (TFS 323945)
- Merged cells text getting trimmed when a sub-column is slided. (TFS 290774)

## C1.WPF.Document

### Improvements:

- PDF files containing dashed lines can be rendered incorrectly. (TFS:327643)
- Added support (PDF view) of CFF type fonts (Type1).

## C1.WPF.ExpressionEditor

### Bug fixes

- Focus does not move to detailed functions panel when pressing "Tab" key while focus is in Function Categories panel. (TFS-311062)

### Improvements

- Added C1ExpressionEditor.InsertCommand property.

## C1.WPF.Extended

### Improvements

- [C1PropertyGrid] Make DisplayAttribute take effect on enum type value in C1PropertyGrid. (TFS-322535)

## C1.WPF.FlexGrid

### Bug fixes

- System.ArgumentOutOfRangeException when changing DataContext while checkbox cell has focus. (TFS-325516)

## C1.WPF.FlexGridFilter

### Bug Fixes

- Exception is thrown in PresentationFramework.dll when clicking the Filter button of the FlexSheet Product Sample. (TFS-323096)
- Filtering features do not work correctly in ExcelBook sample. (TFS-325490)

## C1.WPF.Input

### Breaking changes:

- [C1MultiSelect][C1CheckList] Changed SelectedItems property type form IEmunable to IList<object>/IList in WPF/UWP.
  SelectedItems Property as readonly, use SelectedItems.Add method instread of set SelectedItems value.

### Bug Fixes:

- [C1MultiSelect][C1TagEditor] Selected Item Tag is not properly shown and clipped in DisplayArea when SelectionMode is set "Tag" at MultiSelect's original width and height.(TFS-322963)
- [C1MultiSelect][C1CheckList] KeyNavigation[Up/Down key] is not correctly worked while selecting items.(TFS-323191)
- [C1MultiSelect] System.NullReferenceException is thrown when entering text after deleting selected item in DisplayArea.(TFS-323970)
- [C1MultiSelect] System.OutOfMemoryException is thrown when all text of Tag in Display Area are deleted at "Suggest" Autocomplete Mode. (TFS-323672)
- [C1MultiSelect] Request to add feature for checking/unchecking items from code.(TFS-318492)
- [C1MultiSelect] Unlike previous build, Selected items are not shown in the TextBox of PropertyGrid. (TFS-324168)
- [C1MultiSelect] Cursor move to the left most position of DisplayArea after deleting one item using Backspace in "Text" DisplayMode.(TFS-323980)

# Release version 4.0.20182.589 - 05/21/2018

## C1.WPF

### Bug fixes

- [C1ComboBox] Applying grouping to C1combobox shows multiple issues.(TFS-305986)
- [C1DragDropManager] Exception throws when trying to drag C1TreeViewItem out. (TFS-304854)

### Improvements

- [C1TreeView] Add support for external Drag&Drop using and firing standard Drag&Drop events.
- [C1Menu] Add InputGestureText property to C1MenuItem.

## C1.WPF.BarCode

### Improvements

- Added new bar code types: MicroQRCode, ITF14, Code11, SSCC18, Telepen, Pharmacode, PZN, HIBCCode128, HIBCCode39, ISBN, ISSN, ISMN, Iata25, Bc412, Plessey, IntelligentMailPackage
- Added new options: MicroQRCodeOption

## C1.WPF.DataGrid

### Bug fixes

- Deleting records from DataSource in grouped DataGrid throws exception. (TFS 321552)
- Column header for a grouped grid can be resized by dragging to a 0 width and then cannot be adjusted. (TFS-306204)

## C1.WPF.DateTime

### Bug Fixes

- Trying to select text in C1DatePicker through mouse drag, does not work sometimes. (Tfs 313400).

### Improvements:

- Add DisplayMode to C1DatePicker that is used to get or set a value that indicates whether the calendar displays a month, year, or decade. (Tfs 315469).

## C1.WPF.ExpressionEditor

### Breaking changes

- Added new method AddFunction into the IExpressionLexer interface.

### Improvements

- Added the AddFunction method to C1ExpressionEditor class. This method adds a custom function to engine of C1ExpressionEditor. (TFS-309412)
- Added C1ExpressionEditorPanel.Categories property to customizing categories of the expression items. (TFS-305001)

## C1.WPF.FlexChart

### Bug fixes

- Request to change the Description for TreeMap in the 'DrillDown' sample (TFS-312130)
- FlexGrid axis minor tickmarks are now correctly based on the Axis.MinorTickMarks setting instead of Axis.MajorTickMarks setting.
- Lines cropped on stacked Y plot (TFS-308503)
- DateTime values on AxisX are displayed as numbers when the ItemsSource for the 0th series is empty (TFS-320784)
- AxisX Labels are incorrect when binding with series.BindingX to string data type (TFS-315802)
- No Data point is plotted when setting invalid BindingX value (TFS-323122)
- TreeMap's data labels now support wrapping and trimming according to DataLabel.ContentOptions. The default value for content options is WordWrap. (TFS:320004)
- Chart renders incorrectly when adding AxisY Scrollbar on a chart with multiple plot areas (TFS:322533)
- NullReference exception thrown when a FlexChart with Direct2D rendering is hosted in a WinForms ElementHost control (TFS:324512)
- Added assembly info for C1.WPF.FlexChart.Extended.dll (TFS:324002).

### Improvements

- Added axis TimeUnits enum and Axis.TimeUnit property. Used in combination with Axis.MajorUnit, the Axis.TimeUnit property \
  allows expression of MajorUnit in terms of calendar periods such as Week, Month, Year instead of only days.
- Added Axis.LabelMin and Axis.LabelMax boolean properties which when true forces the labeling of axis extremes.
- Added axis grouping expand/collapse through the addition of the Axis.GroupVisibilityLevel property. The absolute value Axis.GroupVisibilityLevel \
  specifies the most expanded level of the groups moving away from the anchor. Positive values specify the anchor at the highest level, negative \
  values specify the anchor at level 1.
- Added public class DateTimeGroupProvider. This built-in class manages typical axis groupings for various dated axis durations.
- Added new C1.WPF.FlexChart.Extended.dll that includes various extended charting features.
- Added new Heatmap series class that allows to create different heatmap visualizations(C1.WPF.FlexChart.Extended.dll).
- Improved performance of area charts with large data in DirectX rendering mode.
- Added new FrequencyPolygon mode to Histogram series class that allows to show the frequency of original data as a polygon.
- Added new Ichimoku cloud overlay to FinancialChart
- Added new NormalCurve object to Histogram series class that allows to show a gaussian curve together with the histogram chart
- Improved LineMarker feature to allow moving/dragging after the position properties are specified

## C1.WPF.FlexGridFilter

### Breaking Changes

- Add C1.WPF adn C1.WPF.DateTimeEditor for references.

### Bug Fixes

- Setting column format does not changes filter format.(TFS-319425)

### Improvements

- Use C1DatePicker for filter a DateTime type value.

## C1.WPF.GanttView

### Bug fixes

- Deadline marker cannot be dragged when long bar text covers over deadline marker.(TFS_316138)

## C1.WPF.Input

### Breaking changes:

- [C1MultiSelect] Change inherit from C1ItemsControl to ItemsControl.
- [C1CheckList] Change inherit from C1ListBox to ListBox.
- [C1MultiSelect][C1CheckList] Unity SelectionMode property for C1MultiSelect and C1CheckList.
  For WPF as System.Windows.Controls.SelectionMode.
  For UWP as Windows.UI.Xaml.Controls.SelectionMode.

### Bug Fixes:

- [C1CheckList] Exceptions are occurred when setting "IsSelected = True" to CheckListItems Properties using ItemCollectionEditors at DesignTime.(TFS-316408)
- [C1MultiSelect] PlaceHolder text is shown in DisplayArea when changing DisplayMode from "Text" to "Tag".(TFS-315934)
- [C1MultiSelect] Selected Item contains space at first place is disappeared in Display Area and change to Uncheck state at dropdown when Focus is out of the Display Area .(TFS-314718)
- [C1CheckList] Selection highlight color didn't shown on keyboard navigation in C1CheckList. (TFS-310870)
- [C1MultiSelect] Selection highlight color is not shown in C1MultiSelect dropdown for keyboard navigation.(TFS-306449)
- [C1TagEditor] Deleted Items are shown again in TagEditor when adding new Items in "Text" DisplayMode at RunTime.(TFS-316033)
- [C1MultiSelect] Dropdown items can not selected by "Enter" or "Spacebar" keys from keyboard in C1MultiSelect controls.(TFS-306448)
- [C1MultiSelect] Selected items and selection highlight color are not showed in display area and dropdown list although item is checked in dropdown part by using "Spacebar" key from keyboard.(TFS-315061)
- [C1MultiSelect] Empty space for scrollbar is reserved when setting SelectedBackground and MouseOverBrush properties.(TFS-307628)
- [C1MultiSelect] Empty space for scrollbar is reserved when setting HorizontalContentAlignment to Right.(TFS-307657)

### Improvements

- [C1MultiSelect][C1CheckList] Support set C1MultiSelect/C1CheckList's ItemsSource as grouped data source will show grouped items.
- [C1MultiSelect][C1CheckList] Add GroupStyle,IsGrouping and GroupStyleSelector properties for group feature.
- [C1MultiSelect][C1CheckList][C1TagEditor] Set default Width and Height of Input controls when drag and drop control to the form toolbox.(TFS-314538)
- [C1MultiSelect] Add AutoCompleteMode for C1MultiSelect, in AutoCompleteMode enums there are four values:
  None - Disables the automatic completion feature.
  Append - Appends the remainder of the most likely candidate string to the existing characters, highlighting the appended characters.
  Suggest - Displays the auxiliary drop-down list associated with the edit control. This drop-down is populated with one or more suggested completion strings.
  SuggestAppend - Applies both Append and Suggest options.
  If set AutoCompleteMode or AutoSuggestMode as None will disable current filter feature as behaviour as WF ComboBox.
  AutoCompleteMode default value as Suggest.
- [C1CheckList] Add Keyboard support for C1CheckList. C1CheckList keyboard behavior as follow:
  Type Up,Down,PageUp,PageDown,Home and End key if SelectionMode as Single and Expend navigation to specific item and selected it will raise SelectionChanged event.
  Type pre key with Ctrl with same selection mode, item show navigation highlting but not selected item until type Enter.
  Type pre key when SelectionMode as Multiple item show navigation highlting but not selected item until type Enter.
  Navigation highling color used as MouseOverBrush.
- [C1MultiSelect] Add Keyboard support for C1MultiSelect when suggest list popup.
  Type Up and Down will navigate to next or prevoius item.
  Type Enter will selected item form suggest list.
- [C1Tag] Add ContentUpdating event customer can cancel tag content updating and return to EditMode.
- [C1TagEditor] Add TagUpdating event customer can cancel current updating tag and return this specific tag to EditMode.
- [C1TagEditor] Enter key can add last input whatever tag mode and text mode.

## C1.WPF.Theming

### Bug Fixes:

- Applying theme to window, Datagrid selection, filter gets lost when scrolled/collapse expand operation is performed.(TFS-311287)

# Release version 4.0.20181.588 - 04/18/2018

## C1.WPF.DataGrid

### Bug fixes

- Clicking on empty space in Filter Dialog box changes sort of the column. (TFS 316140)

### Improvements

- Add Ctrl+X function in C1DataGrid.

## C1.WPF.DataGrid.Filters

### Bug fixes:

- When using C1FullTextSearchBehavior, NullReferenceException is thrown when property change is notified from the datasource. (TFS-316998)

## C1.WPF.Document

### Bug fixes:

- Certain PDF files rendered incorrectly. (TFS:327010)

## C1.WPF.ExpressionEditor

### Bug fixes

- Tooltips of Expression was not shown when UnderlineError and SyntaxHighlighting is unchecked. (TFS-311388)

## C1.WPF.FlexChart

### Bug fixes

- Request to change the Description for TreeMap in the 'DrillDown' sample (TFS-312130)

## C1.WPF.FlexGrid

### Bug fixes

- With SelectionMode = ListBox, resizing a non-selected row resizes selected rows too. (TFS-315795)

## C1.WPF.RichTextBox

### Bug fixes:

- Typing hyperlink changes fontfamily to default family.(TFS-316893)

## C1.WPF.Word

### Bug fixes

- Unable to load Docx file into C1Word (invalid). (TFS:295050)
- Alignment of text and image in the MS document are missing when read/write in another C1WordDocument. (TFS:285688)
- Alignment and FontStyle of RTFParagraph are affected to the adjacent RTFString with different behavior in (.docx) and (.rtf) files. (TFS:276813)
- ForeColor of RTFParagraph are affected to the adjacent RtfDateField when save the document with (.rtf) format. (TFS:276823)
- Support text format Save (only text string in paragraphs) method.

# Release version 4.0.20181.587 - 03/09/2018

## C1.WPF.DataGrid

### Bug fixes

- FreezingSeparator does not work fine with hidden columns. (TFS 311337)

## C1.WPF.ExpressionEditor

### Bug fixes

- Unlike WF and UWP ExpressionEditors, Backgroundcolor does not change to Grey color when "IsEnabled" (TFS-311053)

## C1.WPF.FlexChart

### Bug fixes

- No data are not shown in StockChart sample and System.Net.WebException thrown (TFS-307167)

# Release version 4.0.20181.586 - 03/05/2018

## C1.WPF.ExpressionEditor

### Bug fixes

- Tooltips and Function Descriptions was not Localized when changing any CultureInfo at runtime. (TFS-294622)

### Improvements

- Added toolbar button to enter English quotes.

## C1.WPF.FlexChart

### Bug fixes

- XAML designer shows InvalidOperationException for Histogram and RangedHistogram charts (TFS-293774)

### Improvements

- Add new features to stock analysis sample, eg: price warning, more settings for indicators and overlays.

## C1.WPF.FlexGrid

### Bug fixes

- ColumnFooters not getting merged. (TFS-310887)

## C1.WPF.RichTextBox

### Bug fixes:

- The cursor in C1RichTextBox is misaligned when its TextOptions.TextFormattingMode property is set to "Display".(TFS-308913)

## C1.WPF.Word

### Bug fixes

- Unable to properly read outline set in MS Word. (TFS:299297)

# Release version 4.0.20181.585 - 02/13/2018

## C1.WPF.DataGrid

### Bug fixes

- Scrolling C1DataGrid using PageDown does not work correctly sometimes. (TFS 308092)

## C1.WPF.ExpressionEditor

### Bug fixes

- Showing tooltips is overlapped upon Intelligence box when it only ruuning at right side of the window screen. (TFS-294061)

## C1.WPF.FlexSheet

### Bug fixes

- The cell with number format displays incorrectly when load a Excel. (TFS-307243)

## C1.WPF.FlexViewer

### Other changes

- Supported various page scaling modes during printing. (TFS:301482)

## C1.WPF.Word

### Bug fixes

- Default font size of 'RtfParagraph' and 'RtfString' is getting smaller if using c1WordDocument.Clear() method and saving the document with (.docx) format. (TFS:305133)
- Font size is not retained in heading style text when loading and saving as .docx file using C1WordDocument. (TFS:305198)

# Release version 4.0.20181.584 - 02/05/2018

## C1.WPF.Document

### Bug fixes:

- Now C1DocumentSource.ShowPrintUIAsync() method uses C1DocumentSource.DefaultPrintOptions. (TFS:301482)

## C1.WPF.ExpressionEditor

### Bug fixes

- Request to provide Alphabetical order for the items of the categories selection. (TFS-292950)
- Items of the functions are shown with irrelevant order. (TFS-292950)

## C1.WPF.FlexChart

### Bug fixes

- DataLabels are not displayed although setting properties of Series.DataLabel (TFS-305752)
- Scrolling via AxisScrollbar causes memory leak if the data objects are implementing INotifyPropertyChanged (TFS-305892)
- System.Exception thrown in C1FlexChart dll internally (TFS-306026)
- Incorrect description of GroupStyle property is displayed in IntelliSense (TFS-306298)
- GroupStyle properties for numeric axis labels grouped by GroupProvider are not affected (TFS-306257)
- Lines cropped on stacked Y plot (TFS-308503)

### Improvements

- [C1FlexChart] Improved the performance of Histogram charts with large data source.
- [C1FlexChart] Improved DirectX rendering at high DPI screens.

## C1.WPF.FlexReport

### Bug fixes:

- Added property to C1FlexReport.BehaviorOptions (TFS: 295679)
  bool FireOnFormatForEachInstanceOfRepeatedGroupSection { get; set; }
  Gets or sets a value indicating whether the OnFormat script is fired
  for each instance of a repeated group section, or just once for the
  first instance.Applies only to groups with Repeat property set to true.

## C1.WPF.FlexSheet

### Bug fixes

- "System.NullReferenceException" is thrown when clicking the Filter button of the FlexSheet Product Sample. (TFS-305709)

## C1.WPF.Pdf

### Bug fixes

- When saving a PDF document with FontType specified as Standard or TrueType causes unexpected rendering. (TFS:153782)
- When C1TreeView is outputted to C1PdfViewer, a garbled character appears. (TFS:306818)

## C1.WPF.RichTextBox

### Bug fixes:

- Position of the cursor is moved one line upward without going to the beginning when bullet in the RichTextBox is deleted with backspace.(TFS-305469)

## C1.WPF.Theming

### Bug Fixes:

- corrected MS ComboBox and ScrollBar styles in Office2013, Office2016, Cosmopolitan themes.(TFS-305653)

# Release version 4.0.20181.583 - 01/22/2018

## C1.WPF.Document

### Improvements:

- Added C1DocumentSource.DefaultPrintOptions property allows to define default print options.
  Set C1DocumentSource.DefaultPrintOptions.PageScaling to FitToPrintableArea if document's margins
  are too small and less than printable margins of physical printer. (TFS:301482)

## C1.WPF.GanttView

### Bug fixes

- ReadOnly GanttView is not in ReadOnly mode after loading new xml file.(TFS-294214)

# Release version 4.0.20181.582 - 01/12/2018

## C1.WPF.Chart

### Bug fixes

- Lines between symbols of a LineSymbols chart are not rendered when zoomed in by changing the axis Scale values.(TFS-301507)

## C1.WPF.DataGrid

### Bug fixes

- Incorrect selection in C1DataGrid. (TFS 296656)

### Improvements

- Add MergedRanges property. It is used to get or set merged ranges in C1DataGrid by users.

## C1.WPF.DataGrid.Filters

### Bug fixes:

- Cell value is not updated when the binding source is updated and C1FullTextSearchBehavior is applied to the grid. (TFS-293760)

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] The screen position of floating DockTabControl is not loaded. (TFS-301484)

## C1.WPF.Excel

### Bug fixes

- Error "We found a problem with ..." is occurred in result excel (.xlsx) file when
  loading and saving an excel file that contains TabColor and formula. (TFS:303440)
- Back Color is not applied on the grid when load the excel file. Regression for
  TFS:200400, notice by Alexey Smorkalov. (TFS:301789)
- Request to add feature to select multiple sheets while saving the excel through
  C1XLBook. (TFS:293060)
- Hyperlinks in resultant excel file do not work in some special condition. (TFS:285089)
- C1Excel errors with .xlsm file. (TFS:291985)
- Invalid Excel OpenXml file (*.xlsx) exception is thrown on loading C1XLBook with xlsx
  created in LibreOffice. (TFS:295413)
- Request to provide information on cell styles in excel file when FlexGrid is saved
  using SaveExcel method. (TFS:289978)
- Text written by RTF format is not shown in exported excel file. (TFS:274741)
- Error at export the report with RTF format to excel file (.xls) (TFS:274980)
- A message box ‘We found a problem with some content in ...’ is shown when opening the result xlsx file. (TFS:305960)
- Backcolor of cell is applied as font color of cell in result .xls/.xlsx file. (TFS:306055)

### Improvements

- Added SelectedIndexes property for the XLSheet class (the index array of the sheets
  that is selected).

## C1.WPF.ExpressionEditor

### Breaking changes

- Added new method AddAlias into the IEngine interface.

### Bug fixes

- Blank tooltip is shown when hovering the mouse on ExpressionTextBox. (TFS-292325)

### Improvements

- Added support of field aliases (System.ComponentModel.DisplayNameAttribute and System.ComponentModel.DataAnnotations.DisplayAttribute).
- Added support of BrowsableAttribute for fields.
- Aggregate functions with one argument works for all items from DataSource.
- Added alphabetical order for the items of the categories selection.

## C1.WPF.FlexChart

### Improvements

- [C1TreeMap] Added new NodeRendering, NodeRendered events to TreeMap
- [C1FlexChart] Added new SortDescending property to RangedHistogram
- [C1FlexPie,C1Sunburst] Data labels can be hidden or trimmed if their content is outside pie segment. Added new PieDataLabels.Overlapping property and corresponding enum PieLabelOverlapping.
- [C1FlexChart] Staggered axis labels. New Axis.StaggeredLines property.
- [C1FlexChart] Trim or wrap the overlapping axis labels. New members of OverlappingLabels enum: Trim and WordWrap.
- [C1FlexChart] Rotated data labels. New DataLabel.Angle property.
- [C1FlexChart] Series-specific data labels. New Series.DataLabel property.
- [C1FlexChart] Automatic positioning of data labels without overlapping. New 'Auto' member of LabelPosition enum.
- [C1FlexChart] Trim or wrap data label content. New DataLabel's properties: MaxWidth, MaxLines, ContentOptions and corresponding ContentOptions enum.
- [C1FlexChart] Control appearance of overlapped data labels. New DataLabel's properties Overlapping and OverlappingOptions and corresponding enums LabelOverlapping and LabelOverlappingOptions.

## C1.WPF.FlexGridFilter

### Improvements

- Need to set DatePicker at place of TextBox in C1FlexGrid's filter. (TFS 302476)

## C1.WPF.GanttView

### Bug fixes

- TaskInfoDialog can't create StartOnly and FinishOnly task, it's related to TFS-224843.

## C1.WPF.Input

### Improvements

- [C1MultiSelect] Beta version.

## C1.WPF.Schedule

### Breaking changes:

- DuskBlue, DuskGreen, MediaPlayer and Vista themes has been moved to the new C1.WPF.Schedule.Themes.Legacy.4 assembly.
  Corresponding properties of the C1SchedulerResources and C1CalendarResources classes have been marked as obsolete.
- Default appearacnce have been changed from Office 2007 to Office 2016 Colorful.

### Improvements:

- Added new embedded themes Office2010 Blue, Black, Silver.
- Added new embedded themes Office2016 Colorful, White, Black, DarkGray.
- Default appearance have been changed from Office 2007 to Office 2016 Colorful.

## C1.WPF.Word

### Bug fixes

- Unable to properly read outline set in MS Word (two part). (TFS:299297)
- (partly) RoundRectangleShape loosing rounded corner/text on saving to *.rtf/*/docx formats respectively. (TFS:303566)
- Bullet color is not retained when load the word document and save it as '.docx' using C1WordDocument. (TFS:303516)
- Extra space are added in heading style text when read and write in new C1WordDocument. (TFS:276701)
- 'KeyNotFoundException' is thrown when load and save the document contained image and bold style text. (TFS:303834)
- Font and Color of RtfParagraph added by AddParagraph () method are not affected in result (.docx) format. (TFS:303525)
- Unlike build 286, default font size of 'RtfParagraph' and 'RtfString' is getting smaller when saving the document with (.docx) format. (TFS:303502)
- Total page count number is not properly shown in exported .docx and .rtf files when loading the .docx file contained table. (TFS:302425)

# Release version 4.0.20173.581 - 12/19/2017

## C1.WPF

### Bug fixes

- [C1TileListBox] Need to implement ItemsPanelTemplate using C1TileListBoxPanel. (TFS-298281)

## C1.WPF.Chart

### Bug fixes

- Fixed the problem with axis title and rotated annotations for 3D charts.(TFS-290273)

## C1.WPF.DataGrid

### Bug fixes

- Selection is not working in C1DataGrid when multiple rows are added in row's header. (TFS 299763)

## C1.WPF.ExpressionEditor

### Bug fixes

- System.ArgumentOutOfRangeException thrown on entering "Instr(" in expression box. (TFS-301118)

## C1.WPF.GanttView

### Bug fixes

- Request to provide a consistent appearance in GanttView toolbar's menu icon.(TFS-288947)

## C1.WPF.RichTextBox

### Bug fixes:

- System.NotSupported Exception is thrown when a specific text is pasted in C1RichTextBox.(TFS-298034)

## C1.WPF.Word

### Bug fixes

- Unable to properly read outline set in MS Word. (TFS:299297)
- Text style in the original document is not retained when saving as .docx file in another document. (TFS:299372)
- Alignment of text and image in the MS document are missing when read/write in another C1WordDocument. (TFS:285688)
- Alignment and FontStyle of RTFParagraph are affected to the adjacent RTFString with different behavior in (.docx) and (.rtf) files. (TFS:276813)
- ForeColor of RTFParagraph are affected to the adjacent RtfDateField when save the document with (.rtf) format. (TFS:276823)
- FlexReport exported to docx generates the entire document in bold and italics. (TFS:296298)
- Black rectangle is shown when loading the rtf file contained table and saving as '.rtf' file. (TFS:301005)
- Bullet are not retained when load the word document and save it as '.docx' using C1WordDocument. (TFS:300997)

# Release version 4.0.20173.579 - 11/20/2017

## C1.WPF

### Bug fixes

- [C1ComboBox] Unlike previous build, when 'Condition' property is set to 'Contains', incorrect behavior is observed. (TFS-41613)

## C1.WPF.FlexChart

### Bug fixes

- Fixed problem with memory leak when Direct2D mode is used via RDP (TFS-281388)
- AxisScrollbar's are not rendered at correct positions if their Visibility is changed at run-time (TFS-298057)
- The 'Binding' property is mandatory for the 'Histogram' series to be plotted, even though it has no effect (TFS-295111)
- Text doesn't get displayed on Polygon Annotation with Attachment set to Relative (TFS-292702)

## C1.WPF.FlexSheet

### Bug fixes

- "System.InvalidCastException" occurred in C1.WPF.FlexSheet.4.dll while grouping is applied with CollectionViewSource. (TFS-295357)

## C1.WPF.GanttView

### Bug fixes

- Some menus icons on the toolbar are cut off when setting of custom font size to C1GanttView.(TFS-295095)

## C1.WPF.MediaPlayer

### Bug Fixes

- Some operations do not work correctly in C1MediaPlayer.(TFS-294607)

## C1.WPF.Schedule

### Improvements:

- Improved layout of short appointments in views with small visual interval scale. (Tfs 295043)

## C1.WPF.Word

### Bug fixes

- Column layout in the word document is not retained when read and write it in another document. (TFS:270490)
- (partly) Bullet are not retained when load the word document and save it in another document. (TFS:269921)
- Center alignment of text are slightly missing in rtf file when read the word document and write in C1WordDocument. (TFS:271096)
- Loading and saving a file with newline removes newline characters. (TFS:281258)
- Unable to load Docx file into C1Word (invalid). (TFS:295050)

# Release version 4.0.20173.578 - 11/02/2017

## C1.WPF.FlexGrid

### Bug fixes

- "System.NullReferenceException" occurred in C1.WPF.FlexGrid.4.dll when selecting Color dropdown of new row. (TFS-294986)

## C1.WPF.GanttView

### Bug fixes

- BarStyle of taskbars will be reset while selecting any task item in Task combobox after selecting "(Default)" item.(TFS-294975)
- BarText of default Milestone is not shown in BarStyle dialog.(TFS-294984)

# Release version 4.0.20173.577 - 10/30/2017

## C1.WPF.DataGrid

### Bug fixes

- Content of DataGridTextColumn column shifts to bottom at the time of editing. (TFS 293414)

## C1.WPF.FlexSheet

### Bug fixes

- Excel file loaded in C1FlexSheet is not displayed as expected. (TFS-291968)

## C1.WPF.GanttView

### Bug fixes

- "System.NullReferenceException" occurred in PresentationFramework.dll while setting of BarStyle of taskbar after deleting its task name.(TFS-294042)

## C1.WPF.Theming

### Bug Fixes:

- Office2013 and Office2016 themes throw "XamlParseException" exception for Expander control.(TFS-293736)

# Release version 4.0.20173.576 - 10/24/2017

## C1.WPF.Extended

### Bug fixes

- [C1ColorPicker] An exception occurs when a value is input from the context menu in the '#' field in the Advanced tab. (TFS-250055)

## C1.WPF.FlexChart

### Bug fixes

- "InvalidOperationException" with "Sequence contains no elements" message is thrown when setting 0 to Period of CCI and WilliamsR indicators (TFS-291254)
- DataLabel is not shown in exported svg image of TreeMap (TFS-291269)
- "IndexOutOfRangeException" is thrown when setting Period=1 and Scaling=Dynamic (TFS-291870)
- Datalabels in floating bars for Class A series are displayed the same as Class B series in 'FloatingBarChart' sample (TFS-291557)

## C1.WPF.GanttView

### Bug fixes

- Request to descrease "gap" distance between GanttView toolbar's menu icon.(TFS-288932)
- "Split Task" menu cannot be closed while hiding the ChartView.(TFS-276969)
- BarStyle cannot be reset while set of BarText/BarShape of Default task.(TFS-276601)
- Pressing Tab key does not update Start and End date values.(TFS-289994)
- BarStyle cannot be applied to new added task.(TFS-276644)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- C1FontColorTool is included in Tab navigation even if its IsTabStop property is set to false.(TFS-281414)

# Release version 4.0.20173.575 - 10/16/2017

## C1.WPF.BarCode

### Bug fixes

- C1BarCode's Save() method creates a black image.(TFS-291222)

## C1.WPF.FlexChart

### Bug fixes

- Legend text is rendered unparalleled to Legend icon in exported svg file of FlexChart (TFS-290331)
- 'NullReferenceException' is thrown when adding empty series, RangMode='ATR' and ChartType='Renko' / 'Kagi' (TFS-269448)

## C1.WPF.FlexViewer

### Bug fixes

- Highlighted selection and the current page number were sometimes not in sync. (TFS:290272)

## C1.WPF.GanttView

### Bug fixes

- "System.NullReferenceException" occurred in PresentationFramework.dll while choosing Group Type after clicking Order combobox.(TFS-290414)

## C1.WPF.ReportViewer

### Bug Fixes

- C1ReportViewer does not release memory even when GC is forced.(TFS-290715)

# Release version 4.0.20173.574 - 10/04/2017

## C1.WPF.DateTime

### Bug Fixes

- Date/Time format of of C1DateTimePicker and C1DatePicker is not reflected immediately when Culture is changed at run time. (Tfs 286459).

## C1.WPF.FlexChart

### Bug fixes

- AxisY labels and bars are overlapped in exported SVG image of FlexChart with 'Bar' chart type (TFS-277443)

## C1.WPF.FlexSheet

### Bug fixes

- Clipboard operation is not working properly in Bound Mode FlexSheet.(TFS-276656)

## C1.WPF.GanttView

### Bug fixes

- ContextMenu is shown in blank area of C1GanttView while setting of some themes and without selecting any task.(TFS-280220)

## C1.WPF.Olap

### Bug Fixes

- ComboBox item's can't be seen clearly in Custom Filter Dialog box while applying "Office2016Black" themes to Olap. (TFS-288705)
- Blank space is shown in OlapGrid after remove field in OlapGrid while the focus is set in Chart or Raw Data. (TFS-279871)

## C1.WPF.RichTextBox

### Bug fixes:

- A row and text of table cell that contains list will disapper after export and import from RTF. (TFS-278044)

# Release version 4.0.20173.573 - 09/25/2017

## C1.WPF.FlexChart

### Bug fixes

- [FlexChart] Build number for C1.WPF.FlexChart dll is incorrect.(TFS-288406)

# Release version 4.0.20173.572 - 09/22/2017

## C1.WPF

### Bug fixes

- [C1NumericBox] C1NumericBox with Format to "X" has incorrect cursor position. (TFS-285674)

### Improvements

- [C1Window] Add AddDefaultPopupToVisualTree method that should be called if you have problems with showing C1Window in your application.

## C1.WPF.DataGrid

### Bug fixes

- If HeaderBackground is set to Transparent then filter drop-down box has a black background. (TFS 281241)

## C1.WPF.ExpressionEditor

### Improvements

- First Release.

## C1.WPF.FlexChart

### Bug fixes

- 'NullReferenceException' is thrown in designer when adding secondary axis to series with CandleStick/HighLowOpenClose ChartType (TFS-280199)
- 'ArgumentException' is thrown when choosing 'False' in 'Uptrend' comboBox in 'Fibonacci Tool' (TFS-279616)
- For Logarithmic axes, setting Axis.Max does not restricts the axis scale to the 'Max' value (TFS-284566)
- Removed the advanced options in HistogramSeries (TFS-289099)

### Improvements

- [C1FlexChart] Implement Histogram / RangedDiagram chart types
- [C1FlexChart] Implement Step / StepArea / StepSymbols chart types
- [C1FlexChart] Use point index instead of series index as parameter of LabelRendered / LabelRendering events
- [C1FinancialChart] Added new chart type "PointAndFigure". The demo page for new chart type added to FinancialChartExplorer sample.
- [C1FlexChart] Added new FloatingBarChart samples.

## C1.WPF.FlexGrid

### Bug fixes

- System.NullReferenceException occurred in C1.WPF.FlexGrid.4.dll while binding using CellTemplate in FlexGrid. (TFS-284488)
- A1 cell is always shown instead of selected cell in Print/Preview/Selection action when Headings are in invisible state. (TFS-285306)

### Improvements

- Added MarqueeColor property to define custom marquee color.Note, you must set ShowMarquee = "True" then you can see it.

## C1.WPF.FlexSheet

### Bug fixes

- "Column and Direction" Column Headers of SortDialog are not localized to Japanese Strings in C1FlexSheet.(TFS-285061)
- Selection DataRange is always shown as reverse order when selecting some of the data to add sparkline.(TFS-285060)

## C1.WPF.GanttView

### Bug fixes

- Milestone is only shown as half of its mark while increasing its task bar height.(TFS-285155)

## C1.WPF.InputPanel

### Improvements

- Add 'TextWrapping' to C1InputTextBox.

## C1.WPF.Theming

### Bug Fixes:

- [ContextMenu] Context menu texts on scrollbar are not visible clearly while setting "Office2016Black" theme.(TFS-279550)
- [ContextMenu] ContextMenu item's symbols are not clearly visible while setting of "Office2016BLack" theme.(TFS-280203)
- [ContextMenu] Scrollbar context menu texts exceed to the blank area ahead while applying other themes except from Office2007 and Office2010 themes.(TFS-279595)
- [ContextMenu] ContextMenu item's icon and menu texts are getting very closely with each other while setting of Office2013/Office2016 themes.(TFS-280221)

## C1.WPF.Word

### Bug fixes

- C1WordDocument not able to load RTF File containing an Image (part 2 "1.rtf" file). (TFS:277877)

# Release version 4.0.20173.569 - 08/21/2017

## C1.WPF.FlexGrid

### Bug fixes

- Incorrect values are copied from a numeric column with specific format. (TFS-278161)
- Merging does not work correctly when there are less than 2 rows in the grid.(TFS-278963)

## C1.WPF.FlexSheet

### Bug fixes

- System.NullReferenceException is occurred while open Filter dropdown after save files by FlexSheet.(TFS-278743)
- Expand/Collapse can not work when grouping is applied in FlexSheet after exporting file.(TFS-278836)

### Improvements

- png images in SortDialog have been replaced by corresponding symbols from Segoe UI Symbol font or path.
- png images in ExcelFilterEditor have been replaced by corresponding symbols from Segoe UI Symbol font or path.
- Replaced "NewSheet.png" by Excel2016 style corresponding symbols form Segoe UI Symbol font.
- Replaced Expanded/Collapsed as corresponding symbols from Segoe UI Symbol font.

## C1.WPF.GanttView

### Bug fixes

- The linked task is disappeared when dragging the predecessor task to the half of its starting day in CustomColumn Sample.(TFS-267208)
- Separate taskbars cannot be dragged and merge into a whole after inserting a split on the task.(TFS-252484)

### Improvements

- png images in toolbar buttons have been replaced by corresponding symbols from Segoe UI Symbol font or path.
- png images in Print dialog's Header/Footer tab have been replaced by corresponding symbols from Segoe UI Symbol font or path.
- png images in ContextMenu have been replaced by corresponding symbols from Segoe UI Symbol font or path.
- png images for link arrow have been replaced by corresponding symbols from Segoe UI Symbol font.
- png images for expanded/collapsed have been replaced by corresponding symbols from Segoe UI Symbol font.
- png images for MoveUp/MoveDown in Resource,ChangeWorkingTime,GridColumns and ManagerChalendar dialog have been replaced by corresponding path.

## C1.WPF.InputPanel

### Bug fixes

- Number in page textbox is shown as '0' while setting of 'AutoCommit' as 'False' in bound InputPanel. (TFS-278744)

## C1.WPF.Olap

### Improvements:

- png images in toolbar buttons have been replaced by corresponding symbols from Segoe UI Symbol font or path.
- png images in Options dialog's Header/Footer tab have been replaced by corresponding symbols from Segoe UI Symbol font or path.
- png images in OlapPanle and ContextMenu have been replaced by corresponding symbols from Segoe UI Symbol font or path.

## C1.WPF.Schedule

### Improvements:

- png images in the IntervalAppointmentTemplate have been replaced by corresponding symbols from Segoe UI Symbol font.
- TextBlocks have been replaced by Labels in embedded dialogs. It improves readability in different themes.
- png images in toolbar buttons of the EditAppointmentControl have been replaced by corresponding symbols from Segoe UI Symbol font.
- ico images except "resources" replaced by png images as Outlook 2016 style.

## C1.WPF.Theming

### Bug Fixes:

- [BasicControls] Combobox item is cut off when setting "Office2007Blue/Office2007Silver" themes.(TFS-270110)
- [OLap] Filter text is not clearly visible while applying "Office2016Black" or "ExpressionDark" themes to C1Olap.(TFS-270493)

### Improvements

- Added default style for ToolBarTray.
- Added settings for C1GanttView.ToolbarBackColor property.
- Improved Office2016 themes as designer suggested.

# Release version 4.0.20172.571 - 09/05/2017

## C1.WPF

### Bug fixes

- [C1NumericBox] C1NumericBox with Format to "X" not showing Hexadecimal values correctly. (TFS-280651)
- [C1Window] C1Window memory leak - Parent window remains in memory. (TFS-279890)

## C1.WPF.FlexViewer

### Bug fixes

- Incremental search did not work correctly for large documents. (TFS:109133)
- Copying text to the Clipboard occasionally thrown an unhandled COMException.

### Improvements

- Added the LimitSearchToCurrentPage property indicating whether the text search should be limited to current page.
- Added the CurrentPageVisibleOnSearchToolbar property indicating if the "Current Page" button is visible on the Search toolbar.
- ZoomFactor property is now zooming from center of the control at runtime. (TFS:284517)

## C1.WPF.GanttView

### Bug fixes

- "Start" and "Finish" of Automatic task can be set in "Task Information" dialog.(TFS-280555)
- "Font" text is not localized to Japanese localization when setting of CurrentCulture and CurrentUICurture.(TFS-280622)
- System.Runtime.InteropServices.ExternalException occurred while all tasks are selected and then clicking "Zoom Selected Task" on toolbar.(TFS-281249)

## C1.WPF.Word

### Bug fixes

- Loading and saving a file with newline removes newline characters. (TFS:281258)
- C1Word not able to load file (*.docx and *.rtf) containing table. (TFS:279239)
- Request to provide information on changing fonts without adding new paragraph and adding markers with "AddParagraph". (TFS:274137)
- RTFLineBreak above the RTFTable is effected to the first row of table when save the document with docx format. (TFS:272451)
- Request to provide information on changing fonts without adding new paragraph and adding markers with "AddParagraph". (TFS:274137)
- System.FormatException is thrown when load the word file contain bullet and use the C1.C1Word.2dll. (TFS:269585)
- System.FormatException occurred when load the certain specific file. (TFS:269598)
- Footer are clipped in exported Word file with docx format. (TFS:268805)
- Checkmark for some check mark style are not shown in expored word file. (TFS:255387)
- CheckedSymbol are shown as number instead of CustomSymbol in exported word file. (TFS:255389)

# Release version 4.0.20172.570 - 08/28/2017

## C1.WPF

### Bug fixes

- [C1NumericBox] "System.IndexOutOfRangeException" occurred while clicking increment/decrement button in C1NumericBox and then pressing Spacebar key from keyboard. (TFS-280493)

## C1.WPF.FlexChart

### Bug fixes

- [FlexChart][Regression]Candlestick symbols are rendered while setting e.Cancel=True in series SymbolRendering event handler
- CandleStick series does not honor the PlotArea bounds to which its Axis has been attached to

## C1.WPF.FlexGrid

### Bug fixes

- The size of templated cells is not calculated properly. (TFS-277973)

## C1.WPF.FlexSheet

### Bug fixes

- Remove Duplicates action is not worked in C1FlexSheet.(TFS-276696)

## C1.WPF.GanttView

### Bug fixes

- Calendar moves left/right position and does not fix at the same position while adding new calendar and changing working time.(TFS-279544)

# Release version 4.0.20172.568 - 08/14/2017

## C1.WPF

### Bug fixes

- [C1NumericBox] IndexOutOfRange exception is thrown when space character is entered in an empty C1NumericBox with AllowNull set to true. (TFS-277528)

## C1.WPF.FlexChart

### Bug fixes

- [FlexChart] AxisLine is covered by AxisScrollBar when hiding all the series by toggling legend (TFS-276972)
- [FlexChart] Incorrect axis format and series plotted is shown when setting DateTime type to BindingX in C1FlexChart which has series with Secondary AxisX (TFS-276888)

## C1.WPF.FlexSheet

### Bug fixes

- Sorting does not work on clicking column header in bound mode binding FlexSheet although AllowSorting is "TRUE".(TFS-276626)
- Blank sheet is exported when C1FlexSheet is bound with DataTable and datetime value and exported to various format (.xlsx/.xls/.htm/.html/.csv/.txt/).(TFS-276856)
- "System.ArgumentOutOfRangeException" is thrown when loading the C1FlexSheet in which some of the cells are merged together.(TFS-276966)
- "System.InvalidCastException" is thrown when grouping in FlexSheet is applied with CollectionViewSource.(TFS-276804)
- Filtering is not work when the C1FlexSheet is bind with DataTable.(TFS-277971)

## C1.WPF.GanttView

### Bug fixes

- Filter cannot be applied to tasks when loading of filter applied .XML file to C1GanttView.(TFS-276692)
- Background of predecessors arrow is shown in black.(TFS-276775)
- BarStyle of task will disappear after setting of BarStyle of Inactive Task.(TFS-276658)
- Value type in Advanced Filter cannot be updated immediately while changing different FieldName.(TFS-277902)

### Improvements:

- German language resources added.

## C1.WPF.Gauge

### Bug Fixes:

- Setting Background Color does not work when customizing the shape of C1RadialGauge.(TFS-275263)

## C1.WPF.InputPanel

### Bug fixes

- Multiple issues are observed while setting big FontSize to InputPanel. (TFS-264781)

# Release version 4.0.20172.567 - 07/31/2017

## C1.WPF.Chart

### Bug fixes

- Fixed the problem with incorrect z-axis annotations under several conditions.(TFS-266123)

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexChart] ArgumentOutOfRangeException is thrown in designer when LineMarker is added to chart containing no series (TFS-274622)
- [C1FinancialChart][Regression] "System.NullReferenceException" is thrown when the "Binding"contains only close values in RSI indicator (TFS-269517)

## C1.WPF.FlexGrid

### Bug fixes

- ColumnHeaderSelectedBackground property of C1FlexGrid does not work as expected. (TFS-271440)
- Chart cannot interact with FlexGrid while change selected item in both of them. (TFS-272753)

## C1.WPF.FlexSheet

### Bug fixes

- Selected cell ranges of FlexSheet cannot be merged even click "Merge" button on the toolbar.(TFS-272421)

## C1.WPF.GanttView

### Bug fixes

- There is no "Use Fiscal Year" checkbox in Timescale dialog of "Top/Middle/Bottom" tier tab.(TFS-257913)
- Edges of "Resources/Advanced/Notes" tabs keep remaining with a spot while switching each tab to another in Task Information dialog.(TFS-266865)
- Text are not aligned consistently with each other in Calendar tab of Change Working Time dialog.(TFS-266875)
- Tooltips for reflect on summary bar and reflect on group bar are not shown when the task is applied reflect on summary bar or reflect on group bar from Task Information dialog and mouse hover it.(TFS-260270)
- Inconsistent behavior is occurred when setting both of the "Print only first" and "Print first" option in View Tab of the Print Dialog.(TFS-257511)
- Project validations is not shown while applying invalid schedule in ProjectInformation.(TFS-251986)
- Searching can not be performed in output pdf file of C1.WPF.GanttView.(TFS-250638)
- Bar height of selected task remains unchanged while setting Task to "(Default)" and changing Bar height in "Bar Styles" dialog.(TFS-269692)
- BarStyle is not applied to chosen taskbar while setting of Default ProgressBar style.(TFS-253384)
- ChartView cannot be shown after opening print preview dialog even setting Tier in "TimeScale" dialog.(TFS-271041)
- Progress bar using "Pattern" style is not shown correctly.(TFS-250096)
- There are a lot of black lines drawing in ChartView while creating Predecessors/Successor link by drag and drop action.(TFS-280536)
- "Conflict Resolver" dialog is not shown in GanttView while moving task bar with predecessors.(TFS-276817)
- "System.InvalidOperationException" occurred in mscorlib.dll while dragging DurationOnly manual task in ChartView.(TFS-280689)
- Predecessors/Successor link can not be added by drag and drop Duration Only Task.(TFS-280998)
- Some menu icons on the toolbar are cut off when setting of custom font size to C1GanttView.(TFS-281041)
- BarStyle cannot be applied to grouped task bar.(TFS-284758)

# Release version 4.0.20172.565 - 06/28/2017

## C1.WPF.Document

### Bug fixes

- Bound images in the flexreport are not cleared in exported pdf file. (TFS:269973)

## C1.WPF.Theming

### Bug Fixes:

- [DataGrid] 'Click here to add a new row' text is not clear when setting "Office2016DarkGray" themes.(TFS-270396)

# Release version 4.0.20172.564 - 06/27/2017

## C1.WPF

### Bug fixes

- [C1ComboBox] C1ComboBox does not refresh after changing DisplayMemberPath. (TFS-268997)

## C1.WPF.Excel

### Bug fixes

- Different output file being generated for SaveCsv() method using 2016v3 and 2017v1
  builds. (TFS:268424)
- Location of merged cells in saved excel file changes when a row's height/column's
  width is changed after merging in C1Excel. (TFS:268784)
- Request to provide information on how to use XLReferenceMode Enum in C1Excel.
  (TFS:242729)
- When a .xlsx file is load and saved just as it is, the user definition format of
  a cell changes. (TFS:251891)
- C1XLBook throws an unhandled exception of type 'System.ArgumentException' when
  loading a xslx file. (TFS:245883)
- Fixed work with print area (Excel: Seting print area). (TFS:204542)
- Request to improve performance for saving excel file. (TFS:253350)

### Improvements

- Added support XLReferenceMode.R1C1 (and ReferenceMode property for C1XLBook) for
  C1Excel (Request: TFS:242729)
- Added UseDefaultCsvEncoding property in C1XLBook (use the default encoding for CSV
  files), for Japanese version true by default.

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexChart] DataLabels are overlapped in bar stacked group if same values are at the same group (TFS-268756)
- [C1FinancialChart] ArgumentException is thrown when add two series with same data and ChartType='LineBreak' (TFS-268952)
- [C1TreeMap] ArgumentException occurs when C1TreeMap is added many items at design time by setting DataLabel.Border="True" and without setting Width property to C1TreeMap (TFS-269640)

## C1.WPF.GanttView

### Bug fixes

- [Theme] Legend Text is invisible in Preview Print page when setting "CosmopolitanDark" themes.(TFS-268872)

## C1.WPF.Olap

### Bug Fixes

- Text of 'Format' column in 'Field Setting' is invisible when setting "ShinyBlue" themes. (TFS-268734)

## C1.WPF.Theming

### Bug Fixes:

- [BasicControls] Ribbon's Gallery Name text are disappeared and Ribbon group can not be seen clearly when setting "Office2016Black" themes.(TFS-266843)
- [DockControl] Header of DockTabItem is invisible in Sliding mode when setting "Office2016Colorful" themes.(TFS-268750)
- [BasicControls][RangeSlider] Height of the RangeSlider is expanded when setting "C1Blue" themes.(TFS-268735)

## C1.WPF.Word

### Bug fixes

- Footer are clipped in exported Word file with docx format. (TFS:268805)
- Text style in the original document is not retained when save it in another document. (TFS:268303)
- Header and footer are not shown when load the word document and save it in another document. (TFS:268381)
- FormatException is thrown when a word document is loaded. (TFS:261763)
- Image are not displayed in Docx format. (TFS:262936)
- Alignment of picture is not effected with Docx format. (TFS:263451)
- Ellipse,Arc,Beziers and line shapes are not shown in output documents. (TFS:215107)

# Release version 4.0.20172.563 - 06/20/2017

## C1.WPF.FlexSheet

### Bug fixes

- Fixed not working RowHeaderForeground and ColumnHeaderForeground properties.

# Release version 4.0.20172.562 - 06/19/2017

## C1.WPF.Document

### Bug fixes

- Export to BMP takes too much time. (TFS:266122)

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexPie] Slices in FlexPie are not rendered correctly when binding with negative value (TFS-265305)
- [C1FlexChart] DataLabels are overlapped when values at Y-Axis are the same in the same stacked group. (TFS-265756)
- [C1FlexChart] Fixed problem with minor grid lines/ticks when number of major ticks is less than 2. (TFS-219316)
- [C1FinancialChart] IndexOutOfRange exception thrown when using DateTime X-axis values for Stochastic oscillator (TFS-261840)
- [C1FinancialChart] MovingAverages are not getting rendered on a CandleStick/HLOC chart Fixed need review (TFS-260556)
- [C1FlexChart] LineMarkers cannot be dragged after resizing the chart if all the series are plotted on a secondary Y-axis. (TFS-259891)

### Improvements

- [C1FlexChart] Added new 'ContentCenter' property to Polygon annotation to control the location of the content. (TFS-253917)
- [C1TreeMap] Added new C1TreeMap control for visualization of hierarchical data.

## C1.WPF.Theming

### Bug Fixes:

- [Guages] Tickmarks of Ruler guages can not be seen when setting "Office2016DarkGray" themes.(TFS-266826)
- [RichTextBoxToolBar] RichTextBoxToolBar's items are not clearly seen when setting "Office2016Black" and "CosmopolitanDark" themes. (TFS-266439)

## C1.WPF.Word

### Bug fixes

- System.Runtime.InteropServices.COMException is thrown when load the rft file
  contained image. (TFS:267942)

# Release version 4.0.20172.561 - 06/12/2017

## C1.WPF.DataGrid

### Bug fixes

- Datas are disappeared when printing the page images using GetPageImagesAsync() method. (TFS 265734)

## C1.WPF.Document

### Bug fixes

- System.Exception occurred when apply certain paper size to the C1DocumentSource derived classes. (TFS:264744)
- Image in the flexreport file is not shown in the exported pdf file. (TFS:266069)

## C1.WPF.FlexViewer

### Bug fixes

- Catched exceptions that may occur while printing the document. (see TFS:264265)
- Context menu was shown outside of C1FlexViewer when using "Shift+F10" keys. (TFS:264838)
- Context menu opened with "Shift+F10" could not be closed with the "Esc" key. (TFS:264843)
- Items in the context menu could not be selected with the "Arrow" keys if the context menu is opened with "Shift+F10". (TFS:264846)
- Context menu was shown on the boundary of C1FlexViewer if opened with the Menu key. (TFS:264858)

### Improvements

- Added the HyperlinkClicked, HyperlinkHovered, OutlineClicked events to C1FlexViewerPane. (TFS:259423)

## C1.WPF.GanttView

### Bug fixes

- NumericBox and textbox are not aligned consistently each other in Task Information dialog.(TFS-264740)
- "System.ArgumentOutOfRangeException" occurred in mscorlib.dll while deleting all selected tasks after clearing grouped tasks by Undo action.(TFS-265677)
- "System.ArgumentException" occurred in WindowsBase.dll while Open Print Preview dialog after checking "Print Specific Dates" checkbox and opening "Print" dialog.(TFS-265755)
- Exception occurred while do undo action after adding summary and sorting. (TFS-265704)

## C1.WPF.RichTextBox

### Bug fixes:

- The text is not pasted from notepad/MS Word to C1RichTextBox with Shift+Insert Key. (TFS-264873)

## C1.WPF.Theming

### Bug Fixes:

- Unlike other Themes, Context Menu Content are not clearly displayed when setting "Office2016DarkGray" themes to GanttView.(TFS-264756)
- [RichTextBoxToolbar] 'System.Windows.Markup.XamlParseException' occurred in PresentationFramework.dll when C1RichTextBoxToolbar is applied with C1ThemeOffice2016Colorful, C1ThemeOffice2016DarkGray and C1ThemeOffice2016White themes.(TFS-265732)
- White text is difficult to see clearly in group scheduler while choosing 'Office2016Black' theme.(TFS-257495)

### Improvements

- Reviewed Office 2016 themes for C1Scheduler and C1Calendar controls. Control templates have been changed to be closer to Outlook 2016 appearance.

## C1.WPF.Word

### Bug fixes

- PageBreak is not effected in output docx file if the C1WordDocument contain RTFPicture
  and RTFTable. (TFS:251877)
- RtfLineBreak between RTFTable and RTFPicture is not effected in output docx file.
  (TFS:251845)
- "FirstLineIndent" property is not effected in output document when save the
  C1WordDocument with docx format. (TFS:251784)
- "Can't Open" error is thrown when save the C1WordDocument contained RTFHeader and
  RTFFooter with docx format. (TFS:251776)
- Image drawn by "DrawMetaFile" method is not shown when read and write in another word
  document. (TFS:249571)
- CheckedSymbol are shown as number instead of CustomSymbol in exported word file.
  (TFS:255389)
- Checkmark for some check mark style are not shown in expored word file. (TFS:255387)
- FormatException is thrown when a word document is loaded. (TFS:261763)
- Image are not displayed in Docx format. (TFS:262936)
- Alignment of picture is not effected with Docx format. (TFS:263451)
- Image drawn by "DrawMetaFile" method is distorted when read and write in another word
  document with rtf format. (TFS:263844)
- Color of image drawn by "DrawMetaFile" method is not retained when read and write in
  another word document. (TFS:263860)
- Ellipse,Arc,Beziers and line shapes are not shown in output documents. (TFS:215107)

# Release version 4.0.20172.560 - 06/05/2017

## C1.WPF.DataGrid

### Bug fixes

- Fixed support for IEditableCollectionView.AddNew (honor BindingList<T> with AddingNew event handler). (TFS 264404)

## C1.WPF.Document

### Bug fixes

- Exporting a Pdf file using C1PdfDocumentSource to Word and Excel was removed.
- Error is shown when export the flexreport file contained RTF field to the PDF file. (TFS:263912)
- System.Exception occurred when apply certain paper size to the C1DocumentSource derived classes. (TFS:264744)
- Image in the flexreport file is not shown in the exported pdf file. (TFS:266069)

## C1.WPF.FlexViewer

### Bug fixes

- C1FlexViewer can show zoom value "0%" on the toolbar. (TFS:261319)
- Error is shown when type invalid characters in PageNumber textbox of C1FlexViewer. (TFS:261314)

### Other changes

- Oulines were collapsed when refreshing C1FlexViewer. (TFS:261301)

## C1.WPF.GanttView

### Bug fixes

- Exception occurred while clear group type and set Maintain Hierarchy option to True. (TFS-261687)
- The "Progress Point Shape and Progress Point Color" text are cutoff in progress line dialog box while applying Themes in GanttView and opening progress line from toolbar.(TFS-261615)
- "System.ArgumentOutOfRangeException" occurred in mscorlib.dll while detele summary task and click "Undo" button on the toolbar.(TFS-261773)
- Summary Task and its child task are not aligned consistently each other while clicking "Indent Task" button.(TFS-261800)
- "System.NullReferenceException" occurred in C1.WPF.GanttView.4.dll while add new blank rows and delete these rows.(TFS-262062)
- Blank item will shown in Predecessor Task Name combobox after removing Resources name of a task.(TFS-262169)

## C1.WPF.InputPanel

### Bug fixes

- Arrow toggle buttons are not visible in C1InputDateTimePicker and C1NumericBox while setting AutoGenerate="False" in C1InputPanel. (TFS-261708)

## C1.WPF.RichTextBox

### Bug fixes:

- Japanese text entered after pressing the Insert key is displayed vertically. (TFS-262123)

# Release version 4.0.20172.559 - 05/27/2017

## C1.WPF.Document

### Bug fixes

- Blank pages is displayed by the C1PdfDocumentSouce if document is protected with password from modify. (TFS:260561)

## C1.WPF.Excel

### Bug fixes

- Unlike previous build, the excel file generated by C1Excel cann't be opened if the
  cell background is black. (TFS:260205)
- Unlike previous build, the excel file cann't be opened if loading .xls file and
  saving in .xlsx (OpenXml) format. (TFS:260209)

## C1.WPF.GanttView

### Bug fixes

- Connector line rendering does not reach to the destination task when a taks is linked to Milestone.(TFS-251874)
- Group bar still has both sides while Milestone tasks are created in the ChartView.(TFS-251976)
- Task ID and expand/collapse button in Grid View and Task bar or Summary bar in Chart View automatically move according to resizing row height when project summary task's row height is resized in GridView.(TFS-260258)

## C1.WPF.Olap

### Bug Fixes

- Chart is disappeared in file while printing Olap as Pdf file. (TFS-260872)

# Release version 4.0.20172.558 - 05/23/2017

## C1.WPF.DataGrid

### Bug fixes

- Setting Background Color in RowStyle does not work (TFS-261343).
- DataGrid can't scroll to the top when scroll to the bottom and want to scroll back to the top. (TFS-251349)

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Floating DockTabItem cannot be docked in one attempt. (TFS-235804)

## C1.WPF.Excel

### Bug fixes

- When a .xlsx file is load and saved just as it is, the user definition format of a
  cell changes [part 2]. (TFS:251891)
- Request to improve performance for saving excel file. (TFS:253350)

## C1.WPF.FlexGrid

### Improvements

- Added support for RowDetailsTemplate. Note, it is not supported for hierarhical representation when ChildItemsPath property is set.

## C1.WPF.GanttView

### Bug fixes

- Only "%Complete" column value keep remains when any task row height is resized/enlarged in GridView.(TFS-256140)
- The opened dropdown area keeps remaining its original place while dragging the splitter bar to left side and right side.(TFS-256117)
- ComboBoxes and text are not aligned consistently each other in dialog. (TFS-251703)
- Split task connector line between separate taskbars is not connected while resizing/enlarging the row height of task.(TFS-256733)

### Improvements

- Request to provide "custom print style" in printing of C1GanttView.(TFS-214868)

## C1.WPF.InputPanel

### Bug fixes

- DataPager is still shown number '0' even though clearing filter of C1DataGrid. (TFS-257115)

## C1.WPF.Olap

### Bug Fixes

- Exception occurred while dragging fields of Rows field to Column field in listbox. (TFS-257778)

## C1.WPF.Theming

### Bug Fixes:

- Combobox item will pop up automatically while choose Office2016 theme.(TFS-257510)
- [C1FlexGrid] Unlike other themes, RowHeader and ColumnHeader Grid lines are lost when setting the "Office2010Silver" themes to C1FlexGrid.(TFS-255704)

# Release version 4.0.20172.556 - 05/10/2017

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexChart] NullReferenceException occurs at design page while adding new series.(TFS-239117)
- [C1FlexChart] In Direct2D RenderMode,FlexChart placed in a C1DockTabItem behaves incorrectly on changing displayed data or resizing application window. (TFS-250139)

### Improvements

- [C1FlexChart] Request to provide feature to create Stacked groups in FlexChart. (TFS-215718)
- [C1FlexPie] Legend text is not showed with multiple lines and FlexPie is showed as very small when setting the Legend text to long text. (TFS-204491)

## C1.WPF.GanttView

### Bug fixes

- A task in progress can be inactivated in GanttView.(TFS-251888)
- Only chart view of the selected task is inactive when the selected task is inactivated by clicking "Inactive" button on toolbar.(TFS-256757)

### Improvements

- Request to provide "Legend" Tab and "View" tabs and contents in "Print" dialog box of C1GanttView.(TFS-215111)

# Release version 4.0.20172.554 - 04/22/2017

## C1.WPF.GanttView

### Bug fixes

- "Field:" combobox in "Field Styles" dialog is disappeared while select multiple cells.(TFS-250919)

### Improvements

- Request to provide backcolor for specific day of week.(TFS-239174)

## C1.WPF.Theming

### Improvements

- Added Theming.Office2016 assembly with the Colorful, DarkGray and White themes included.
  Added Theming.Office2016Black assembly with the Black theme included.
  Theming support for native MS Ribbon controls and MS/C1 Controls.

# Release version 4.0.20171.557 - 05/18/2017

## C1.WPF.FlexViewer

### Bug fixes

- Page range is not shown in the Print dialog box. (TFS:256544)

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that StartOnly , FinishOnly , Deadline Tasks are not created in the ChartView when setting to the task with only start date, only end date and deadline date.(TFS-193903)

## C1.WPF.PdfViewer

### Bug Fixes

- NullReferenceException is thrown when attached pdf files are loaded in C1PdfViewer. (TFS-256120)

# Release version 4.0.20171.555 - 05/02/2017

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] C1DockControl places dock control in different location. (TFS-253871)

## C1.WPF.FlexViewer

### Bug fixes

- Customized page settings don't affect the "Printing Preferences" dialog. (TFS:255700)

# Release version 4.0.20171.553 - 04/21/2017

## C1.WPF.FlexGrid

### Bug fixes

- ColumnHeader Backcolor Issue (TFS-253361)

## C1.WPF.FlexViewer

### Bug fixes

- Application gets terminated on moving tab containing C1FlexViewer in C1TabControl continuously. (TFS:253743)

### Improvements

- Added the (Open|Close)ButtonVisible properties and (Open|Close)Action events to C1FlexViewer for opening/closing files using toolbar buttons.
- Attached keyboard shortcuts to some toolbar buttons (Ctrl+O, Ctrl+P, ...)

## C1.WPF.GanttView

### Bug fixes

- Task bar can be dragged in ReadOnly Mode.(TFS-253402)
- Task bar will be disappeared while dragging the taskbar and make it become a Milestone by reducing its duration to "0".(TFS-251541)

## C1.WPF.InputPanel

### Bug fixes

- Menu on the header of InputPanel is not dim while setting of 'IsEnabled' as 'False'. (TFS-251846)

## C1.WPF.RichTextBox

### Bug fixes:

- Incorrect font is set when C1Document generated using RtfFilter.ConvertToDocument method is loaded in C1RichTextBox.(TFS-253069)

# Release version 4.0.20171.552 - 04/06/2017

## C1.WPF.DataGrid

### Bug fixes

- TargetInvocationException is thrown when Visibility of DataGridFilterRow is set in XAML . (TFS 252416)
- Grid auto scrolls to the start when scrollbar reaches the end and main window is resized using mouse. (TFS 252723)

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Background color is not affected in an exported excel when setting GroupWithSummaryRow in LoadedRowPresenter Event of the C1DataGrid. (TFS-245450)

## C1.WPF.Excel

### Bug fixes

- Garble texts are shown in output .xls file while loading and saving of the border
  style containing .xls/.xlsx to C1Excel. (TFS:251734)
- When a .xlsx file is load and saved just as it is, the user definition format of
  a cell changes. (TFS:251891)
- C1XLBook throws an unhandled exception of type 'System.ArgumentException' when
  loading a xslx file. (TFS:245883)
- Fixed work with print area (Excel: Seting print area). (TFS:204542)
- Numeric value item is replaced by character "GyyyyNyyyyRAL" in saved CSV file.
  (TFS:251863)
- [Regression]Loading of XLS file (which has frozen columns and dotted border) to
  C1Excel, System.NullReferenceException was unhandled in C1.WPF.Excel.4. (TFS:250150)

### Improvements

- Added support XLReferenceMode.R1C1 (and ReferenceMode property for C1XLBook) for
  C1Excel (Request: TFS:242729)

## C1.WPF.GanttView

### Bug fixes

- Data validations is shown twice and filter dialog is closed automatically while applying invalid Advancedfilter.(TFS-250933)
- "System.NullReferenceException" occurred in C1.WPF.GanttView.4.dll while clicking "Undo" button after deleting the new blank row.(TFS-251699)
- "System.ArgumentOutOfRangeException" occurred in mscorlib.dll while drag a column header to ChartView.(TFS-251871)
- "System.ArgumentOutOfRangeException" occurred in mscorlib.dll while right clicking time tiers in empty ChartView.(TFS-251972)

## C1.WPF.InputPanel

### Bug fixes

- 'Header' of C1InputTextBox/C1InputComboBox/C1InputBase is disappered. (TFS-251397)

## C1.WPF.RichTextBox

### Bug fixes:

- Opening a RTF file with multiple row, loads incorrectly.(TFS-251342)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Can't set color with C1FontColorTool/C1TextHighlightTool in a single click.(TFS-251338)

# Release version 4.0.20171.551 - 03/27/2017

## C1.WPF

### Bug fixes

- [C1ComboBox] Dropdown is not closed by F4 key after selecting child items in Multiple SelectionMode. (TFS-239092)
- [C1NumericBox] Exception occurs when focus in C1NumericBox if culture is set. (TFS-250367)

## C1.WPF.Excel

### Bug fixes

- Unlike WF version image is not rendered in output .xls/.xlsx file, while
  System.Drawing.Bitmap image is added to specific cell value. (TFS:249943)
- 'System.NullReferenceException' occrred in C1.WPF.Excel.4.dll when loading
  of Form styles contained .xls is loading to C1Excel. (TFS:250007)

## C1.WPF.GanttView

### Bug fixes

- "System.ArgumentException" occurred in WindowsBase.dll when dragging any row out of GanntView area.(TFS-249815)
- PredecessorType(Finsh-to-Start(FS)) is not displayed in GridView although Lag value is set to non zero.(TFS-213173)
- "System.ArgumentException" occurred in WindowsBase.dll while dragging a taskbar and make it become a Milestone by reducing its duration to "0".(TFS-250080)
- "Split Task" Toolbar button action cannot split a selected task.(TFS-250299)
- Unlike previous build, button/comboBox/NumericBox are cut off in "Resources" tab of TaskInformation Dialog.(TFS-250652)
- Custom column "Actual Cost" are lost in GridView when applying of grouping to C1GanttView.(TFS-250177)
- C1GanttView "Print" Dialog is kept opening while MS "Print" Dialog is opened. (TFS-250686)
- Unlike previous builds, Columns can not be sorted by clicking up/down button in "Grid Columns".(TFS-250892)

## C1.WPF.Pdf

### Bug fixes

- Attempting to create an encrypted C1PdfDocument with a user password and Security.Encryption set to PdfEncryptionType.Standard128 crashes with index out of range. (TFS:253903)

# Release version 4.0.20171.550 - 03/13/2017

## C1.WPF.DataGrid

### Bug fixes

- Column width is increased automatically when scrolling through rows and column width is set to "Auto". (TFS 245439)

## C1.WPF.FlexReport

### Bug fixes:

- Now ImageField.Picture and Field.Picture properties can be specified as System.Drawing.Image or as BitmapSource.

### Improvements:

- Added methods to load C1FlexReport from XDocument:
  public void Load(XDocument doc, string reportName)
  public void Load(XDocument doc, string reportName, out bool converted)

## C1.WPF.FlexViewer

### Improvements

- Implemented deferred rendering for the page thumbnails.

### Other changes

- Added reference to C1.WPF.Bitmap.dll.

## C1.WPF.GanttView

### Bug fixes

- Summary task is shown as "Manually Scheduled" in "Bar Type" of Bar Style dialog.(TFS 239070)
- When two indicators are shown in Row Header of GridView, 2nd indicator is cut off.(TFS 239228)
- Tasks are not reflected on the SummaryTask bar even checking "Reflect on summary bar" checkbox.(TFS 210678)
- Antialiasing line is not dim while check "Antialiasing" checkbox of "Progress Line" dialog.(TFS 212329)
- Pattern of BarStyle is not applied to TaskBar in GanttView.(TFS 209425)
- Field Styles of GridView is not retailed while using Undo and Redo function.(TFS 223000)
- Multiple issues are observed in setting of "Bar height" in BarStyle and Layout dialog.(TFS 239595)
- Predecessors can be added by manual task to group/summary task.(TFS 238762)
- Applied Bar text disappears while add/remove columns in GridView.(TFS 242644)
- Some content is invisible while setting of some themes in GanttView.(TFS 235490)
- Collapsed rows cannot be expanded after grouping and printing it as pdf/xps file.(TFS 242867)
- "Split Task" is shown Only in ContextMenu and it is always disabled.(TFS 209203)
- Group bar disappears while Milestone tasks are created in the ChartView.(TFS 242835)
- Rows of GridView can not be dragged and dropped to a new position.(TFS 238063)
- TaskMode can not be filtered by Advanced Filter in GanttView while using ApplyFilters() method.(TFS 244757)
- There is no "Today" button in Calendar of Advanced Filter dialog.(TFS 244786)
- Data validations is shown while applying valid Advancedfilter after saved filter condition.(TFS 244766)
- TimeScale area not remains the same height with ColumnHeader row height after selecting all in GridView and resizing any row height.(TFS 238728)
- Sub summary task bar is disappeared while deleting parent summary task and using Undo function.(TFS 238775)

### Improvements

- Support reflect on summary task feature.
- Support reflect on group task feature.
- Support split task feature.

## C1.WPF.InputPanel

### Improvements

- Support Ctrl+Left / Ctrl+Right.
- Expose C1DataPager properties (DisplayMode, NumericButtonStyle​) to C1InputPanel.

## C1.WPF.Maps

### Breaking changes

- The SOAP Services will be retired on June 30, 2017. We updated to use REST service in C1Maps component. (TFS 239591)
  Please refer to the following links:
  https://blogs.bing.com/maps/June-2016/Bing-Maps-V8-Web-Control-Released
  https://www.microsoft.com/maps/discon-control-migrat-guide.aspx

## C1.WPF.PdfViewer

### Improvements

- Provide the some features to view pdf file that contains attachments. (TFS 231893)
  Attachments property: Gets the list of attachments for this document.
  GetAttachment method: Returns memory stream with attachment data.
  AttachmentClick event: Fired when click on attachment icon.

## C1.WPF.ReportViewer

### Improvements

- Provide the some features to view pdf file that contains attachments. (TFS 231893)
  Attachments property: Gets the list of attachments for this document.
  GetAttachment method: Returns memory stream with attachment data.
  AttachmentClick event: Fired when click on attachment icon.

# Release version 4.0.20171.549 - 02/26/2017

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexPie] Multiple issues are observed when setting some value to DataLabelPosition , Offset, SelectedItemOffset and 1 to InnerRadius. (TFS-244411)
- [C1FlexPie] IndexOutOfRangeException is thrown by shrinking form size when DataLabelPosition is set to any position other than 'None'. (TFS-243301)

# Release version 4.0.20171.548 - 02/24/2017

## C1.WPF.GanttView

### Bug fixes

- "System.Collections.Generic.KeyNotFoundException" occurred in PresentationFramework.dll while double click "ActualCost" of FieldName in "Advanced Filter" Dialog.(TFS-242856)

# Release version 4.0.20171.547 - 02/20/2017

## C1.WPF

### Bug fixes

- [NumericBox] Validation Error ( red color rectangle ) is not shown on Page loading. (TFS-239149)
- [C1ComboBox] One item can be selected repeatly in Multiple SelctionMode. (TFS-239351)
- [C1ComboBox] Currently selected item is lost in Text area of comboBox while changing "SelectionMode" at run time. (TFS-238820)
- [C1ComboBox] Selection toggle is not updated in TextArea of C1ComboBox. (TFS-239590)
- [C1ComboBox] In Multiple SelectionMode,1st item is deselected automatically and can be selected second time even it has been selected by spacebar interaction. (TFS-239308)

## C1.WPF.Bitmap

### Bug fixes

- Fixed a bug with image DPI in the Import(C1Bitmap) and CreateImage methods of C1Bitmap.

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexChart] AxisY of of series is not closed to MajorGrid.(TFS-239281)
- [C1FlexChart] ErrorBar is disappeared when changing the ChartType to "Area" or "SplineArea" in C1FlexChart. (TFS-235045)
- [C1FlexChart] Part of DataSeries exceed PlotAreas is not cut off in FlexChart with
  setting FlexChart.AxisY.Min/Max value.(TFS-239311)

## C1.WPF.GanttView

### Bug fixes

- LeftText and RightText are not rendered in ChartView while BarType = "Progress Bar". (TFS-212289)
- Collapsed rows cannot be expanded after grouping and opening "Preview..." dialog.(TFS-238542)
- New added predecessor task name is shown as "#xlo.#tVs" instead of "(Undifined)" while setting of theme as "BureauBlack"/"WhistlerBlue".(TFS-235488)
- Taskbar cannot become "Active" immediately after it is changed "Inactive" and vice versa.(TFS-238863)

## C1.WPF.Theming

### Bug Fixes:

- In office2007 Themes, background color is not fully distributed to all rows ( both group rows and child rows ) in PropertyGrid. (TFS-238416)
- Light background on light text when using CosmopolitanDark theme on C1ToolBarTabControl.(TFS-239597)

# Release version 4.0.20171.546 - 02/13/2017

## C1.WPF.DataGrid

### Bug fixes

- DataGridTextColumn and DataGridDateTimeColumn DefaultAutoWidth property values have been reduced.
  Added setter to the DataGridColumn.DefaultAutoWidth property, so that it can be changed from custom code or xaml. (TFS-235818)

## C1.WPF.Excel

### Bug fixes

- Part 2: Width and Height of image is not retained in output .xls/.xlsx file.
  (TFS:236105)
- System.ArgumentException occurs in C1.WPF.Excel.4.dll when loading of .xslx file
  which contains JPN text. (TFS:238446)

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexChart] Dotted line of Series is shown as solid line in exported SVG image
  while setting of 'StrokeDashArray' property.(TFS-236020)

## C1.WPF.GanttView

### Bug fixes

- "System.ArgumentException" occurred in PresentationFramework.dll after choosing specific dates and clicking "Preview..." button.(TFS -238471)
- Print Preview window is too big to resize its shape in GanttView.(TFS-238065)
- "System.NullReferenceException" occurred in PresentationFramework.dll while clear group type and set "Maintain Hierarchy" option to True.(TFS-238508)

## C1.WPF.OrgChart

### Bug Fixes

- ConnectorLines are disorted when changing the ConnectorStartLineCap, ConnectorEndLineCap,
  HorizontalContentAlignment and VerticalContentAlignment properties.(TFS-236748, TFS-236706)

## C1.WPF.Pdf

### Bug fixes

- Result pdf file with arabic text have some scrambled. (TFS:238493)

# Release version 4.0.20171.545 - 02/08/2017

## C1.WPF

### Breaking changes

- [C1TreeViewItem] Removed HeaderEditor template part from the C1TreeViewItem control. It should not affect control functionality in any way.

### Improvements

- [C1TreeView] simplified C1TreeViewItem ControlTemplate for better performance (TFS-228353).

## C1.WPF.DataGrid

### Breaking changes

- DataGridCellPresenter.MergedRange property converted from dependency property to simple CLR property.

### Bug fixes

- Disable pasting changes to C1DataGrid when ReadOnly = true. (TFS-237294)

## C1.WPF.Excel

### Bug fixes

- An Exception thrown when load an Excel file by C1Excel (part 2: 元ファイル20161029_nv1.xlsx). (TFS:213273)
- Width and Height of image is not retained in output .xls/.xlsx file. (TFS:236105)
- C1Excel replaces "@" symbol to new line"\n". [next fix for CSV format] (TFS:235074)

## C1.WPF.Extended

### Bug fixes

- [PropertyGrid] Collection editors which are created for the list type properties is shown at top of window screen. (TFS-233814)

## C1.WPF.FlexChart

### Improvements

- [C1FlexChart] Support PlotAreas.
- [C1FlexChart] Support axis binding.

## C1.WPF.GanttView

### Bug fixes

- System.ArgumentOutOfRangeException occurred when deleting the last and only one task at run time. (TFS-236329)
- Exception occurred when mouse clicking in ChartView after dragging down task row to resize and scrolling down using mouse wheel in GridView at third times. (TFS-236704)
- Sorting feature is absolutely not working at all. (TFS-236381)
- Exception occurred when task name is changed, ganttview is in edit mode, bar style is applied and combobox in the column is opened. (TFS-236489)
- Milestone Summary task bar shape is shown as in both "Start" shape and "End" shape in the ChartView.(TFS-236609)
- "System.ArgumentOutOfRangeException" occurred in mscorlib.dll on switching group types for the collapsed tasks.(TFS-236386)
- "System.ArgumentOutOfRangeException" occurred in mscorlib.dll while changing TaskMode and removing applied Group.(TFS-236358)
- Exception occurred when deleting of grouped rows at run time. (TFS-236395)
- GroupBar of GranttView has edges in both side.(TFS-210301)
- Request to provide warning message box instead of showing "System.ArgumentException" occurred in PresentationFramework.dll after clicking preview/print button if all margins are set to over expected range.(TFS-237153)
- ProgressBar of task can not be dragged at run time while ProgressLines are shown. (TFS-236487)
- Collapsing and expanding grouped notes enters to the EditMode of the TaskName cell. (TFS-236391)
- Current page number is not updated in PageNumer numeric box on page navigation in "Print Preview" dialog.(TFS-236586)

### Improvements

- Request to provide the procedure to stop user from opening Task Information Dialog when task bar is double clicked. (TFS-236653)

## C1.WPF.Olap

### Bug Fixes

- Olap Chart cannot be fully printed in Pdf\XPS file while setting of Charttype as 'Column'. (TFS-229783)

## C1.WPF.RichTextBox

### Bug fixes:

- 'System.NullReferenceException' occurred in C1.WPF.RichTextBox.Toolbar.4.dll when selecting Row/Column/Cell/Table after resizing the page.(TFS-236862)

## C1.WPF.Toolbar

### Bug Fixes

- [C1Toolbar] Border of specific C1ToolbarTabItem item is lost while setting of some themes and adding of new C1ToolbarTabItem at run time. (TFS-236031)

## C1.WPF.Word

### Bug fixes

- "System.InvalidCastException" exception is thrown when load the rtf file contained table. (TFS:236199)

# Release version 4.0.20171.544 - 01/25/2017

## C1.WPF.DataGrid

### Breaking changes

- Removed some old obsolete stuff.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Main window containing C1DockControl can get focus even if a MessageBox is open.(TFS-233883)

## C1.WPF.Excel

### Bug fixes

- C1Excel replaces "@" symbol to new line"\n". (TFS:235074)
- Multiple issues are observed when loading .xlsx file that contains cells
  with thousand separators and 11 decimal values. (TFS:208468)
- Unlike build 216,'I' cursor is not shown in c1FlexGrid edit mode when loading .xlsx
  excel file to c1FlexGrid by using LoadExcel() method. (TFS:228390)
- Height of Image is reduced when image is added and saved to excel file using
  C1Excel. (TFS:223304)
- Error 'Invalid Excel OpenXml file' is occurred on opening of an excel file contains
  TabColor and formula after saving as another one. (TFS:197450)

## C1.WPF.FlexChart

### Bug fixes

- Legend text are rendered not evenly to legend icon when exporting FlexChart to SVG format.(TFS-227954)
- Part of series is covered the AxisY when exporting FlexChart to SVG format.(TFS-234505)

## C1.WPF.FlexGrid

### Improvements

- Improved loading and scrolling performance.

## C1.WPF.FlexSheet

### Bug fixes

- (-) is displayed at all of the Column Headers on opening of output PDF file exported by C1FlexSheet.SavePdf() method. (TFS-236108)
- Outlines are distorted when loading of outline contains .XLSX file to C1FlexSheet. (TFS-208230)
- 1st row of selection is not within Outline area of FlexSheet after grouping. (TFS-228003)
- Formula of specific cells are not getting copied and pasted along with the cell value. (TFS-227993)
- Exception occurred in WindowsBase.dll when exporting FlexSheet to PDF format with FlexSheet.SavePdf() method. (TFS-235752)

## C1.WPF.FlexViewer

### Improvements

- The error message text is shown on a page that can not be rendered because of an internal error.
- Optimized printing multiple copies (see TFS:230322).

## C1.WPF.GanttView

### Bug fixes

- Mouse pointer does not updated after dragging a task bar and moving the mouse up/down.(TFS-227899)
- Setting different values to ZoomFactors , and scrolling the horizontal scrollbar , the later part of ChartView and TimeScale area are distorted.(TFS-215122)
- Taskbar Interactivity tooltip is not responding after dragging the task bar vertically.(TFS-209522)
- Data validations is not shown property while applying invalid Advancedfilter.(TFS-229493)
- Taskbars cannot be dragged while opening Task information dialog of taskbar and clicking "Show Project Summary" menu.(TFS-228054)
- Splitter can be moved via Keyboard and it is disappeared while dragging it over visual area.(TFS-209769)
- Blank rows are sorted between the tasks rows when tasks are sorted Ascending by using CustomColumn value.(TFS-212848)
- "System.ArgumentException" occurred in WindowsBase.dll when zoom in to a taskbar and zoom entire project.(TFS-234872)
- Taskbar exceeds visible tiers of Timescale while setting CharViewZoomFactor to zero "9".(TFS-229174)
- Items in BarShape comboboxes are Clipped in BarStyle dialog of TaskInformation in C1GanttView.(TFS-234892)
- "%Complete" value of taskbar will change if dragging ProjectSummary taskbar.(TFS-228052)
- Bar height is invalid for taskbar while setting of Bar height of "BarStyle" dialog.(TFS-234936)
- TaskMode can not be filtered by Advanced Filter in GanttView.(TFS-234947)
- "System.InvalidOperationException" occurred in PresentationFramework.dll while printing C1GanttView.(TFS-234921)
- Decimal Value can be added in "%Completed" Column in GridView or dragging the ProgressBar in ChartView.(TFS-203656)
- Focus cannot get into Group Title when all the tasks are grouped with build-in grouping.(TFS-214117)
- Matched tasks are not shown when applying "Percent Complete" filter by using "Equal" and "DoesNotEqual" testOperator after dragging the "Percent Complete" as "63" value in tasks.(TFS-234986)
- "System.ArgumentOutOfRangeException" occurred in mscorlib.dll when deleting last task in the GridView.(TFS-235007)
- Deadline can not be added in custom calendar of ChangeWorkingTime dialog.(TFS-210679)
- Scrollbar move automatically to the left when scroll the scrollbar to the right and drag the task.(TFS-222711)
- Adding of a new rows in blank C1GanttView , SelectedIndexChanged does not event fired.(TFS-210067)
- Auto Task bar moves according to its predecessor which has changed its Start date.(TFS-210666)
- Old index returns again even after the current Index has already returned when getting of "SelectedTaskIndex" in SelectedIndexChanged event and clicking "Move Task Up" and "Move Task Down" button.(TFS-195734)
- Selection highlight is automatically jumped to the Task position of Index 0 and selected focus is lost for the first selected cell when selecting a task and added a new task from the "Add Task" button and canceling it.(TFS-214564)
- "System.NullReferenceException" occurred in C1.WPF.GanttView.4.dll and PresentationFramework.dll when design time defined tasks are sorting.(TFS-235109)
- Deadline marker can not be dragged drop in the ChartView.(TFS-222774)
- LeftText and RightText are not rendered in ChartView while BarType is "Progress Bar".(TFS-212289)
- Printing output files does not honor the applied orientation .(TFS-227917)
- "System.ArgumentOutOfRangeException" occurred in PresentationFramework.dll while sorting new calendar in Manage Custom Calendars.(TFS-235166)
- "System.ArgumentOutOfRangeException" occurred in mscorlib.dll while dragging column of empty GridView.(TFS-235206)
- Start and End shape is not adapted to enlarged task bar.(TFS-235203)
- Custom time units is not displayed in the combobox in zoom dialog.(TFS-235259)
- "BeforeZoomFactorChange" and "ZoomFactorChanged" events are not getting fired while setting of "zoom entire project".(TFS-235295)
- "Completed" tick mark are not shown for the PercentComplete = 100% task in row header area of GridView.(TFS-210655)
- Index of the task is lost is row header area while "Error" icon is shown.(TFS-210651)
- Taskbar Interactivity tooltip is not responding after dragging the task bar while cell is in edit mode.(TFS-235421)
- Deadline is not created in ProjectSummaryTask.(TFS-222678)
- ContextMenu not affected by Office2007Black and Office2010Blue.(TFS-204378)
- Task bar of FinshOnly Task is created after Today line in ChartView.(TFS-213810)
- Group bar is missing after zooming entire project and grouping by Duration.(TFS-222903)
- Expanding/Collapsing marker is not moving with "TaskName" column.(TFS-235028)
- FieldStyle ignores some cells in GridView while applying of Foreground FieldStyle property for "All" field of SummaryTask.(TFS-235151)
- Expanding/Collapsing marker disappeared after expanding/collapsing group row twice.(TFS-235017)
- New expanding/collapsing markers are diaplayed in "Percent Complete" column after grouping tasks and add columns in GridView.(TFS-235043)

### Improvements

- Add print preview of C1GanttView in print dialog.(TFS-203915)

## C1.WPF.Olap

### Bug Fixes

- Exception is thrown when printing the Olap.(TFS-234961)
- Condition in Custom Filter is shown as 'None' when its textbox lost focus.(TFS-233686)

## C1.WPF.OrgChart

### Bug Fixes

- String and numeric values cannot be set for 'Header' property through property grid.(TFS-20388)

## C1.WPF.RichTextBox

### Improvements:

- Table alignment is affected while selecting Row/Cell and applying the alignment to the Row/Cell contents.(TFS-234940)

## C1.WPF.Toolbar

### Bug Fixes

- [C1Toolbar] Default style and borders gets removed from a tab item when new tabs are inserted, selection is changed and Cosmopolitan theme is applied on it.(TFS-233961)

## C1.WPF.Word

### Bug fixes

- System.FormatException is thrown when load the certain docx file. (TFS:227601)
- Text are jump to the new line in exported docx file when RenderObjects use BaseNine fonts. (TFS:235816)

# Release version 4.0.20171.543 - 01/13/2017

## C1.WPF

### Improvements

- [C1ComboBox] Request to provide multi-select feature for C1ComboItems.(TFS-20472)

## C1.WPF.Bitmap

### Improvements

- Added the CreateImage method to C1Bitmap which creates the internal image of the given size with uninitialized content.
- Added the Import(C1Bitmap) method for more efficient copying the image between instances of C1Bitmap.

## C1.WPF.Chart

### Bug fixes

- "NullReferenceException" occurs in designer when setting Theme property to "Vista".(TFS-142207)

## C1.WPF.DataGrid

### Bug fixes

- The dropdown part keeps remaining in initial place while opening the ComboBox/Dropdown column and scrolling. (TFS-229967)
- Fixed memory leak at printing to xps or pdf. (TFS-229938)

## C1.WPF.FlexChart

### Bug fixes

- The FlexChart is not clipped in exported image.(TFS-227822)
- The StrokeDashArray is not applied to FlexChart while setting of FunnelType as
  Rectangle and RenderMode as Direct2D.(TFS-227777)

### Improvements

- [C1FlexChart] Add ErrorBar and BoxWhisker series.
- [C1FinancialChart] Add Fibonacci tools.
- [C1FinancialChart] Add Envelops and Bollinger Bands overlay series.
- [C1FinancialChart] Add MACD, Stochastic indicators.

## C1.WPF.FlexGrid

### Breaking changes

- Removed obsolete ShowGroups property.

### Bug fixes

- Sorting action does not perform correctly when C1FlexGrid is binding with XmlDataProvider. (TFS 232902)

### Improvements

- Add support for filtering values by using ExpandoObject. (TFS-229570)

## C1.WPF.FlexGridFilter

### Bug Fixes

- Null values are shown in the result when "is Less than or Equal to" or "is Less than" conditional filter is used. (TFS 233163)

## C1.WPF.FlexSheet

### Bug fixes

- Outlines are distorted when loading of outline contains .XLSX file to C1FlexSheet. (TFS-208230)
- AlternatingRowBackground property is not affected to FlexSheet. (TFS-223726)
- Grouping can not be applied to FlexSheet while the selection range contains the last cell. (TFS-228000)
- The angle format of text do not retain while saving or loading the FlexSheet. (TFS-144860)

## C1.WPF.GanttView

### Bug fixes

- Group task can not be expanded/collapsed and does not show Highlight color in GanttView.(TFS-210348)
- "ChartDateFormat" property is not exposed under C1.WPF.GanttView.C1GanttView class like "GridDateFormat".(TFS-213060)
- "ProjectSummary Task" task can not be expanded/collapsed.(TFS-214878)
- "Unit size mismatch: ....." dialog box is always showed while setting "MiddleTier" to "Year" and "BottomTier" to any of the "Units:" combobox items.(TFS-215085)
- Milestone cannot be created via "Task Information" dialog in GanttView.(TFS-224843)
- Taskbar cannot be dragged after clicking a taskbar and changing its property.(TFS-223772)
- FieldStyle ignores the currently selected cell in GridView while applying of some FieldStyle properties for "All" field.(TFS-210630)
- "Values" dropdown items are lost after deleting "Test" dropdown items and lost foucs in "AdvancedFilter" dialog.(TFS-229447)
- Applied Manual Value(s) of AdvancedFilters is shown as "Auto" in AdvancedFilter Dialog while using ApplyFilters() method.(TFS-228166)
- Deadline marker disappeared while changing Manual taskbar into DurationOnly taskbar.(TFS-228093)
- Zoom in/zoom out feature can not work via pressing "Ctrl" key and mouse wheel in ChartView.(TFS-212342)
- Predecessors/Successor link can not be added by drag and drop action.(TFS-210674)
- Items of Format/Example comboBox is not updated/refresh to minutes formats/examples only when selecting of "Minutes" in "Units:" ComboBox.(TFS-201886)
- Format and Example comboBoxes data are disappeared when setting the bottom tier units to "Minutes" and then reopen the "Timescales" dialog box.(TFS-201879)
- Work Weeks\Exceptions is not maintained when opening Chang Working Time dialog again after adding a Work Weeks\Exceptions.(TFS-212867)
- "Start" and "Finish" Date is not affect for new Auto Task if "Duration" value is not set.(TFS-198417)
- Constraint Date, Start Date and Finish Date didn't change although auto task is moved.(TFS-202188)
- Horizontal scroll thumb keep moving until to the end when dragging the task bar by exceeding the visible screen.(TFS-209419)
- Task bar color is chaged to inactive (i.e "Dim" color) when dragging the task bar by exceeding the visible screen and
  horizontal scroll bar is going to the original position of the taskbar when releasing the task bar with visible state.(TFS-214437)
- Top and Bottom text of Task bar is clipped at the place of overlapping with "NonworkingTime" position.(TFS-209462)

### Improvements

- ContextMenu and Tier text can not be seen when setting of some build-in themes.(TFS-204378)
- Ctrl+Z/Ctrl+Y shortcuts are not working in C1GanttView.(TFS-210148)
- Refactor ganttview toolbar use ToolBar instead of C1Menu.
- Support for import from MS Project.
- Support for creating task by mouse drag.
- Support for colapse/expand group and summary and group tasks, support indent/outdent tasks in grid view.
- Add link line for linked tasks and support create link by mouse drag.
- Support for adaptive bar height.
- GanttView support for Themes and ganttview dialog support for Themes.

## C1.WPF.InputPanel

### Improvements

- First Release.

## C1.WPF.Olap

### Improvements

- Add expanded\collapsed event.(TFS-19973)

## C1.WPF.RichTextBox

### Bug fixes:

- All pasted text are not removed at once by an Undo (Ctrl+Z ) action.(TFS-229806)

### Improvements:

- ???Enhancement request to support "Left/Center/Right" Table alignment properties.(TFS-36126)

## C1.WPF.Word

### Bug fixes

- Image in the MS Word file is not retained when load to C1WordDocument and save with Docx format. (TFS:204965)
- Text are not fit into field's bound in RTF/Word/Excel exported file when use "TextFitMode". (TFS:191006)
- Forecolor of RTF paragraph is not effected when save the C1WordDocument with RTF format. (TFS:224991)
- An unhandled exception of type 'System.FormatException' occurred in C1.WPF.Word.4.dll. (TFS:233860)

### Improvements

- Changed DOCX format reader for support merged cells of the table.
- Added ForeColor for Word/RTF paragraph object.
- Added support expand (spacing between characters) value for DOCX format.

# Release version 4.0.20163.541 - 01/09/2017

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Foreground color of Group rows in DataGrid is not saved in .xls or .xlsx files. (TFS-232001)

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexChart] Height of the bars in BarChart is shortened when it includes a long value for the "BindingX" parameter.(TFS-230947)

# Release version 4.0.20163.539 - 12/23/2016

## C1.WPF.Pdf

### Bug fixes

- [Regression] Not all rotated text are rendered when rotated text are created by using PdfDocument.DrawString() method. (TFS:209554)

# Release version 4.0.20163.538 - 12/20/2016

## C1.WPF.FlexViewer

### Improvements

- The OpenExportedFile property added to C1FlexViewer (mapped from C1FlexViewerPane). Its default value is set to True. (TFS:228347)

## C1.WPF.GanttView

### Bug fixes

- "System.NullReferenceException" occurred in PresentationFramework.dll if choose FieldName after clicking null value in Advanced Filter.(TFS-228079)
- "System.NullReferenceException" is occurred in "PresentationFramework.dll" when clicking the "Value(s)" dropdown of CustomFieldColumn in "Advanced Filter" Dialog.(TFS-228125)

## C1.WPF.Olap

### Bug Fixes

- Olap page can not be printed to .pdf/.oxps while CustomCellFactory is used to apply cell style in OlapGrid.(TFS-228392 )

# Release version 4.0.20163.537 - 12/15/2016

## C1.WPF.Bitmap

### Bug fixes

- System.ArgumentException is thrown when rotate the JXR file by using TransformOptions. (TFS:227961)

## C1.WPF.DateTime

### Bug Fixes

- Application is out of response when move focus to C1DatePicker with dropdown calendar open. (Tfs 227955).

## C1.WPF.FlexGrid

### Bug fixes

- TargetParameterCountException when you try to copy cells which use the indexer property. (TFS-226714)
- System.StackOverflowException occurred while opening of FilterDropdown of a column which has null value. (TFS-227984)

## C1.WPF.FlexReport

### Breaking Changes

- Now non paginated RTF export is used by default, i.e. RtfFilter.Paged is false by default.

## C1.WPF.FlexViewer

### Bug fixes

- System.Runtime.Remoting.RemotingException was thrown in the Designer after running the project. (TFS:227748)
- A reference to C1FlexChart not added to the project references when adding C1FlexViewer from the toolbox.

### Improvements

- Added Japanese and Chinese localization.

## C1.WPF.PdfViewer

### Bug Fixes

- Text are garble while loading of pdf file contained Chinese strings , TextBoxes , CheckBoxes. (TFS-227370)

# Release version 4.0.20163.536 - 12/12/2016

## C1.WPF.Chart

### Bug fixes

- Axis Labels are not rendered correctly when we create a Radar chart with log base 10. (TFS-153129)

## C1.WPF.DataGrid

### Improvements

- Allow adding new rows when grid is grouped. (TFS-25483)

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexChart] Legend border and border color are shown in svg image. (TFS-222077)
- [C1FlexChart] Background is lost while setting RenderMode as Direct2D. (TFS-222170)
- [C1FlexChart] Background color of FlexChart is lost in exported SVG image.(TFS-222217)
- [C1FlexChart] SelectionChanged event is fired twice at first while selecting any series.(TFS-222394)

## C1.WPF.FlexGrid

### Bug fixes

- The data in the cell is copied to the cell below it when using StartEdit(False) method in the SelectionChanged event and focus to cell is changed using the cursor keys. (TFS-224968)

### Improvements

- Allow adding new rows when grid is grouped or sorted. (TFS-25483)
- Reset Row/Column size to original value if resizing was cancelled by pressing Escape key. (TFS-222710)

## C1.WPF.FlexReport

### Breaking Changes

- SubreportParameterValue was renamed to ReportParameterValue.
- SubreportParameterValues was renamed to ReportParameterValues.

### Bug fixes

- C1FlexReport.EndPage event not fired for last page of the report. (TFS:227288)

### Improvements

- Added two more variants to define hyperlink in the report (see FieldBase.Hyperlink property):
- ReportLinkTargetScript. Script will be executed when user perform navigation, see "Interactive Report" sample.
- ReportLinkTargetBookmark. Added properties Report and ParameterValues properties
  which allow to create a link to another report or to same report with different parameters.
- Added new FlexChartField report field, supporting the following chart
  types: Column, Bar, Line, Scatter, LineSymbols, Area, Spline,
  SplineSymbols, SplineArea, Bubble, Candlestick, HighLowOpenClose,
  Funnel. The new FlexChartField is supported on all platforms
  (WinForms, WPF, UWP).
  FlexChartField internally uses the FlexChart control, so now
  C1.WPF.Document.4 and C1.WPF.FlexReport.4 assemblies require the
  C1.WPF.FlexChart.4 assembly, UWP assemblies C1.UWP.Document and C1.UWP.FlexReport require
  C1.UWP.FlexChart.
- Now ForcePageBreak specified for FieldBase, Section or SubSection assigned to the
  RenderObject.LayoutBreak this allows to improve exporters.

## C1.WPF.FlexSheet

### Bug fixes

- FilterDropdown can not be resized/restored its original size after enlarging the size. (TFS-203593)
- Full precision for decimal value shows in numeric cell of FlexGird/FlexSheet after exiting from Edit Mode. (TFS-207182)

## C1.WPF.FlexViewer

### Improvements

- Added C1FlexViewer control.

## C1.WPF.GanttView

### Bug fixes

- Disable filtering by resources if there are no resources in TaskResources.(TFS-223745)
- Add a combobox in the custom column when its type is Enum.(TFS-222247)
- Filter value is lost after filtering by Boolean, Enum and Resource while opening Advanced Filter dialog again.(TFS-223727)
- "System.ArgumentOutOfRangeException" is occurred in PresentationFramework.dll when printing Ganttview if hiding GridView.(TFS-224747)

## C1.WPF.PdfViewer

### Bug Fixes

- Only blank pages are rendered without any words when loading pdf file in C1PdfViewer. (TFS-224693)

## C1.WPF.RichTextBox.Toolbar

### Improvements:

- Removed BorderThickness property from C1RichTextBoxToolbar.(TFS-41138)

## C1.WPF.TileView

### Bug fixes

- System.ArgumentOutOfRangeException occurs when adding of 8 or above child C1TileViewItem,
  maximizing/minizing 7th and later TileViewItems. (TFS-227274)

# Release version 4.0.20163.535 - 11/28/2016

## C1.WPF

### Bug fixes

- [NumericBox] Application stops executing on typing value in NumericBox. (TFS-17831)
- [TreeView] Scrolling does not work when pressing PageDown key for second and onwards in isVirtualizing=True. (TFS-204912)

## C1.WPF.Bitmap

### Bug fixes

- System.NotSupportedException occurred while saving bitmap to Jpeg by using SaveAsJpeg() with ImageQuality property. (TFS:222673)

## C1.WPF.DataGrid.Excel

### Bug Fixes

- CellStyles applied using Data Trigger does not reflect in the exported
  excel file. (TFS-221867)

## C1.WPF.Excel

### Bug fixes

- First sheet is always selected when setting 'SelectedIndex' value less than 'FirstIndex'
  value. (TFS:19584)
- One of the columns in the second sheet becomes invisible after saving in the different
  path and opening it. (TFS:15297)

## C1.WPF.FlexGrid

### Bug fixes

- FlexGrid doesn't create autogenerated column for decimal values. (TFS-119735)
- Broken characters are shown when we enter Korean text in C1FlexGrid. (TFS-206395)

## C1.WPF.FlexGrid.GroupPanel

### Bug fixes

- GroupPanel text are invisible when chaning of some builds in themes.(TFS-206890)

## C1.WPF.FlexGridFilter

### Bug Fixes

- Filter tick mark i can not be seen and blur while applying of ExpressionDark/ShinyBlue/Office2007Black. (TFS 206896)
- DBNull value rows are not shown in result, while 'Equals = Null' for String/ DateTime/ Numeric columns. (TFS 101256)

## C1.WPF.FlexReport

### Bug fixes

- Error occurs during rendering if name of field of DataSource equals to VBScript keyword like "To", "While" etc. (TFS:221944)

## C1.WPF.FlexSheet

### Bug fixes

- Focus jumps to the last inserted sheet when hiding of a specific sheet instead of its next index sheet. (TFS-216537)
- Applied format is not reflected to the column of FlexSheet. (TFS-216640)

## C1.WPF.GanttView

### Bug fixes

- System.ArgumentOutOfRangeException occurs in PresentationFramework.dll when setting CharViewZoomFactor 0 and print GanttView.(TFS-215137)
- IsWithin and IsNotWithin TestOperator can not be used in C1GanttView.(TFS-205944)
- Whitespace is missing between Group Title Colon " : " and Value of the group type.(TFS-214089)
- Exception throws while dragging Duration's bar of Duration only task. (TFS-222775)
- System.NullReferenceException occurred after add blank row and click style button of Task Information. (TFS-222817)
- "System.NullReferenceException" occurred in PresentationFramework.dll when printing of CustomColumn contains GanttView.(TFS-222953)
- "System.ArgumentOutOfRangeException" is occurred in PresentationFramework.dll when printing Ganttview if hiding ChartView.(TFS-222970)

## C1.WPF.PdfViewer

### Bug Fixes

- Logo image color in original pdf file is not retained when view the pdf file in C1FlexViewer. (TFS-221614)
- C1PdfViewer is not able to navigate to their link pages by clicking TOC links. (TFS-222733)

## C1.WPF.ReportViewer

### Bug Fixes

- Current found word can not be shown in the visible screen when loading of .mhtml and jumping within the found words.(TFS-218161)

## C1.WPF.RichTextBox

### Bug fixes:

- Image cannot be copied and pasted from MS to RichTextBox via keyboard shortcut.(TFS-217432)

## C1.WPF.SpellChecker

### Improvements

- Add default dictionary in SpellChecker.(TFS-17900)
- Add Load(string fileName) method to allow people to specify files instead of streams.(TFS-17901)

## C1.WPF.Theming

### Bug Fixes:

- Child controls' text foreground are changed as "White" and becomes invisible
  when applying of some build-In themes to the Grid.(TFS: 204884)

# Release version 4.0.20163.534 - 11/14/2016

## C1.WPF

### Bug fixes

- [C1TabControl] Fixed the issue that Collapsed c1Toolbar is not auto expanded
  after selected one item in collapsed state.(TFS-32199)
- [C1TabControl] Fixed the issue that c1ToolbarTabItem�s content is remaining
  in c1Toolbar although c1ToolbarTabitem is closed by using close button.(TFS-32218)

## C1.WPF.Bitmap

### Improvements

- C1Bitmap added to the suite.

## C1.WPF.Excel

### Bug fixes

- Japanese characters, font styles, watermarks and shapes are not rendered in output
  .xlsx file. (TFS:204191 cases 2 & 5)
- Multiple issues are observed when loading .xlsx file that contains cells with thousand
  separators and 11 decimal values). (TFS:208468 case 1)

## C1.WPF.FlexChart

### Improvements

- [C1FlexChart] Add funnel chart type.

## C1.WPF.FlexReport

### Improvements:

- Exception occurs during C1FlexReport rendering if it contains RTF field with auto height. (TFS:215531)

## C1.WPF.FlexViewer

### Bug fixes

- Page was not correctly navigated to after setting the page number in thumbnail view mode. (TFS:215918)

### Improvements

- Supported FlowDirection.RightToLeft for C1FlexViewerPane.

## C1.WPF.GanttView

### Bug fixes

- Progress bar is not shown in project summary task, summary task and inactive summary task.(TFS-210382)
- Text of child controls in the dialogs are cut off when setting of custom font size to C1GanttView.(TFS 209514)
- Value of "% Percent" is not shown in ToolTip while clicking progress bar of Taskbar.(TFS-209823)
- When using "Legend Last Page" print style formats shown on that extra last page uncorrect.(TFS-213123)
- Deadline can not be added in "Advanced" tab of Task Information dialog.(TFS-210675)
- Print Dialog Korea and Japanese language show uncorrect.(TFS-215560)
- Wrong "Bad C1GanttView XML" error is shown while saving and loading of ProgressLine contains tasks.(TFS-209291)
- Filtered tick-mark is not checked at "Advanced Filter" dropdown item when updating the filter in MoreFilterDialog.(TFS-213785)
- Filtered tick-mark is not checked at "Advanced Filter" dropdown item when loading of filter applied xml file to C1GanttView.(TFS-205633)
- Filter tick mark lost in "Advanced Filter" dropdwon item when editing or applying the advanced filter on second time.(TFS-209553)
- Tick marks is not cleared in group dropdown even after clearing the applied group of GanttView.(TFS-210412)
- System.ArgumentOutOfRangeException occurred in PresentationFramework.dll when printing the empty Ganttview.(TFS-217296)
- Toolbar buttons are cut off and not fitted with the design.(TFS-214847)
- System.NullReferenceException occurred in C1.WPF.GanttView.4.dll after clicking on "Zoom…" toolbar button when chart view is empty.(TFS-215220)
- Operators, FiledNames and Value(s) of the applied filter are lost after loading the XML file in C1GanttView.(TFS-205299)
- Applied Value(s) of AdvancedFilters is not shown in AdvancedFilter Dialog while using ApplyFilters() method.(TFS-209549)
- ChartView is totally blank when loading of xml which contain MaintainHierarchy in GanttView.(TFS-210399)
- Project summary task is not listed in "Task:" comboBox of BarStyle dialog.(TFS-210668)
- Minium height value is not set to ColumnHeader row and TimeScale area by default. (Tfs-209523)
- TimeScale area remains enlarge after ColumnHeader row height has been restored by double click action in GridView. (Tfs-209745)

## C1.WPF.Olap

### Bug Fixes

- Fixed the issue that exception is thrown while filtering. (TFS-214801)

## C1.WPF.PdfViewer

### Bug Fixes

- C1PdfViewer does not displays the attached pdf files and becomes blank.(TFS-218148)

## C1.WPF.Toolbar

### Bug Fixes

- [C1Toolbar] Fixed the issue that No tabshape style in C1ToolbarTabItem
  which is dynamically added into C1ToolbarTabControl.(TFS-15692)
- [C1Toolbar] Fixed the issue that Some Header properties are not applied
  in design and run time if set in property grid.(TFS-44318)
- [C1Toolbar] Fixed the issue that Data binding does not work for
  C1ToolbarTabControl.ContentTemplate if UnselectedContentMode='Collapsed'.(TFS-16075)

# Release version 4.0.20163.532 - 10/21/2016

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexRadar] Fixed the argument exception when drag FlexRadar from
  toolbox to window.(TFS-212465)

## C1.WPF.FlexSheet

### Bug fixes

- New inserted column show cell values if insert new column when last column is selected. (TFS-203662)

## C1.WPF.FlexViewer

### Improvements

- Added the PageHistoryTracking property to C1FlexViewerPane to enable tracking history of changes for the PageNumber/PageSetNumber properties.

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that chart view bottom tier is distorted and showing only
  "F" or "T" for every day after setting "Zoom Entire Project".(TFS-213704)
- Fixed the issue that default bottom tier and middle tier formats are not
  reflected on chart view after setting "Zoom Entire Project" or "Zoom Selected Task".(TFS-213694)
- Fixed the issue that "System.ArgumentOutOfRangeException" occurs in
  mscorlib.dll when right clicking on Timescale area of the empty ganttview.(TFS-214453)
- Fixed the issue that "System.NullReferenceException" occurred in
  PresentationFramework.dll when printing of CustomColumn contains GanttView.(TFS-214505)
- Fixed the issue that "System.NullReferenceException" occurred in
  PresentationFramework.dll when printing the ganttview with specific dates option.(TFS-214507)
- Fixed the issue that "Cast:" is displayed instead of "Cost:" Label in
  Resources tab of Task Information Dialog box in C1GanttView.(TFS-214544)
- Fixed the issue that "System.NullReferenceException" and
  "System.Reflection.TargetInvocationException" occurred while setting
  ChartViewZoomFactor to 0.(TFS-214532)
- Fixed the issue that add summary task feature can be added to C1GanttView
  while gouping applied.(TFS-210378)

# Release version 4.0.20163.531 - 10/17/2016

## C1.WPF.FlexChart

### Bug fixes

- [C1Sunburst] Fixed the issue that the default name is "flexPie".(TFS-212469)
- [C1Sunburst] Fixed the issue that ItemSource at runtime is not
  reflected back on the chart.(TFS-211573)

### Improvements

- [C1FlexChart] Export FlexChart as SVG image.

## C1.WPF.FlexViewer

### Bug fixes

- The Paginated property becomes Nullable to allow setting Paginated to True for SSRS reports. (TFS:212513)
- When the SelectMouseMode property is set to false, the user could still select the text with Ctrl+A but she can't remove the selection. (TFS:212905)

### Improvements

- Added a number of ICommands to C1FlexViewerPane to facilitate development with MVVM pattern.

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that ChartView is blank when loading of output xml file to
  the same GanttView again. (TFS-212002)
- Fixed the issue that text entered in the grid cell are lost while cell is in
  edit mode after right click to check open context menu to open grid column dialog.(TFS-212597)
- Fixed the issue that text Auto/Manual task bars rendered until to the Sunday
  if their Finish date is Friday. (TFS-210694)
- Fixed the issue that "System.NullReferenceException" occurred in C1.WPF.FlexGrid.4.dll
  while setting of "TaskMode" as "Automatic" and clicking Constraint Type dropdown in GanttView.
  (TFS-210636)
- Fixed the issue that "System.NullReferenceException" occurred in C1.WPF.FlexGrid.4.dll
  while selecting "Automatic" from dropdown of Task Mode at first time and then clicking
  Task Mode's dropdown for next row within edit mode. (TFS-212021)
- Fixed the issue that Undo/Redo functions do not recognize for the changes
  in GridView. (TFS-209117)
- Fixed the issue that Combobox and DropDown of the field column can't be seen
  and Keyboard Navigation can't support in "Advance Filter" dialog. (TFS-205943)
- Fixed the issue that task name are lost in GridView when applying of
  grouping to C1GanttView. (TFS-212870)
- Fixed the issue that PrintSyle name is missing in General tab of "Print" dialog.(TFS-212922)
- Fixed the issue that Connector line is distorted between predecessor and
  successor task when applying "Default Days off = all days".(TFS-210925)
- Fixed the issue that task bar are lost and only group bars are shown in
  ChartView while applying group. (TFS-210187)

# Release version 4.0.20163.530 - 10/10/2016

## C1.WPF.Document

### Improvements:

- Now changing properties of the parameter of the C1SSRSDocumentSource will force
  set of C1SSRSDocumentSource.Dirty to true.

## C1.WPF.FlexGrid

### Bug fixes

- Row selection is still remained after changing SelectionMode from ListBox to RowRange. (TFS-40451)

## C1.WPF.FlexReport

### Bug fixes

- In some cases text selected in viewer copied not fully if report contains CheckBoxField. (TFS:211679)

## C1.WPF.FlexSheet

### Improvements

- Save/load frozen columns and rows in Excel format. (TFS-209272)

## C1.WPF.FlexViewer

### Bug fixes

- Alt+Left and Alt+Right keys did not navigate the view backward/forward.
- Pages were not rotated to 180 degrees in the Thumbnail view. (TFS:211550)
- InvalidCastException was thrown when customized the ZoomFactor. (TFS:211504)

### Improvements

- Scroll animation with the mouse is slightly improved.
- Added more dependency properties to C1FlexViewerPane, such as PageNumber, HasBackwardHistory, and so on.

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that application is not responding and C1GanttView
  crashed while applying FieldStyle to Inactive SummaryTask. (TFS-210434)
- Fixed the issue that StartDate and EndDate of the task are not updated
  according to it's PredecessorType. (TFS-209060)
- Fixed the issue that System.InvalidOperationException occurred while dragging
  PercentComplete Indicator of DurationOnly task. (TFS-209735)
- Fixed the issue that Existing tasks and newly added tasks do not honor to
  the default BarStyle(BarShape/BarText). (TFS-210423)
- Fixed the issue that BarText is not maintained when opening dialog again after
  setting of BarText of TaskBar. (TFS-209399)
- Fixed the issue that BarText can not be reset after setting it. (TFS-212035)
- Fixed the issue that legend area is printed in every page of output file when
  printing GanttView. (TFS-209531)
- Fixed the issue that "System.ArgumentOutOfRangeException" occurred in
  PresentationFramework.dll while printing C1GanttView. (TFS-209065)
- Fixed the issue that "System.OverflowException" and "System.ArgumentException"
  occurred in PresentationFramework.dll while print specific dates in GanttView. (TFS-210177)
- Fixed the issue that System.ArgumentException occurs in "PresentationCore"
  when calling of C1.WPF.GanttView.PrintManager.Print() method by setting print date
  range out of project date range.(TFS-210429)

# Release version 4.0.20163.529 - 10/04/2016

## C1.WPF.Chart

### Bug fixes

- Application freezes while maximizing the window containing C1Chart. (TFS-199965)

## C1.WPF.FlexReport

### Improvements

- First release.
  WPF version supports all features of FlexReport for WinForms excluding:
- ChartField
- Map and SuperLabel custom fields

## C1.WPF.FlexViewer

### Improvements

- First release.

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that Custom calendar is not listed or can not be set in
  Tasks of C1GanttView via "Calendar" column.(TFS-193117)
- Fixed the issue that Filtering does not work when filter the task by
  "Percent Complete" field. (TFS-194699)
- System.ArgumentOutOfRangeException occurs when calling of gv.ScrollToTask()
  method in GanttView_Loaded() event. (TFS-209836)
- Fixed the issue that matched tasks are not shown correct when applying
  "Percent Complete" filter by using "Equal" and "DoesNotEqual" testOperator after
  dragging the "Percent Complete" value in tasks.(TFS-205939)
- Fixed the issue that text entered in the grid cell are lost in edit mode after
  clicking on the "Grid Columns" toolbar to check the visible column. (TFS-210049)
- Fixed the issue that unnecessary tag is added to TaskPropertyColumn when
  drag GanttView to page in design time. (TFS-208811)

## C1.WPF.ImportServices

### Improvements

- First release.

# Release version 4.0.20163.528 - 09/26/2016

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Fixed the issue that Foreground color of DataGrid is not saved in .xls or .xlsx files. (TFS-209188)

## C1.WPF.FlexChart

### Improvements

- [C1FlexRadar] First release.

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that when applying 1 Day(s) Custom Zoom in C1GanttView
  "System.ArgumentException" occurred in WindowsBase.dll.(TFS-209296)
- Fixed the issue that "System.ArgumentOutOfRangeException" occurred in mscorlib
  when hiding and showing of Tiers in TimeScale.(TFS-209252)
- Fixed the issue that MarqueeColor is not affected/shown to Taskbar while
  dragging it in ChartView. (TFS-209500)
- Fixed the issue that application is frozen and InvalidOperationException is
  thrown while dragging Task bar several times in ChartView. (TFS-209058)
- Fixed the issue that Multiple/All tasks can not be selected by using
  Shift + Click action or clicking on "SelectAll" area of GridView. (TFS-209505)
- Fixed the issue that after switching dll versions for C1GanttView,
  "Cannot locate resource" error occurs in deisnger and C1GanttView is crashed. (TFS-208823)
- Fixed the issue that "System.InvalidOperationException" occurred while clicking
  DurationOnly, StartOnly and Finish Only Taskbar in GanttView.(TFS-209438)
- Fixed the issue that when enlarging the ColumnHeader row of GridView in
  empty GanttView System.ArgumentOutOfRangeException occurs in mscorlib.dll.(TFS-209508)
- Fixed the issue that Applied PercentComplete value is ignored in Advanced Filter
  and it returns less task counts in Filter result than in actual value.(TFS-209533)
- Fixed the issue that Applied "Progress Point Color" changed automatically to
  the same with "Line Color", when reopening the "Progress Line" dialog(TFS-209330)
- Fixed the issue that exception throws when adding of a task at index 0
  by using tasks.Insert() method. (TFS-209195)

# Release version 4.0.20163.527 - 09/21/2016

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that exception occurs when adding tasks at run time. (TFS-208817)
- Fixed the issue that horizonal scrollbar move automatically to the left end
  when pressing on the task. (TFS-209039)
- Fixed the issue that "Reset" function breaks in Sort Dialog of C1GanttView.(TFS-209079)
- Fixed the issue that CheckBoxes of GridColumn Dialog can not be checked by
  "Spacebar" interaction.(TFS-205309)
- Fixed the issue that System.NullReferenceException occurs in C1.WPF.GanttView.4.dll
  while loading xml containing FieldStyle formating in C1GanttView.(TFS-209102)
- Fixed the issue that System.NullReferenceException occurs in C1.WPF.GanttView.4.dll
  on opening of ZoomDialog when all three tiers are visible=false.(TFS-209309)

### Improvements

- Add Today button in calendars footer area for every C1DatePicker in C1GanttView.(TFS-193111)

# Release version 4.0.20163.526 - 09/19/2016

## C1.WPF.DataGrid

### Bug fixes

- Fixed the issue that RowHeight and DateFormat are not maintained
  while printing the inverted C1DataGrid.(TFS-204388)

## C1.WPF.DateTime

### Improvements:

- Added handling of 'F4' key (opens drop-down) (Tfs 208235).

## C1.WPF.FlexChart

### Breaking changes

- Change the namespace of IChartLayer from C1.WPF.Chart.Interaction to C1.WPF.Chart.

### Improvements

- [C1FlexChart] Add Waterfall series.
- [C1FlexChart] Add annotations.

## C1.WPF.FlexSheet

### Bug fixes

- Fixed the issue that focus jumps to the 1st sheet when hiding of a specific
  sheet instead of its previous index sheet. (TFS-204298)

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that operators, filed names and value of the applied filter
  is lost after loading the XML file in C1GanttView.(TFS-205299)
- Fixed the issue that "Task Information" Dialog box is not opened and show as
  a "Blink" when clicking the "Task Information" button from tool bar of a blank
  C1GanttView.(TFS-195451)
- Fixed the issue that task information dialog tool bar button and context menu
  item interaction are inconsistent after adding new blank row to C1GanttView.(TFS-203390)
- Fixed the issue that validation dialog is not shown while an upper tier has
  less time per tick than one of the tiers below it.(TFS-197838)
- Fixed the issue that milestone tasks are not created in the chart view when
  start date and finish date is the same.(TFS-193645)
- Fixed the issue that need hide maximize and minimize buttons in all
  dialogs of C1GanttView.(TFS-201662)
- Fixed the issue that some of the items in dialog box are not localized.(TFS-205708)
- Fixed the issue that "Editor" text is displayed instead of "Edit" text and
  request to provide "Ellipses" in "New" and "Edit" button of "More Filter" dialog.(TFS-205952)
- Fixed the issue that delete task toolbar button is active even though
  there is no Task in C1GanttView.(TFS-205955)
- Fixed the issue that Ganttview not updated localization immedeately.(TFS-197766)
- Fixed the issue that "Print" Dialog,context menu items and toolbar tooltip are not
  localized in GanttView.(TFS-197772)
- Fixed the issue Column names, tiers text, menu dropdown item, tooltips and Contextmenu
  are not localized to japnaese chinese localization when setting of CurrentCulture
  and CurrentUICulture.(TFS-205319)

## C1.WPF.Pdf

### Bug fixes

- Check boxes interaction can not be performed and radio buttons are disappeared in
  output pdf file from C1Pdf. (TFS:205954)
- [Sample] Request to use "WPF component" instead of "UWP component" in vertical
  text of Pdf Acroform sample page. (TFS:206004)
- Unknown character shown when Japanese character exported to pdf file for C1RichTextBox. (TFS:97308)

### Improvements

- Added support of alternative fonts for Chinese, Korean, Japanese characters.

## C1.WPF.RichTextBox

### Improvements:

- Add AutoCapitalizationMode property to indicate how to handle auto capitalization.(TFS-114613)
  None: Specifies that there is no automatic text capitalization. This is the default type.
  Sentence: Specifies automatic capitalization of the first letter of each sentence.

# Release version 4.0.20162.524 - 08/29/2016

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that exception occurs when hiding of all three tiers
  at design time and unhiding at run time. (TFS-201930)
- Fixed the issue that exception occurs while setting of "Start" time of
  Automatic task in GanttView. (TFS-204895)
- Fixed the issue that default focus is not shown on the last index of
  filter item in "Filters" listBox of "More Filters" Dialog.(TFS-204955)
- Fixed the issue that exception occurrs when design time defined tasks
  are sorting. (TFS-204960)
- Fixed the issue that context menu item "Task Information" is still active
  in ReadOnly mode after dragging a task bar.(TFS-205324)
- Fixed the issue that sign of percent complete "%" is lost in GridView. (TFS 205357)

# Release version 4.0.20162.523 - 08/23/2016

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that new task can not be added by clicking "Add Task"
  menu button/context menu.(TFS-204348)

# Release version 4.0.20162.522 - 08/22/2016

## C1.WPF.FlexChart

### Bug fixes

- [C1FlexPie] Fixed the issue that C1FlexPie is not updated when
  change the corresponding value (TFS-202556).

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that task bar is not shown when drag a long task bar to
  short one. (TFS-201647)
- Fixed the issue that progress line is not move for auto task. (TFS-198354)
- Fixed the issue that Manual TaskBar is disappeared when setting of
  ScheduleFrom="ProjectFinishDate" and dragging at run time. (TFS-193678)
- Fixed the issue that the extra margin area/sapces are very small
  in almost all dialog of C1GanttView. (TFS-197916)
- Fixed the issue that in advanced filter dialog, CombinationOperator(AND/OR)
  value is shown as FilterValue for the specific FilterRow while clicking
  "Value (s)" new filterRow.(TFS-197848)
- Fixed the issue that "Test" dropdown items are lost when reopening
  of "AdvancedFilter" which is given without "Test" and "Values".(TFS-194671)
- Fixed the issue that "Set working times" and "Range of Recurrence" groupboxes
  items are "Enable" when there is no exception in the "Exceptions" listbox.(TFS-203987)

## C1.WPF.Pdf

### Improvements

- Added PdfAcroform sample (for demo of Acroform fields) for C# and VB.

## C1.WPF.Schedule

### Bug Fixes:

- Fixed issue with not showing newly created appointments if C1Scheduler.ViewType is set to TimeLine view at design-time.

# Release version 4.0.20162.521 - 08/15/2016

## C1.WPF

### Bug fixes

- [ComboBox] Fixed the issue that match item is not selected while pasting
  text by Key in TextEditor. (TFS-193857)

## C1.WPF.DataGrid

### Bug fixes

- Fixed the issue that BorderThickness of ScrollBar style is
  not affected to C1DataGrid. (TFS-198985)

## C1.WPF.FlexGridFilter

### Bug Fixes

- Fixed the issue that FilterDropDown still open even after focus lost from
  that box when FlexSheet contains window is called from another window. (TFS 135961)

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that TaskMode can't be filter by Advanced Filter
  in GanttView. (TFS-197786)
- Fixed the issue that Bottom Tier is shown as blank row when setting MinWidth
  of the "Bottom Tier" to 8 or less than of 8. (TFS-201941)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that C1RichTextBox loose color and table formatting while copying content.(TFS-202426)
- Fixed the issue that focus can not be placed outside of the table and text can not be input anymore in C1RichTextBox after
  paste the table from MSWord.(TFS-200826)

## C1.WPF.Schedule

### Improvements:

- Added new C1SchedulerSettings.ShowReminderDialog property.
  This property determines whether control should display embedded reminder dialog when reminder is fired.
  The default value is true.

## C1.WPF.Theming

### Bug Fixes:

- Fixed the issue that ContextMenu icon is disappeared when hovering
  in "BureauBlack" theme. (TFS-200830)

# Release version 4.0.20162.520 - 08/08/2016

## C1.WPF

### Bug fixes

- [C1TreeView] Fixed the issue that applied MouseOverBrush color are
  remaining on the parent nodes of C1TreeView. (TFS-202004)

## C1.WPF.BarCode

### Bug fixes

- Fixed the issue that EncodingException.Message always returns "Invalide barcode data"
  after receiving an exception in encoding the barcode.(TFS-201539)

## C1.WPF.DataGrid

### Bug fixes

- All data are rendered incorrectly while using C1FullTextSearchBehavior with DataGridTemplateColumns. (Tfs 199306)
- Column is still shown and adjacent column name is disappeared while setting of c1DataGrid.Columns[x].Visibility = Visibility.Hidden (Tfs 198956)
- The last group with child rows is not deleted while selecting the grouped rows by mouse action from the last group row to the 1st group row and pressing "Delete" key (Tfs 198997)
- Preserve selection at sorting and filtering. (Tfs 199280)

## C1.WPF.Excel

### Bug fixes

- Error occurs in output file while loading and saving of the border style containing
  .xls/.xlxs to C1Excel. (TFS:191302)
- When the report is exported to Excel file with .xls format, background color in
  some field may change. (TFS:195006)
- Comment of cell in result excel file is not properly shown in C1Excel when loading
  and saving to C1Excel. (TFS:191100)
- Request to provide bitmap support in SL Excel. (TFS:19275)
- 'System.ArgumentException" occur in C1.WPF.Excel.4.dll while loading of .xlsx file
  contains Profit-And-Loss calculation and formula. (TFS:200261)
- #VALUE! is shown in the cell with .xls excel file after loading and saving an excel
  file which has '=SUM((B1,B2))' formula with C1Excel. (TFS:195419)
- When a Excel file that has RTF texts including line break is loaded, an unnecessary
  blank is inserted between the 2 byte characters at the time of an RTF translation
  (Regression from TFS:191100). (TFS:198035)

## C1.WPF.FlexChart

### Improvements

- [C1Sunburst] First release.

## C1.WPF.FlexGrid

### Bug fixes

- Disable sorting for autogenerated column if column data type doesn't implement IComparable interface. (TFS-201006)

## C1.WPF.FlexGridFilter

### Bug Fixes

- ColumnFilterEditor of numeric column does not sorts items correctly. (TFS 192470)

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that parent dialogs are closed on pressing "Esc" key
  while dropdown/comboBox or child dialog are opening. (TFS-195428)
- Fixed the issue that PopUp Dialog box startup position of C1GanttView is
  not at the center of the MainWindow. (TFS-197850)
- Fixed the issue that height of the bottom Tier stretch out and fill the whole
  chart view when increasing the row height of column header in Grid View. (TFS-198073)
- Fixed the issue that exception occurs when clicking value in Predecessors
  column at run time and setting of ScheduleFrom="ProjectFinishDate". (TFS-198348)
- Fixed the issue that "System.NullReferenceException" occurs in
  PresentationFramework when set working times in Exceptions tab of
  ChangeWorkTime in GanttView. (TFS-198457)
- Fixed the issue that TargetInvocation exception occurs in runtime
  while setting of "ChartStartDate"/"ChartFinishDate" in GanttView. (TFS-197702)
  [WPF] Fixed the issue that System.NullReferenceException occurs in
  C1.WPF.GanttView.4 dll when calling of gv.ScrollToTask()
  method after InitializeComponent(). (TFS-201636)
- Fixed the issue that ConstraintType and ConstraintDate can be set for
  ManaualTasks and shown in the GridView. (TFS-193675)

## C1.WPF.Maps

### Improvements

- Used a reference to C1.WPF.Zip library instead of shared C1Zip code.

## C1.WPF.Pdf

### Improvements

- Added support PDF/A compliance for PDF annotations. PDF/A bug fixing.
- Fixed support PDF Acroforms for XAML versions.

## C1.WPF.PdfViewer

### Improvements

- Used a reference to C1.WPF.Zip library instead of shared C1Zip code.

## C1.WPF.ReportViewer

### Improvements

- Used a reference to C1.WPF.Zip library instead of shared C1Zip code.

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that font size is displayed incorrectly if copy and paste the character.(TFS-201083)
- Fixed the issue that the caret position is incorrect in a particular
  character in 'Yu Gothic UI' font family.(TFS-201086)

### Improvements:

- Add support for resizing table by dragging.(TFS-91526)

## C1.WPF.SpellChecker

### Improvements

- Used a reference to C1.WPF.Zip library instead of shared C1Zip code.

## C1.WPF.Word

### Bug fixes

- Text's alignment of original document is not retained in new document. (TFS:191068)
- Backfilling color changes in output .rtf and not effected in output .docx file
  when load/save the MS Word Document to C1Word. (TFS:196282)
- Font Size of MS word file is not retained when load and save in C1WordDocument. (TFS:193081)
- System.FormatException is thrown when load the docx file contained bookmark and save
  it in another document. (TFS:192836)
- PageBreak from MS word does not effect in C1WordDocument when load MS word file and
  save it in C1Wordocument. (TFS:193054)
- Position of Footer text are different in RTF and Docx Files. (TFS:196953)
- Text behind the tab character "\t" are disappeared in output RTF file. (TFS:197388)
- Background filling color of main section in the C1WordDocument is not effective in
  output RTF and DOCX files. (TFS:153736)
- WidthPercent of Table row is not effected in word doucument with Docx format. (TFS:153145)
- Font color of "RTF Field" is not effected in exported Docx and RTF files (TFS:201537)

# Release version 4.0.20162.518 - 07/18/2016

## C1.WPF

### Bug fixes

- [Combobox] 'SelectedIndex' is always shown as '0' after editting and selecting the text in C1Combobox. (TFS-199022)

## C1.WPF.DataGrid

### Breaking changes

- Removed obsolete C1DataGridScrollMode enumeration and DataGridColumn.LoadingFilter event.
- GetPageCompletedArgs class renamed to GetPageCompletedEventArgs.

## C1.WPF.FlexGrid

### Bug fixes

- Column header's background color disappears while selecting any cell in C1FlexGrid. (TFS-199595)

## C1.WPF.GanttView

### Bug fixes

- Fixed the issue that Context menu items are still active and user can interact
  some functions via these context menu even in ReadOnly Mode. (TFS-195723)
- Fixed the issue that System.NullReferenceException occurs in C1.WPF.GanttView
  .4.dll when hiding of all three tiers in task existing GanttView. (TFS-197803)
- Fixed the issue that System.ArgumentException occurred in PresentationFramework
  while hiding of Middle Tier and changing Unit in Bottom Tier. (TFS-197806)
- Fixed the issue that "NullReferenceException" occurs in
  C1.WPF.GanttView.4.dll while deleting of CombinationOperator(And/Or) and opening of
  the FieldName Dropdown.(TFS-197886)
- Fixed the issue that System.InvalidOperationException occurs in
  PresentationFramework.dll while changing of %Complete value in GridView.(TFS-198188)
- Fixed the issue that length of Task bar can't be increased / reduced by
  dragging to increase or reduce the duration of the task.(TFS-195514)

## C1.WPF.Theming

### Bug Fixes:

- Fixed the issue that ContextMenu items are displayed with white foreground
  while applying C1ThemeCosmoplitanDark theme. (TFS-199003)
- Fixed the issue that ListViewItems becomes transparent on selection while
  we apply C1ThemeCosmopolitanDark theme. (TFS-199004)

# Release version 4.0.20162.517 - 07/04/2016

## C1.WPF

### Bug fixes

- [C1DragDropManager]"System.NullReferenceException" is thrown while pressing space bar during cell drag. (TFS-197911)

## C1.WPF.DateTime

### Improvements:

- Removed angle brackets from default watermak in DatePicker control.

# Release version 4.0.20162.516 - 06/27/2016

## C1.WPF

### Bug fixes

- [C1RangeSlider] Fixed the issue that UI of RangeSlider is lost and shown as
  empty box in both DesignTime and RunTime. (TFS-195133)

## C1.WPF.Excel

### Bug fixes

- Error occurs in output file while loading and saving of the border
  style containing .xls/.xlxs to C1Excel. (TFS:191302)

# Release version 4.0.20162.514 - 06/21/2016

## C1.WPF.DataGrid

### Improvements

- Improved performance when C1DataGrid.ColumnWidth property is AutoStar (default value).
  Added DataGridColumn.DefaultAutoWidth property which determines default column width used in AutoStar sizing.

## C1.WPF.Olap

### Bug Fixes

- Fixed the issue that headers are duplicated when calling of SortRows()
  method in two or more fields. (TFS-152765)

## C1.WPF.RichTextBox.Toolbar

### Improvements:

- PopUp dialogs(Image dialog, Hyperlink dialog, SpellCheck dialog) would be
  closed when press Esc key.(TFS-193899)
- DropDown items(Change Case, Font Color, Text Highlight Color, Paragraph Color,
  Borders, Margin, Padding, Insert Symbol, Insert Table, Select Table, Delete Table)
  would be closed when press Esc key.(TFS-193894)

# Release version 4.0.20162.513 - 06/14/2016

## C1.WPF.GanttView

### Improvements

- First beta version.

# Release version 4.0.20162.511 - 06/06/2016

## C1.WPF.DataGrid

### Improvements

- Allow using arbitrary content in customized cell presenters
  http://our.componentone.com/groups/topic/c1datagrid-bug/#post-679061.
- Add GetPageImagesAsync method.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that "ItemDockModeChanged" event is not fired
  when C1DockTabControl is changed to Docked mode by dragging. (TFS-189875)

## C1.WPF.FlexChart

### Improvements

- [C1FinancialChart] First release.

# Release version 4.0.20162.509 - 05/16/2016

## C1.WPF

### Bug fixes

- [C1ComboBox] Fixed the issue that "System.Window.Data" error is thrown
  while opening the dropdown of C1ComboBox. (TFS-151867)

### Improvements

- [C1RangeSlider] Add ScrollBehavior property.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that ArgumentOutOfRangeException is thrown
  while moving a C1DockTabControl which contains a collapsed C1DockTabItem. (TFS-153955)

## C1.WPF.FlexChart

### Improvements

- [C1FlexChart] Add DirectX rendering.
- Change beta license to normal license.
- [C1FlexChart] Add SaveImage method.

## C1.WPF.FlexGrid

### Bug fixes

- Fixed the issue that print the Frozen Column on every page while printing
  the C1FlexGrid.(TFS-153296)

## C1.WPF.PdfViewer

### Bug Fixes

- Fixed the issue that application crashes while loads a pdf document. (TFS-152429)
- Fixed the issue that ArgumentOutOfRangeException is occured when loading
  another pdf file during searching the some text in C1PdfViewer. (TFS-152943)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that some content would be collapsed when insert a very
  large image in Paint ViewMode.(TFS-153278)

## C1.WPF.Sparkline

### Improvements

- First Release.

# Release version 4.0.20161.507 - 04/23/2016

## C1.WPF.FlexChart

### Bug fixes

- Fixed the problem with rendering selected series for area chart (TFS 150626).
- The axis displayed correctly after setting axis origin (TFS 150968).
- Series with bubble chart type are rendered correctly (TFS 150995).
- Cancel property works properly for SymbolRendering event in financial charts (TFS 151123).
- Fixed the problem with exception in area spline charts (TFS 151718).

## C1.WPF.FlexGrid

### Bug fixes

- Fixed the issue that the AutoComplete behavior is not working.(TFS-150682)

## C1.WPF.Olap

### Improvements

- Provide feature for custom sort for column headers and row
  headers. (TFS-136783)

## C1.WPF.PdfViewer

### Bug Fixes

- Fixed the issue that the image is not rendered in correct in C1PdfViewer. (TFS-150539)

### Improvements:

- Changed the search behavior. Search only starts at pressing Enter
  key in the search box. Pressing Escape key cancels long search operation.

## C1.WPF.Word

### Bug fixes

- There is no footer visible in the Word document created using C1Word when it is saved in Docx format. (TFS:150574)

### Improvements

- Add support of table cell pading for Open XML format (DOCX).

# Release version 4.0.20161.506 - 04/01/2016

## C1.WPF

### Bug fixes

- [C1TabControl] Fixed the issue that no response when drag a item in dropdown
  of C1ComboBox in C1TabItem.(TFS-149529)

## C1.WPF.DataGrid

### Bug fixes

- Fixed validation in new row occur problem when update to new version (Tfs 149753).

## C1.WPF.FlexChart

### Improvements

- [C1FlexChart] First release.
- [C1FlexPie] First release.

## C1.WPF.FlexGrid

### Bug fixes

- Support binding to indexed properties with Guid parameter.(TFS-138920)

## C1.WPF.Olap

### Bug Fixes

- Fixed the issue that exception is thrown while removing a field from
  C1OlapPage after printing the OlapGrid. (TFS-148579)

## C1.WPF.RichTextBox

### Improvements:

- AutoFormatHyperlinks is used to indicate whether Url strings would be converted
  to hyperlink when the user presses the ENTER or SPACE key.(TFS-146369)

## C1.WPF.Theming

### Bug Fixes:

- Fixed the issue that C1ContextMenu items are not visible when apply
  CosmopolitanDark theme.(TFS-140215)
- Fixed the issue that C1ContextMenu items are not visible when apply
  ExpressionDark.(TFS-138614)

## C1.WPF.Word

### Bug fixes

- Table borders are not shown and text are overlapped when save the C1Word with Docx format. (TFS:146519)
- ForeFilling color of table in the C1Word Document is not effective in output RTF and DOCX files. (TFS:144710)
- Line break key 'Ctrl+Enter' in the Text Field , RTF Field and Paragraph Field are not effected in
  Word export. (TFS:139058)

### Improvements

- Impoved support of Word/RTF borders (for all RtfBorderObject heirs). Added RtfTableBorderObject
  for all table objects (RtfTable, RtfRow and RtfCell).

# Release version 4.0.20161.504 - 03/14/2016

## C1.WPF.Chart3D

### Bug fixes

- Fixed the issue that data is not cleared and chart is distorted when Clear()
  method is called with RenderMode = Direct3D and DC_D3D modes.(TFS-114247)
- Fixed the issue that PointToData() method does not appear to work on a second
  surface.(TFS-118254)

## C1.WPF.DataGrid

### Bug fixes

- Fixed the issue that Request to suggest a way on how to obtain Columns
  outside of Visibilty when using GetPageImages method of the grid . (TFS-76130)
- Improved performance at changing rows visibility (http://our.componentone.com/groups/topic/massive-c1datagrid-row-visibility-performance-issues/).

## C1.WPF.FlexGrid

### Bug fixes

- Fixed the issue that System.Argument exception is thrown when we disable
  the scrollbars and resize the C1FlexGrid.(TFS-147602)

## C1.WPF.FlexSheet

### Bug fixes

- Fixed the issue that border styles does not retained after loading an Excel
  file in C1FlexSheet. (TFS-146452)
- Fixed the issue that Circular Reference Error occurs while referencing
  of the cell value with formula of a sheet from another sheet.(TFS-139182)

## C1.WPF.OutlookBar

### Bug fixes

- Fixed the issue that "Hide additional button" is not dim state from
  customize buttons menu when C1OutlookBar is empty.(TFS-29926)
- Fixed the issue that outlook item is not hidden when clicking "Show Fewer Buttons"
  at the first time.(TFS-33194)

## C1.WPF.PdfViewer

### Bug Fixes

- Fixed the issue that after the "BlackoutWords" property is applied, the
  neighbor words are not render correclty by adding space. (TFS-146640)
- Fixed the issue that FindCount does not return correct number. (TFS-143128)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that text alignment of cell content is not retained as in
  original while the nested table is copied and pasted.(TFS-144929)

### Improvements:

- Add Ctrl+b, Ctrl+i, Ctrl+u shortcuts in C1RichTextBox.(TFS-51801)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that OBJ is shown as Text in Hyperlink dialog box when add
  hyperlink for image.(TFS-23464)

# Release version 4.0.20161.503 - 03/01/2016

## C1.WPF.MediaPlayer

### Improvements

- Added C1MediaPlayer.Close() method. Call this method to release resources. (TFS 147222)

## C1.WPF.PdfViewer

### Bug Fixes

- Fixed the issue that NullReferenceException is thrown while loading
  a pdf document in C1PdfViewer. (TFS-147245)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that when the strings of Hankaku-kana is changed with the
  ConvertToDocument method of RtfFilter, they are not sometimes changed correctly.(TFS-146916)

# Release version 4.0.20161.502 - 02/23/2016

## C1.WPF.Chart

### Bug fixes

- DivideByZero Exception is thrown while setting the RenderMode=Bitmap. (TFS-144864)

## C1.WPF.DateTime

### Bug Fixes

- added validation of DisplayDate property at DisplayDateEnd and DisplayDateStart property changes. (Tfs 144704).

## C1.WPF.Excel

### Bug fixes

- Excel file does not exported correctly while exporting the styles and merging the
  cells of C1Excel. (TFS:144689)

## C1.WPF.FlexGrid

### Bug fixes

- Honor culture settings when pasting from clipboard (TFS-139040).

## C1.WPF.Gauge

### Bug Fixes:

- Request to set default value for "FontFamily" in C1Gauge.Decorators.C1GaugeLabel property. (TFS-32018)

## C1.WPF.PdfViewer

### Bug Fixes

- Fixed the issue that BlackoutWords property is not working correctly
  in C1PDFViewer when RenderMode is set to "Extended". (TFS-142874)
- Fixed the issue that unmatched words are highlighted after searching
  one page in pdf file. (TFS-144773)
- Fixed the issue that NullReference Exception will be thrown when
  load one pdf file. (TFS-146264)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that the header strings that is output with RtfFilter's
  ConvertFromDocument method is output by fixing.(TFS-144994)

## C1.WPF.Schedule

### Bug Fixes:

- Fixed arrow keys navigation in the C1Scheduler control (Tfs 146276).

## C1.WPF.Word

### Bug fixes

- Unhandled exception is thrown when load the RTF/Docx document file. (TFS:144874)
- Backfilling color of table in the C1Word Document is not effective in output RTF
  file. (TFS:144707)

# Release version 4.0.20161.501 - 02/03/2016

## C1.WPF.DataGrid

### Improvements

- Added support for vertical scrollbar commands ScrollHere, ScrollToTop, ScrollToBottom (Tfs 143124).

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that exception throws when save or load
  method is excuted if property is bound. (TFS-142200)

## C1.WPF.Excel

### Bug fixes

- "Invalid Excel OpenXml file (*.xlsx)" exception is thrown while Importing
  an Excel(.xlsx) file generated using Altova Mapforce or Telerik
  SpreadSheetProcessing for Wpf with C1Excel. (TFS:142312)

## C1.WPF.FlexSheet

### Bug fixes

- Fixed the issue that the position of image loaded from file is not correct.(TFS-25566)
- Fixed the issue that loses formatting while export into xls file.(TFS-136855)
- Fixed the issue that C1FlexSheet does not save out added or deleted rows and columns.(TFS-143859)

## C1.WPF.OutlookBar

### Bug fixes

- Fixed the issue that IsEnabled property does not work during selection.(TFS-18128)

## C1.WPF.Pdf

### Bug Fixes

- Other system font do not get applied to C1PDF. (TFS:143375)

## C1.WPF.PdfViewer

### Bug Fixes

- Fixed the issue that BlackoutWords property is not working correctly
  in C1PdfViewer when RenderMode is set to "Extended". (TFS-142874)
- Fixed the issue that System.NullReferenceException occurs when
  load pdf file. (TFS-143486)
- Fixed the issue that NullReference exception occurs while creating
  of pdf by PdfFilter.PrintDocument. (TFS-143540)
- Fixed the issue that exception will be thrown when searching text for
  some pdf files. (TFS-143521)
- Fixed the issue that exception is thrown when scroll C1PdfViewer after
  searching and deleting the searched word. (TFS-143116)

## C1.WPF.Schedule

### Bug Fixes:

- Appointment keeps updating itself on click when it is not entirely displayed on screen (Tfs 143340).

## C1.WPF.Word

### Improvements

- First release.

# Release version 4.0.20161.499 - 01/18/2016

## C1.WPF

### Bug fixes

- [C1TreeView] Fixed the issue that cannot add C1TreeViewItem through
  Collection Editor: Items window. (TFS-17551)
- [C1NumericBox] Fixed the issue that color of the blinking cursor is not
  changed when the CaretBrush property is set. (TFS-15327)
- [C1RangeSlider] Fixed the issue that C1RangeSlider's keyboard is not
  supported on WPF. (TFS-140683)
- [C1RangeSlider] Fixed the issue that 'UpperThumbButton' and 'LowerThumbButton'
  cannot move by arrow keys from keyboard. (TFS-15479)
- [C1RangeSlider] Fixed the issue that 'GotFocus' event does not fire when click
  on 'LowerValueThumb' or 'UpperValueThumb'. (TFS-15484)

## C1.WPF.DataGrid.Filters

### Improvements:

- Add Watermark property into DataGridFilterRow.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that picker parts are shown outside of
  DockControl when dragging DockTabItems. (TFS-135948)

## C1.WPF.Excel

### Bug fixes

- At times, position of a string is changed to BottomAligned in the output. (TFS:139667)

### Improvements

- Added BMP and PNG encoder/decoder for WPF version.

## C1.WPF.Extended

### Bug fixes

- [C1PropertyGrid] Fixed the issue that control still gets dimmed after
  setting “DisabledCuesVisibility=Collapsed” if “IsEnabled=False”.(TFS-19061)

## C1.WPF.FlexGrid

### Bug fixes

- Support binding to custom indexed properties with non-default name.(TFS-138920)
- Fixed the issue that ColumnHeader does not changed while inserting a new
  Column in Columns collection.(TFS-141676)

## C1.WPF.FlexSheet

### Improvements

- Load image from .xls/.xlsx file.
- Change the license to make it avalible in Studio/Ultimate Edition.

## C1.WPF.Gauge

### Bug Fixes:

- Fixed the issue that PointerCapFill and PointerCapStroke properties are not
  effected in C1Knob and C1RadialGauge.(TFS-36946)
- Fixed the issue that PointerCap related properties are observed in property
  grid although no pointer cap in C1SpeedometerGauge.(TFS-40871)
- Fixed the issue that PointerStroke and PointerStrokeThickness are not effected in C1Knob.(TFS-41841)

## C1.WPF.Pdf

### Bug Fixes

- Color for pie chart is not exported correctly to pdf file. (TFS:137852)
- "NullReferenceException" has occurred when saving the pdf file that has attachment. (TFS:132231)

### Improvements

- Common code with C1Pdf for WinForms and many changed for it.
- Added support embedded fonts (TrueType fonts, FontType property).
- Added support of PDF/A format (ConformanceLevel property).
- Changes for support bookmarks and links for FlexReport. Added new AddBookmark method.

## C1.WPF.PdfViewer

### Breaking changes:

- Remove obsolete PageSize and PageMargin properties.

### Bug Fixes

- Fixed the issue that error image got displayed instead of smiles while
  loading a pdf file in C1PdfViewer(TFS-137440)
- Fixed the issue that touch is not supported.(TFS-140310)
- Fixed the issue that text cannot be selected when C1Theme is applied
  to PdfViewer.(TFS-116947)
- Fixed the issue that System.FormatException is thrown
  while loading a pdf document in C1PdfViewer.(TFS-141025)

### Improvements:

- Add support for searching text asynchronously. (TFS-129764)
  1. Type any text in TextBox in toolbar.
  2. A "Searching..." popup would be shown.
  3. Search it in the content of the page one by one from the current page to the
  end page. Searching is stopped once the text is found. If the text is not found
  by the end page, search it from the first page to the current page.
  4. Close the popup and Hightlight the found text.
  5. Search the text in the left pages.
  6. After search in the whole pdf file, update the
  FindNumber/FindCount/FindPrevious/FindNext Command.

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed could not add space before table.(TFS-33428)

## C1.WPF.TileView

### Bug fixes

- Fixed the issue that ButtonBackground and ButtonForeground properties
  have no effect.(TFS-30039)

## C1.WPF.Toolbar

### Bug Fixes

- [C1Toolbar] Fixed the issue that Selected tab item of c1Toolbar is not retained
  after C1ToolBar is collapsed expanded.(TFS-28961)
- [C1Toolbar] Fixed the issue that Seconditem is not selected after collapsed
  c1Toolbar is expanded when setting IsSelectable of firstitem to False.(TFS-30885)

# Release version 4.0.20153.497 - 12/24/2015

## C1.WPF.PdfViewer

### Improvements:

- Added Hungarian and Slovenian resources.

## C1.WPF.ReportViewer

### Improvements:

- Added Hungarian and Slovenian resources.

# Release version 4.0.20153.496 - 12/23/2015

## C1.WPF.Docking

### Bug Fixes:

- Correct Japanese strings for some tooltip of MakeDocked, MakeHidden,
  MakeSliding, Sliding.(TFS-39123)

## C1.WPF.Pdf

### Bug Fixes

- Correct Product name of Pdf assembly.(TFS-45766)

# Release version 4.0.20153.495 - 12/14/2015

## C1.WPF.FlexGridFilter

### Improvements:

- Added support to filter child rows.(TFS-112847)
  Note: 1. The type of child rows must be ICollectionView.
  2. Please don't use the same Binding name for parent and child.
  For example:
  public class SalesPerson
  {
  public string PersonName { get; set; }
  public ICollectionView Children { get; set; }
  }
  public class Sales
  {
  public string SaleName { get; set; }
  }
  (PersonName,SaleName) Name should not be the same, if they are all "Name",
  can not distinguish them and don't know which name should be filtered.
  3. The current version does not support sort.

# Release version 4.0.20153.493 - 11/30/2015

## C1.WPF

### Bug fixes

- [C1TreeView] Fixed the issue that Application freezes while expanding a
  node which is having 10000 child items.(TFS-123618)
- [C1NumericBox] Fixed the issue that cursor position is wrong when
  C1DataGridNumericColumn enter into edit mode. (TFS-97762)

## C1.WPF.DataGrid

### Bug fixes

- Fix issue that SourceUpdated event of C1DataGrid can't fire correctly(Tfs 138578)

## C1.WPF.Extended

### Improvements

- [C1PropertyGrid] Provide support for DataAnnotations with the DisplayAttribute's
  GroupName and AutoGenerateField in C1PropertyGrid.(TFS-93552)

## C1.WPF.Olap

### Bug Fixes

- Fixed the issue that printing the Report for an OLAP chart does not
  display legend colors on the printout. (TFS-95417)

# Release version 4.0.20153.492 - 11/23/2015

## C1.WPF

### Improvements

- [C1RadialMenu] Add CollapseOnClick property for
  C1RadialMenuItem to indicate if the menu will auto collapse when the user clicks on
  item which has no child items.

## C1.WPF.BarCode

### Improvements

- Add Save(Stream stream, ImageFormat imgFormat) to save C1BarCode as Image.(TFS-119864)

## C1.WPF.DataGrid

### Bug fixes

- NullReferenceException is thrown while setting DataGridColumnValues as ItemSource
  of a ComboBox (Tfs 136883).

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that last C1DockTabItem disappears
  when it is dragged out and drop on the inner picker into the original
  C1DockControl. (TFS-135038)

## C1.WPF.Excel

### Bug fixes

- Image and CheckBox is not retained when the Excel file containing
  check box and image is saved. (TFS:136880)
- C1Excel incorrect loaded/saved hyperlink ("Cannot open the specified file.")
  (TFS:136722)

### Improvements

- Added new C1XLBook.ListSeparator property for using in methods C1XLBook.Load
  (for .cvs files), XLSheet.LoadCsv and XLSheet.SaveCsv.

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that content will go to next line when press
  space key in C1RichTextBox.(TFS-136732)

# Release version 4.0.20153.489 - 10/31/2015

## C1.WPF.Excel

### Bug fixes

- Cell range is NOT selected when cell range with Frozen row/col is
  selected in C1Excel book. Regression issue. (TFS:30427)

## C1.WPF.Theming

### Improvements:

- Add support for native MS Ribbon controls and native MS Window in
  Cosmopolitan, CosmopolitanDark, Office2013DarkGray, Office2013LightGray,
  Office2013White themes.

# Release version 4.0.20153.487 - 10/27/2015

## C1.WPF

### Breaking changes

- [C1ListViewer] BringIndexIntoView method second parameter "subOffset" default value
  is set to null, and second parameter "subOffset" is nullable now. The same in its'
  derived controls C1ListBox/C1TileListBox.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Removed unnecessary WPFWindow from ToolBox in VS2010.

## C1.WPF.Excel

### Bug fixes

- NullReferenceException is thrown when loading an excle file
  which contains macro with .xlsx/.xls format. (TFS:135360)

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that one column can be selected and deleted if C1FlexSheet
  has no rows(TFS-130816).
- Removed unnecessary SortDialog, PageTemplate, GridSplitter,
  ExcelFilterEditor, NewSheet, Sheet, ExcelContextMenu, SheetContextMenu from
  ToolBox in VS(TFS-135196).
- Fix issue that cell values entered at run time are disappeared after exporting
  with PDF format(TFS-135315).
- Fix issue that no AboutBox link in contextmenu of C1FormulaBar (TFS-135471).
- Fix issue that resizing inserted image is not retained in printed PDF file
  (TFS-131461).

## C1.WPF.Olap

### Bug Fixes

- Fixed the issue that collapsed group columns are expanded when click on
  any column header. (TFS-128608)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that watermark image of pdf document is replaced with red cross
  mark while loading in C1PdfViewer.(TFS-129639)
- Fixed the issue that more than one page is moved while clicking the Next Page button
  of C1PdfViewerToolbar.(TFS-132707)
- Fixed the issue that System.NullReferenceException is thrown while loading a pdf
  document in C1PdfViewer.(TFS-135478)

# Release version 4.0.20153.486 - 10/21/2015

## C1.WPF.Excel

### Bug fixes

- Unable to read all data from Excel file. (TFS:134318)
- Format is changed after load and save by C1Excel. (TFS:134884)
- Specified hyperlink issues for complex sheet names. (TFS:134586)
- Specified background pattern for the ConditionalFormatted cells
  is not saved. (TFS:127975)
- Header and footer image is not displayed when setting header
  and footer image by using C1Excel. Regression of TFS:121907. (TFS:127155)
- Postion of Custom Header (Image) is changed when saving an
  excel file using C1Excel. Really image moved from page header to sheet. (TFS:121907)
- When loaded .xlsx that fixed Column/Row is set and active cell
  is set into fixed Column/Row, saved .xlsx is incorrect. (TFS:120427)
- In loaded xlsx file, Index of print title cannot get by
  GetRangeToRepeat method. (TFS:119851)
- Line Color of Header and Footer image is not retained in
  output excel file when saving as OpenXML format. (TFS:116520)
- Header and Footer images disappear in output excel
  file [regression for 43]. (TFS:116260)
- When set neutral culture to CurrentUICulture property, error
  occurs on code for genarate C1XLBook object. (TFS:115908)

### Improvements

- Added support of OpenXMLMacro format (Open XML format with support
  VBA projects, *.xlsm extension).

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that nullReferenceException occurs when exporting FlexSheet with
  no data to PDF format(TFS-131450).

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue NullReferenceException occurs when navigating "Formatting"
  page of RichTextBoxSamples on Windows 10.(TFS-134456)

# Release version 4.0.20153.483 - 09/28/2015

## C1.WPF.DataGrid

### Bug fixes

- Fix issue that alternatingRows are disorder after change rows Visibility(Tfs 125936).

## C1.WPF.DataGrid.Summaries

### Bug fixes

- Fix issue that text in the group row hides while scrolling the C1DataGrid horizontally.
  (TFS-130686)

## C1.WPF.Schedule

### Bug Fixes:

- InvalidCastException occurs when trying to open Appointment Dialog
  in WPF Browser Application (Tfs 131459).

### Improvements:

- Added C1Scheduler.SmallVisualIntervalScale property.
  If this property value is set, defines TimeSpan of each VisualInterval
  in the VisualIntervals collection for views with intervals shorter
  than 1 day (Day, WorkWeek, Week and TimeLine). This is a dependency property.
  The default value is TimeSpan.Zero which means that only
  C1Scheduler.VisualIntervalScale property has effect.

# Release version 4.0.20152.480 - 09/14/2015

## C1.WPF

### Bug fixes

- [C1TabControl] Fixed the issue that HeaderTemplate doesn't work.(TFS-130609)

## C1.WPF.FlexGrid

### Bug fixes

- Fix the issue that all rows are not printed while setting the MaxRowHeight
  property of C1FlexGrid.(TFS-130376)

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that ArgumentOutOfRangeException occurs when click Copy/Cut
  command in ContextMenu if C1FlexSheet has no rows or no columns(TFS-129246).

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed NulLreferenceException.(TFS-129568)

# Release version 4.0.20152.479 - 08/27/2015

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that in custom regional settings , value in Zoom combobox is not
  changing when zooming with Ctrl+Mouse Wheel.(TFS-128825)

# Release version 4.0.20152.478 - 08/26/2015

## C1.WPF.Extended

### Bug fixes

- [C1PropertyGrid] Fixed the issue that "AmbiguousMatchException" is thrown
  when C1Maps object is set to SelectedObject property of C1PropertyGrid.(TFS-29838)
- [C1PropertyGrid] Fixed the issue that "AmbiguousMatchException" occurs
  on opening "Items" collection editor in C1PropertyGrid at run-time.(TFS-30025)
- [C1PropertyGrid] Fixed the issue that "AmbiguousMatchException" occurs
  when setting SelectedObject property of C1PropertyGrid to C1FlexSheet.(TFS-128569)
- [C1PropertyGrid] Fixed the issue that "AmbiguousMatchException" is
  thrown on clicking the collection editor button for Items collection when
  bounded with C1Menu.(TFS-128589)

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that FlexGrid/Chart license check for repeating instances in the same app
  domain in flexsheet(TFS-127448).

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that nullReferenceException occurs when navigating pages on PdfViewer
  with Pdf file with Annotations.(TFS-128223)

# Release version 4.0.20152.477 - 08/18/2015

## C1.WPF

### Bug fixes

- [C1TileListBox] Fixed the issue that C1TileListBox re-renders when the window
  is resized.(TFS-125812)
- [C1DropDownButton] Fixed the issue that "HeaderFontSize", "HeaderFontStyle"
  and "HeaderFontWeight" properties do not work in C1DropDownButton.(TFS-41775)

## C1.WPF.Chart

### Bug fixes

- Fixed the issue that "No types are available for you to add to this
  collection" message box is shown when trying to add ChartView to C1Chart.(TFS-116988)

## C1.WPF.DataGrid

### Bug fixes

- Fix issue that even if all checks are removed separately by filter operation of
  C1AdvancedFiltersBehavior, a check of "Select All" doesn't come off (Tfs 126304).
- Fix issue that Select All checkbox in filter dropdown does not reflect the current
  state of checkboxes in filter dropdown (Tfs 15864).
- Fix issue that if the cell of a filtering target column is selected after displaying
  a filter dialog, the dialog will be hidden, but a drop-down arrow will be shown at
  the header of column concerned(Tfs 126329).

## C1.WPF.Extended

### Improvements

- [C1PropertyGrid] Provide support for Attached properties in
  C1PropertyGrid.(TFS-117004)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that pencil marks are not shown in C1PdfViewer.(TFS-122450)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that can not enter two "Thai" vowels consecutively
  in C1RichTextBox.(TFS-118741)

## C1.WPF.Theming

### Bug Fixes:

- Fix the issues that setting ExpandDirection=Right of C1Expander throws
  a System.InvalidOperationException.(TFS-125893)

# Release version 4.0.20152.476 - 08/03/2015

## C1.WPF.Olap

### Improvements

- Provide feature for collapse/extend all the subtotals.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that memory leak with C1PdfViewer in pdfviewer sample.(TFS-70722)
- Fixed the issue that memory Leak observed in C1PDFViewer.(TFS-98440)
- Fixed the issue that OutOfMemoryException is raised on a Phone Device.(TFS-98716)
- Fixed the issue that memory Leak observed with C1PdfViewer while loading multiple
  documents.(TFS-118262)

# Release version 4.0.20152.475 - 07/20/2015

## C1.WPF.Chart

### Bug fixes

- Fixed the issue that Y axes are not displayed on setting PlotArea Background/Stroke
  properties.(TFS-72815)
- Fixed the issue that multiple X axes are not rendered correctly with multiple
  Plot Areas.(TFS-122727)

## C1.WPF.FlexGrid

### Bug fixes

- Fix the issue that few columns are not highlighted with SelectionMode is
  ListBox if some columns are hidden.(TFS-122659)

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that system.NullReferenceException occurred when setting
  EnableColumnFilters to FALSE(TFS-124019).

# Release version 4.0.20152.473 - 07/07/2015

## C1.WPF

### Bug fixes

- [C1RadiaMenu] Fixed the issue displays text rotated with
  certain culture settings.(TFS-123008)

## C1.WPF.BarCode

### Bug fixes

- Fixed the issue that Code49 barcode is distorted while BarCode text is greater
  than 271 characters.(TFS-123302)
- Fixed the issue that "Error in the application" is shown when applying of
  StructuredNumber in DataMatrix BarCode.(TFS-123374)

## C1.WPF.Extended

### Improvements

- [C1Rating] First release.

## C1.WPF.FlexGrid

### Bug fixes

- Fix the issue that fatal error occurs when entering Japanese characters with
  Office IME 2010.(TFS-122345)
- Fix the issue that incorrect Cell Navigation when setting FlowDirection to
  "RightToLeft".(TFS-109547)

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that although "AutoGenerateColumns" is set as False and "ItemSource"
  property is set, columns are automatically created at run time(TFS-121666).
- Fix issue that selection still shown in inserted chart, picture although focus
  is set in other place(TFS-121425).
- Fix issue that although AllowSorting is set "TRUE", sorting on FlexSheet cannot
  be performed when clicking the column header of cells.(TFS-121797).
- Fix issue that ArgumentOutOfRangeException occurs on switching sheet from other
  sheet after entered into edit mode(TFS-122860).

## C1.WPF.Olap

### Bug Fixes

- Fixed the issue that all data fields in OlapPanel are disappeard when press
  "Undo" button.(TFS-122647)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that cursor remains on the right edge when typing
  in Hebrew language.(TFS-122039)

## C1.WPF.Theming

### Bug Fixes:

- Fix the issues that flexsheet editing cell cannot be seen while opening
  ContextMenu when C1Office2007Black theme is applied.(TFS-122528)

# Release version 4.0.20152.472 - 06/29/2015

## C1.WPF

### Bug fixes

- [C1TileListBox] Fixed the issue that BringIndexIntoView method does not works
  correctly.(TFS-111201)

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that argumentNullException occurs on switching filter applied tab
  with ObservableCollection from other tabs(TFS-121646).
- Fix issue that nullReferenceException occurs on clicking expand/collapse icon
  when grouping is applied with CollectionViewSource(TFS-121664).

## C1.WPF.Olap

### Bug Fixes

- Fixed the issue that items in the OlapPanel piles up while changing the
  Olap Cube dynamically.(TFS-120897)

## C1.WPF.Theming

### Bug Fixes:

- Fix the issues that the C1.WPF.FlexGrid.ColumnFilterEntry is shown in dropdown
  items of "Condition" filter after applying C1ThemeBureauBlack.(TFS-119245)
- Fix the issues that xamlParseException occurs when any C1Themes are applied
  to controls.(TFS-121781)

# Release version 4.0.20152.471 - 06/22/2015

## C1.WPF.BarCode

### Breaking changes

- Change Code128Options property to Ean128Fnc1Options and Change Code128Options
  class to Ean128Fnc1Options.
- Change the type of ModuleSize from ModuleSize to int, and this property represents
  the Width of the narrow bar in screen pixels.

## C1.WPF.DataGrid

### Bug fixes

- BottomRow shows a validation error while validating the last row in C1DataGrid (Tfs 120855).

## C1.WPF.FlexGrid

### Bug fixes

- Fix the issue that PrintPreveiw of C1FlexSheet does not shown correct selection
  after Scrolling while 'Selection' ScaleMode is used.(TFS-111573)

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that message box is not localized to Japanese/Spain/Portuguese
  strings.(TFS-119692)
- Fix issue that blank row is observed in Context Menu of C1FlexSheet.(TFS-109852)
- Fix issue that sortDialog of FlexSheet can not be moved by mouse dragging at
  runtime.(TFS-110244)
- Fix issue that gridLines are lost in C1FlexSheet while binding with
  ItemsSource by using _flexSheet.AddSheet() method.(TFS-110774)
- Fix issue that applied gourping/outlines is not exported to .xls/.xlsx.(TFS-111248)
- Fix issue that adding of comment in the cell of LastColumn, comment box is
  not shown in visible screen.(TFS-111513)
- Fix issue that line feeds comments are not shown starting from 1st Line in
  CommentBox of C1FlexSheet.(TFS-111535)
- Fix issue that applied filter is not saved in FilterDropdown after swictching
  the tabs.(TFS-114286)

## C1.WPF.Olap

### Bug Fixes

- Fixed the issue that error occurs in WPF Browser Application when trying to
  show context menu.(TFS-121195)
- Fixed the issue that icon sizes from Context menu get small if open context
  menu by using "Shit+F10" keys.(TFS-93707)

# Release version 4.0.20152.467 - 06/05/2015

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that although ShowSingleTab=True, tab strip is not shown when
  FlexSheet has only one sheet(TFS-118996)

# Release version 4.0.20152.465 - 05/24/2015

## C1.WPF.FlexSheet

### Improvements

- Add EditOptions,ShowSingleTab,TabItemShape properties for C1FlexSheet.

# Release version 4.0.20152.463 - 05/23/2015

## C1.WPF.Schedule

### Improvements:

- Added C1Calendar.SelectionMode property(TFS-117732).
  The default value is SelectionMode.Extended, it keeps the same behavior as in previous released versions.
  SelectionMode.Multiple allows the user to select multiple items without pressing a modifier key.
  Note, even if this property value allows to select multiple items, the actual number of selected days
  might be limited by the value of the MaxSelectionCount property.

# Release version 4.0.20151.468 - 06/12/2015

## C1.WPF

### Bug fixes

- [C1MessageBox] Fixed the issue that C1MessageBox loses focus sometimes and
  background controls can be interacted.(TFS-117235)
- [C1HyperlinkButton] Fixed the issue that When set the "IsTabStop"
  property to "False", it also gets the focus.(TFS-118732)
- [C1HyperlinkButton] Fixed the issue that Command Binding is not working.
  (TFS-118511)

## C1.WPF.BarCode

### Breaking changes

- Change property LineStrokThickness to LineStrokeThickness in Code25intlvOptions.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that Layout of C1DockControl is not
  preserved.(TFS-100166)

## C1.WPF.FlexGrid

### Bug fixes

- Fix the issue that argumentOutOfRangeException occurs when copying the chart in
  C1FlexSheet.(TFS-119055)

## C1.WPF.FlexGridFilter

### Bug Fixes

- Fix issue that filterDialog of C1FlexSheet opens away form it's concerned
  column.(TFS-111673)

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that applied Custom SheetName is not affected to the C1FlexSheet
  at run time.(TFS-110771)
- Fix issue that contextMenu of cell is shown while right clicking on
  SheetNavigation button.(TFS-111229)
- Fix issue that deleting the first character of one cell also removed the
  whole cell.(TFS-119683)

## C1.WPF.Olap

### Improvements

- Public OlapCellFactory so that customer can custom CellFactory for
  OlapGrid base on the OlapCellFactory. (TFS-120027)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that HTML contents does not renders correctly in
  C1RichTextBox.(TFS-116758)

# Release version 4.0.20151.466 - 05/25/2015

## C1.WPF

### Bug fixes

- [C1NumericBox] Fixed the issue that leading zero is removed while
  editing. (TFS-98620)

## C1.WPF.BarCode

### Improvements

- Add localization for BarCode exceptions.

## C1.WPF.DataGrid

### Bug fixes

- Background of GroupWithSummaryRow is not working (Tfs 118508).

## C1.WPF.FlexGrid

### Improvements

- added RowCol.VisibleIndex property. This property is read-only.
  If element's IsVisible property is True, VisibleIndex property returns index of
  element in the collection of visible items.

# Release version 4.0.20151.462 - 05/11/2015

## C1.WPF.BarCode

### Breaking changes

- Change the members of QRCodeErrorLevel from L, M, Q, H to Low, Medium, Quality, High.
  And update the values of these members from 1, 0, 3, 2 to 0, 1, 2, 3.

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that System.NotSupportedException was unhandled when
  adding improper file from "Insert Image" dialog of RichTextBoxToolBar.(TFS-117116)

# Release version 4.0.20151.461 - 05/05/2015

## C1.WPF.DataGrid

### Bug fixes

- use proper default overrides for dependency properties (Tfs 116746).

## C1.WPF.Schedule

### Improvements:

- honor Escape key at in-place appointment editing (Tfs 116276).

# Release version 4.0.20151.460 - 04/27/2015

## C1.WPF

### Bug fixes

- [C1Menu] Fixed the issue that setting 'IsEnabled' to false
  on button click does not visually disable C1MenuItem.(TFS-100109)

## C1.WPF.Excel

### Improvements

- Merge changes of WinForms 44 build.

## C1.WPF.Schedule

### Improvements:

- improved keyboard navigation in the C1Scheduler control:
- F2 key turns on in-place appointment editing for selected appointment;
- Enter key creates new in-place appointment or opens appointment dialog for existent selected appointment;
- Tab (Shift-Tab) key navigates selection and keyboard focus to the next (previous) appointment in the current view.
- better support for C1.WPF.Theming in embedded dialogs.
- [SL] added C1Scheduler.ShowNavigationPanels property.

# Release version 4.0.20151.459 - 04/13/2015

## C1.WPF

### Bug fixes

- [C1NumericBox] Fixed the issue that FormatException occurs on setting
  Decimal("D") Format in C1NumericBox.(TFS-113928)

## C1.WPF.DataGrid

### Bug fixes

- Cell validation adorner wasn't shown when tabbing among cells.

## C1.WPF.FlexGrid

### Bug fixes

- Fix the issue that last Column of C1FlexGrid is not visible completely while
  setting "VerticalScrollBarVisibility = Visible".(TFS-114739)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that incorrect behavior observed with "FindText" in case of a
  specific PDF Document.(TFS-109133)

# Release version 4.0.20151.458 - 03/30/2015

## C1.WPF

### Bug fixes

- [C1ComboBox] Fixed the issue that TabIndex property does not work in the
  specified TabIndex sequence.(TFS-113355)
- [C1ComboBox] Fixed the issue that C1ComboBox does not conform to TabIndex
  settings.(TFS-113593)
- [C1Menu] Fixed the issue that hot keys not working with C1MenuItem.(TFS-113278)

### Improvements

- [C1RadialMenu] Honor C1RadialMenuItem.ItemTemplate property
  (http://our.componentone.com/groups/topic/radial-menu/#post-656932).

## C1.WPF.Excel

### Bug fixes

- Request to provide the property similar to ‘Scale with document’ available
  under Header/Footer tab in PageSetup dialog in MSExcel. (TFS:39819)

## C1.WPF.FlexGrid

### Bug fixes

- Fix the issue that can't re-size the column of C1FlexGrid at run time.(TFS-112908)
- Fix the issue that hidden cells are copied when a range containing them is copied
  using Ctrl + C.(TFS-41714)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that pageNumberChanged event not fired when ToolbarVisibility
  property is set to Collapsed.(TFS-111374)

### Improvements:

- Add MaxZoom and MinZoom properties.

# Release version 4.0.20151.455 - 03/13/2015

## C1.WPF.FlexGrid

### Bug fixes

- Fix the issue that rows cannot be dragged and dropped in C1FlexGrid Unbound
  mode(TFS-111903)

## C1.WPF.Schedule

### Improvements:

- added support of Cosmopolitan, Office2010, Office2013 and other themes included into C1.WPF.Theming.XXX assemblies.
  To apply theme, set C1Scheduler.Theme property to the theme's ResourceDictionary:
  var theme = new C1ThemeBureauBlack();
  sched1.Theme = theme.GetNewResourceDictionary();

# Release version 4.0.20151.454 - 03/09/2015

## C1.WPF.FlexGrid

### Improvements

- Drag improved. Add DragDropIndicatorBrush property to get or set the brush
  of drop indicator when drag columns or rows.

## C1.WPF.FlexSheet

### Bug fixes

- Fix issue that system.NullReferenceException occurred in C1.WPF.FlexSheet.4.dll,
  while inserting the rows to C1FlexSheet(TFS-111194)
- Fix issue that system.ArgumentOutOfRangeException occurs switching of
  Unbound sheet and DataTable bound sheet(TFS-111257)

# Release version 4.0.20151.453 - 03/02/2015

## C1.WPF

### Improvements

- [C1RadialMenu] Added C1RadialMenu.GoBack method. It navigates menu
  one level up as if end-user clicked Back button (Tfs 101896).

## C1.WPF.DataGrid

### Bug fixes

- C1DataGrid appeared clipped when printing a grid whose Margin property was set through an implicit style.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that words are not getting selected when double clicking on them.
  (TFS-110018)
- Fixed the issue that page is automatically scrolled down when dragging the mouse
  on Japanese text.(TFS-110063)

## C1.WPF.Theming

### Bug Fixes:

- Fix the issues that the C1Cosmopolitan styles are not applied when
  add ToogleButton in WPF standard toolbar and the InvalidateCaseException will
  be thrown when hovering on drop drown button of WPF standard toolbar.(TFS-107886)

# Release version 4.0.20151.452 - 02/17/2015

## C1.WPF.Chart

### Bug fixes

- Honor AxisScrollbar visibility at layout. (TFS-105717)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that japanese text are not shown in loaded Pdf file.(TFS-109861)

# Release version 4.0.20151.451 - 02/15/2015

## C1.WPF.DataGrid

### Bug fixes

- When ScaleMode is set to 'SinglePage', some columns are cut off in printed grid (TFS 36483).
- DataGridComboBoxColumn honors first key stroke passing the info to the editing element.

## C1.WPF.FlexGrid

### Bug fixes

- Cell values disappears on clicking a cell, if C1Office2013 theme is applied on C1FlexGrid(TFS-105737)
- Fix the issue that AutoSizeFixedRows not working correctly(TFS-95606)

## C1.WPF.FlexSheet

### Improvements

- First release.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that footer text are missing and incorrect logo images are shown
  in C1PDFViewer.(TFS-108798)
- Fixed the issue that some text and circle bullets are shown with square characters
  .(TFS-109128)
- Fixed the issue that hebrew characters are not shown correctly in PdfViewer
  .(TFS-109134)

## C1.WPF.ReportViewer

### Bug Fixes:

- Fixed the issue that NullReferenceException occurs when typing text in search
  box which is loaded *.htm file in C1ReportViewer.(TFS-109283)

# Release version 4.0.20151.449 - 02/09/2015

## C1.WPF.Schedule

### Improvements:

- improved iCal import for reading historical time zones (Tfs 108759).

# Release version 4.0.20143.447 - 02/05/2015

## C1.WPF

### Bug fixes

- [C1TreeView] Fixed the issue that treeViewItem gets into edit mode on
  pressing "F2" on disable item.(TFS-107885)
- [C1NumericBox] Fixed the issue that decimal point cannot enter if Format
  does not contain digital.(TFS-101646)

## C1.WPF.DataGrid

### Bug fixes

- DataGridBoundColumn.IsEditable property now is false when Path or XPath of the column binding is null.

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Background color of top row is not exported to excel sheet (Tfs 98455).
- Unlike previous build, DataGrid's Foreground, RowForeground and AlternatingRowForeground colors are not honored in exported .xlsx file (Tfs 101572).

## C1.WPF.FlexGrid

### Bug fixes

- Fixed the issue that InvalidCastException occurs when using Conditions
  filter type in bounded flexgrid.(TFS-100850)

# Release version 4.0.20143.446 - 02/02/2015

## C1.WPF

### Bug fixes

- [C1TreeView] Fixed the issue that treeView is automatically scrolled up
  after double-click.(TFS-106751)
- [C1TreeView] Fixed the issue that "IsSelected" implicit binding get lost
  on all child nodes when parent treenode is collapsed and expanded.(TFS-106762)
- [C1TreeView] Fixed the issue that selectedItem binding does not work when
  used as EditTemplate.(TFS-106778)
- [C1TreeView] Fixed the issue that combo dropdown is not shown on clicking
  the dropdown icon if used in C1TreeView.(TFS-106789)

## C1.WPF.DataGrid

### Breaking changes

- Changed property type of DataGridAutoGeneratingColumnEventArgs.Column property to DataGridColum.
  To use DataGridBoundColumn.Format property in event handlers, you should cast Column property value to the DataGridBoundColumn type first.

### Bug fixes

- Error is observed on creating a creating a Template column in AutoGenerating event of C1DataGrid.
  Changed property type of DataGridAutoGeneratingColumnEventArgs.Column property to DataGridColum. (Tfs 100083)

## C1.WPF.Excel

### Bug fixes

- Unlike previous build, 'IOException' occurs when saving the Excel file. [WPF, SL] (TFS:106766)
- ArgumentException was unhandled occurred when LoadExcel() is used to opened XLSX file. (TFS:106325)
- Unlike previous build, IOException occurs when saving the excel file with image. (TFS:106879)

## C1.WPF.PdfViewer

### Improvements:

- Support open type font.
- Add RenderMode property. It has two value(Default,
  Extended). Extended mode is a special mode to render all text in pdf with microsoft
  textblock. It is used in 2 cases: 1. must set RenderMode to Extended before using
  BlackoutWords property. 2. try to use Extended mode when texts are not rendered
  properly.

## C1.WPF.ReportViewer

### Improvements:

- Support open type font.

## C1.WPF.SpellChecker

### Improvements

- Added localized resources for the cultures:
  -- Swedish(sv)
  -- Norwegian(no)
  -- Hebrew(he)
  -- Finnish(fi)
  -- Danish(da)
  -- Arabic(ar)

# Release version 4.0.20143.445 - 01/26/2015

## C1.WPF

### Bug fixes

- [C1TreeView] Fixed the issue that NullReferenceException occurs when
  pressing 'Enter' key after pressing 'Tab' key if IsVirtualizing=True.(TFS-105916)
- [C1TreeView] Fixed the issue that ArgumetOutOfRangeException occurs when
  TreeViewItem is clicked after removing an record from underlying data source if
  HierarchicalDataTemplate is used.(TFS-105946)
- [C1TreeView] Fixed the issue that item selection gets lost after new item
  is added to the underlying data source.(TFS-106415)
- [C1TreeView] Fixed the issue that ArgumetOutOfRangeException occurs on
  clicking C1TreeViewItem after node drag drop.(TFS-106420)

## C1.WPF.BarCode

### Improvements

- First release.

## C1.WPF.Excel

### Bug fixes

- Fix exception 'out of memory exception' at write C1XLBook directly to the disk. (TFS:36268)
- Unlike previous build, 'System.NotSupportedException' is thrown when loading
  an excle file which contains macro (.xlsx format). (TFS:105927)

### Improvements

- Added tempary file storage for WPF and SL versions. In WPF using
  tempary file storage by default, for SL is need use UseTempStorage property.
- Merge changes of WinForms 22 build.

## C1.WPF.Olap

### Improvements

- Added async processing for data update.

# Release version 4.0.20143.444 - 01/19/2015

## C1.WPF

### Bug fixes

- [C1Window] Fixed the issue that C1Window will get dimmed when lose focus if
  it is shown as a modal window.(TFS-100857)
- [C1TreeView] Fix issue that ArgumentOutOfRangeException occurs on clicking
  the treeview item after an item is removed from the underlying data source.
  (TFS-101384)
- [C1TreeView] Fixed the issue that Fix the issue that NullReferenceException
  occurs when pressing Keyboard shortcut if IsVirtualizing="True".(TFS-100528)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that input values are not displayed in pdf controls.(TFS-101915)
- Fixed the issue that IndexOutRangeException occurs when Pdf with Graphic objects
  are loaded into C1PdfViewer.(TFS-101976)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that font size/style are not consistently maintained when HTML
  file is loaded and modified.(TFS-100541)

## C1.WPF.RichTextBox.Toolbar

### Improvements

- added localized resources for the cultures partly:
  -- Slovenian(sl, sl-SI)
  -- Hungarian(hu, hu-HU)

# Release version 4.0.20143.443 - 01/05/2015

## C1.WPF.Chart

### Bug fixes

- Fixed the issue that AnnoCreated event does not been fired. (TFS-97330)

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that DockTab's width cannot be maintained
  when dragging the Splitter bar after changing the floating mode.(TFS-98902)
- [C1DockControl] Fixed the issue that Tab Key does not work on
  C1DockTabControl when it is in floating state.(TFS-100155)

## C1.WPF.Excel

### Bug fixes

- Exception (can't access cross-thread) thrown when loading Excel in a child thread. [SL] (TFS:98145)
- Deleteing Column that includes final cell in a merge does not reduce merge. Fixed part 2. (TFS:90131)
- C1XLBook.Save performance is decreased in build 14 compare to build 11. (TFS:98333)
- Cell's Border Color is changed when saving excel file. (TFS:84854)
- ArgumentException is thrown when an Excel file is loaded in C1XLBook [Fixed only exception]. (TFS:97861)
- Exception (can't access cross-thread) thrown when loading Excel in a child thread. [SL] (TFS:98145)
- #VALUE! is shown in the cell which has ROUNDDOWN formula as Biff8 format. (TFS:85358)

### Improvements

- Merge changes of WinForms 20 build.

## C1.WPF.SpellChecker

### Breaking changes:

- Removed AutoReplaceList property, OnAutoReplace method,
  AutoReplace event, AutoReplaceEventArgs and AutoReplaceEventHandler because they
  are not used.

# Release version 4.0.20143.442 - 12/22/2014

## C1.WPF

### Bug fixes

- [C1RadialMenu] Fix issue that XamlParseException is thrown while applying theme
  to the C1RadialMenu.(TFS-92278)

## C1.WPF.FlexGrid

### Bug fixes

- Fixed the issue that translated values are not copied into Clipboard
  when ValueConverter is used.(TFS-98602)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that Chinese Characters are not displayed correctly in the
  Bookmark contents of the loaded PDF File.(TFS-94567)
- Fixed the issue that Hebrew support in C1PDFViewer.(TFS-90240)
- Fixed the issue that Displays PDF file incorrectly black background.(TFS-95627)
- Fixed the issue that Page navigation does not work when clicking on the links in
  c1PdfViewer.(TFS-98681)

# Release version 4.0.20143.440 - 12/17/2014

## C1.WPF.FlexGrid

### Bug fixes

- Fixed the issue that square brackets are automatically added to the column
  header after data binding (TFS-98564).

# Release version 4.0.20143.439 - 12/17/2014

## C1.WPF.FlexGrid

### Bug fixes

- Fixed the issue that checkboxes are not shown in the column of boolean data
  type(TFS-98497).

# Release version 4.0.20143.438 - 12/11/2014

## C1.WPF

### Bug fixes

- [C1TreeView] Fixed the issue that pressing navigation
  keys does not work after pressing "Delete" key.(TFS-97867)
- [C1TreeView] Fixed the issue that ContextMenu is shown
  when pressing contextmenu key from keyboard in c1treeview.(TFS-97957)

# Release version 4.0.20143.437 - 12/10/2014

## C1.WPF

### Bug fixes

- [C1TreeView] Fixed the issue that keyboard navigation stop working after
  pressing space key.(TFS-97578)

## C1.WPF.FlexGrid

### Bug fixes

- Fixed the issue that string values are not shown in the filter drop down list.

# Release version 4.0.20143.436 - 12/08/2014

## C1.WPF

### Bug fixes

- Allows setting String.Empty in objects whose property type is Nullable<T> where T != string.
- [C1ComboBox] Fixed the issue that if set IsDropDownOpen to true in
  C1ComboBox's GotFocus event, the StackOverFlowException will be thrown when
  focus out C1ComboBox.(TFS-95426)
- [C1TreeView] Fixed the issue that keyboard navigation stop working if
  ItemTemplate binding is set.(TFS-97543)

## C1.WPF.Chart

### Bug fixes

- added property name to event arguments for Axis.PropertyChanged event. (TFS-86886)

## C1.WPF.FlexGrid

### Bug fixes

- checkbox on merged cells are not displayed correctly after sorting the grid
  when checkbox values are filled by Spacebar key.

## C1.WPF.Maps

### Improvements:

- Added support for ShapeFile format to C1Maps.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that some texts and images are not displayed correctly in
  c1PdfViewer.(TFS-95520)
- Fixed the issue that some japanese texts are not rendered correctly in
  c1PdfViewer.(TFS-96786)

## C1.WPF.Schedule

### Bug Fixes:

- improved performance when when working with long-lasting appointments (Tfs 95610).

# Release version 4.0.20143.435 - 11/24/2014

## C1.WPF.Automation

### Bug fixes

- Fixed the issue that RuntimeBinderException is raised on using Coded UI Test
  generator to record the action of clicking the Tab.(TFS-95048)

## C1.WPF.DataGrid

### Bug fixes

- Row.DataItem is null in CommittedNewRow event.

## C1.WPF.Olap

### Bug Fixes

- Fixed the issue that exceptions are observed when move field from "Columns"
  or "Values" field to "Filters" field in "CubeAnalysis" sample.(TFS-94253)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue first character is rendered in extremely small font size
  when RTF file is loaded.(TFS-95167)

## C1.WPF.Schedule

### Improvements:

- added support for RECURRENCE-ID, SEQUENCE and UID in iCal import (TFS:91112).
  Note, cases when RECURRENCE-ID is a recurring event are not supported.

# Release version 4.0.20143.434 - 11/12/2014

## C1.WPF.DataGrid

### Bug fixes

- Selection was lost after removing a row if the grid is grouped.

# Release version 4.0.20143.432 - 11/11/2014

## C1.WPF.DataGrid

### Bug fixes

- Selection was lost after removing a row.

## C1.WPF.FlexGrid

### Bug fixes

- Row was not invalidated correctly when moving it to the last position by dragging its header.

# Release version 4.0.20143.431 - 11/09/2014

## C1.WPF.FlexGrid

### Bug fixes

- Getting values from cells was raising an exception when the data source used indexed properties.

## C1.WPF.Pdf

### Bug Fixes

- Fix the issue that unlike previous build, extra unknown character is
  shown when C1RichTextBox is exported to Pdf (TFS-93907)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that NullReferenceException is raised on calling the
  CloseDocument method of C1PDFViewer when its Visibility is set to 'Collapsed'.
  (TFS-93886)

# Release version 4.0.20143.430 - 11/06/2014

## C1.WPF

### Breaking changes

- Added new AboutBox logic and display.
- Implemented new evaluation version logic. The new logic restricts
  evaluation installs to 30 days.

## C1.WPF.FlexGrid

### Bug fixes

- Setting a non convertible value was raising an exception.
- Evaluating a path with a numeric indexer was not returning the right value.
- Pasting values was not working fine in numeric and boolean columns.
- Resizing rows was not working correctly.
- Auto-sizing columns was not working correctly when there was merged cells.

## C1.WPF.Olap

### Bug Fixes

- Fixed the issue that grid lines are showed when "Show Gridlines" property is
  set to false in OlapChart.(TFS-91662)
- Fixed the issue that ArgumentNullException throws when adding Rows through
  "Row Collection Editor: Rows".(TFS-92573)
- Fixed the issue that NullReferenceException thrown when GroupAxisAnnotation
  property is set to true and open OlapChart at the run time.(TFS-91703)
- Fixed the issue that 'Exception is observed when open 'Miscellaneous' dropdown
  in 'Properties' grid after drag and drop OlapChart on form.(TFS-93715)
- Fixed the issue that "Detail View" grid does not show when right click
  over cell in OlapGrid.(TFS-93712)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that ZStreamException occurs when pdf file containing Graph
  and Images is loaded.(TFS-93428)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that the font dropdown(s) is empty on initial load if the
  Html property contains an empty string.(TFS-90817)

## C1.WPF.Schedule

### Bug Fixes:

- fixed issue with occasionally not firing AppointmentChanged event at drag&drop operations (Tfs 93042).

# Release version 4.0.20143.428 - 11/03/2014

## C1.WPF

### Bug fixes

- [C1RadialMenu] Fixed the issue that XamlParseException is thrown while applying
  theme to the C1RadialMenu.(TFS-92278)

## C1.WPF.DataGrid

### Bug fixes

- Avoid changing selection while current item changes, to prevent conflicts with selection mode.

## C1.WPF.FlexGrid

### Bug fixes

- Setting enum values as string was raising an exception.
- Allows binding DataTable with column names containing "." and ",".

## C1.WPF.Pdf

### Bug Fixes

- [C1FlexGrid][MultiGridPdf Sample] Unlike SL FlexGrid,checkboxes are not shown
  when saving multi grid as pdf file (TFS 91698).
- Unlike C1RichTextBox, ArgumentNullException occurs when DrawElement method is
  invoked on the instance of C1RichTextBoxToolbar control (TFS 92255).

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that search occurrence count is not displayed correctly when
  find action is applied in c1PdfViewer.(TFS-92944)

# Release version 4.0.20143.427 - 10/27/2014

## C1.WPF.DataGrid

### Bug fixes

- Exception thrown when dragging a frozen column and another frozen column is hidden.

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Height of the rows was incorrect when grid wasn't scrolled previously.
- DataGridColumnHeaderRow wasn't exported to excel

## C1.WPF.Excel

### Bug fixes

- Fixed unlike previous build,NotSupportedException was handled when loading .xlsx file. (TFS:91513)

## C1.WPF.FlexGrid

### Bug fixes

- Setting values was throwing an exception when underlying type was Enum and the value was a string.

## C1.WPF.FlexGridFilter

### Bug Fixes

- Executes the column converter when filtering using a text filter.

## C1.WPF.Olap

### Bug Fixes

- Fixed issue that auto scrollbar position and displayed chart Y axis data are
  not consistent.(TFS-91656)

## C1.WPF.Pdf

### Bug Fixes

- Fixed the issue that Text are not shown when exported to pdf.(TFS-92269)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that "GoToPage" method does not work.(TFS-91078)
- Fixed the issue that oversubscribed dynamic bit lengths tree exception occurs on
  opening PDF File.(TFS-89062)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that a portion of the copied text gets pasted inside
  the C1RichTextBox even on setting the CliboardEventArgs.Handled property
  to "True".(TFS-89152)

## C1.WPF.Toolbar

### Bug Fixes

- [C1Toolbar] Fixed the issue with incorrect element size when expanding
  toolbar window.(TFS-91760)

# Release version 4.0.20143.425 - 10/21/2014

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that images and tables are not rendered correctly
  in C1RichTextBox.(TFS-88732)

# Release version 4.0.20143.424 - 10/15/2014

## C1.WPF

### Breaking changes

- extension methods for System.Type have been moved from the Extensions class to the TypeEx class.

### Improvements

- Added new C1ProgressIndicator control.
- extension methods for System.Type have been mpved from the Extensions class to the TypeEx class.

## C1.WPF.DataGrid

### Improvements

- DataGrid uses new C1ProgressIndicator control to display loading state.
  Default control template has been simplified.
  You can customize loading indicator style by setting the new C1DataGrid.LoadingIndicatorStyle to the custom C1ProgressIndicator style.

## C1.WPF.FlexGrid

### Bug fixes

- Aggregate cells are updated when GroupRow is in ColumnHeaders panel.

# Release version 4.0.20142.422 - 10/14/2014

## C1.WPF

### Bug fixes

- [C1TabControl] Fixed the issue that InvalidCastException occurs when
  using bounded datasource in C1TabControl.(TFS-90583)

## C1.WPF.FlexGrid

### Bug fixes

- Exception raised when setting a cell value if items source is DataTable.

## C1.WPF.Maps

### Breaking changes

- Change the names of constant properties from MaxLong, MinLong, MaxLat, MinLat,
  MaxZoom, MinZoom to MaxLongValue, MinLongValue, MaxLatValue, MinLatValue,
  MaxZoomValue, MinZoomValue.

# Release version 4.0.20142.421 - 10/10/2014

## C1.WPF

### Bug fixes

- [C1TabControl] Fixed the issue that Left and Right next buttons are still
  shown if all tabItems are collapsed.(TFS-89362)

## C1.WPF.Chart

### Bug fixes

- Fixed issue that out of range datapoints are visible on the chart When the RenderMode
  is set to 'Bitmap' and Zooming is performed on the Chart object.(TFS-88119)

## C1.WPF.DataGrid

### Improvements:

- DataGridDateColumn now supports CustomDateFormat and CustomTimeFormat.

## C1.WPF.DataGrid.Filters

### Breaking changes

- DataGridMultiLineDateFilter.EditMode type changed from C1DateTimePickerEditMode to DataGridDateTimeColumnEditMode.

### Improvements:

- DataGridMultiLineDateFilter now supports "Custom" EditMode which allows entering the
  datetime in a textbox, analogously to date time column editor.
- DataGridMultiLineDateFilter now supports CustomDateFormat and CustomTimeFormat.

## C1.WPF.FlexGrid

### Bug fixes

- AutoSizeColumn method was raising an exception.

## C1.WPF.FlexGrid.GroupPanel

### Bug fixes

- Hide columns when loading a grouped source and HideGroupedColumn is false.

## C1.WPF.FlexGridFilter

### Bug Fixes

- Exception raised when loading a filter whose value has not the right format.

# Release version 4.0.20142.420 - 09/29/2014

## C1.WPF

### Bug fixes

- C1ListBox unhandled exception thrown when setting SelectedItem to null.

## C1.WPF.Chart

### Bug fixes

- Fixed issue that ChartPanelObject goes out of the ChartView area after Zooming.(TFS-86899)

## C1.WPF.Chart3D

### Bug fixes

- Chart is fully rendered during rotation.(TFS-87448)
- Fixed the issue thatlLicense file is not created
  on dropping the control at design time.(TFS-87447)

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that unhandled exception raised when
  C1DockControl is used in a WinForms App and the Floating Mode is set.(TFS-88617)

## C1.WPF.DX

### Improvements

- First release.

## C1.WPF.FlexGrid

### Bug fixes

- Performance issue was fixed when resizing columns.
- Avoids pasting data in a read-only grid.
- Updates column's visibility when HideGroupedColumns is set at runtime.
- Pasting from clipboard wasn't working fine in all cases.
- Unhandled exception raised when using C1FlexGrid for WPF inside a Windows Form Application.

## C1.WPF.FlexGrid.GroupPanel

### Bug fixes

- Drop indicator displaced when scroll position was different from zero.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that unable to load certain PDF file in PDFViewer properly.
  (TFS-85187)
- Fixed the issue that unable to open scanned PDF file.(TFS-80087)
- Fixed the issue that opening certain pdf file in PDFViewer changes font and
  colors of pdf.(TFS-65605)
- Fixed the issue that unable to load certain PDF correctly in PDFViewer.
  (TFS-83232)
- Fixed the issue that pdf file is not correctly rendered in C1PdfViewer.(TFS-60880)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that selected text's font/font-size is not changed when
  changing font/font size by pressing up/down keyboard arrow keys.(TFS-62874)
- Fixed the issue that when selected text is edited by using ChangeCase
  tool, the above line get selected.(TFS-37201)

## C1.WPF.Schedule

### Improvements:

- Added new property ViewType to the C1Scheduler control. It simplifies changing default C1Scheduler styles both at runtime and design-time.
- The C1Scheduler.BeforeViewChange event is also fired when view is changed due to C1Scheduler.ViewType property change.
- added support to highlight current time in the Day/Week/TimeLine views. That includes:
- new TimeRuler control used in default C1Scheduler control templates;
- new C1Scheduler.CurrentTimeBrush property.

# Release version 4.0.20142.419 - 09/15/2014

## C1.WPF

### Bug fixes

- C1ListViewer hide preview item template when full template is displayed in order
  to avoid seeing duplicated elements.

## C1.WPF.DataGrid

### Bug fixes

- Incorrect layout when "star" columns are used and maximize/minimize is performed.

## C1.WPF.Excel

### Bug fixes

- Partly Setting "FitPageAcross" property changes the "AutoScale" property to True.(TFS:64023)
- Fixed (only for WPF) image getting lost on saving/loading C1XLBook via MemoryStream.(TFS:84628)
- Fixed missing newline character after bold styling.(TFS:85280)
- Fixed case 1 of styles not getting applied in the saved excel book.(TFS:84477)

## C1.WPF.Maps

### Bug fixes:

- Fixed the issue that the exception will be thrown
  when the tab items are exchanged.(TFS-86503)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that some text are shown in bold font style when loading pdf
  file in C1PdfViewer.(TFS-85076)
- Fixed the issue that unknown line is shown between texts in loading C1PDFViewer.
  (TFS-85050)
- Fixed the issue that some texts are changed font style 'Bold' and some bullets
  are replaced by 'G' character in c1PdfViewer.(TFS-85016)
- Fixed the issue that bullets are shown as rectangle in c1PdfViewer.(TFS-85006)
- Fixed the issue that some texts are not displayed correctly in c1PdfViewer.
  (TFS-85004)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that the type attribute in OL tag doesn't handle lower-roman
  or lower-Latin.(TFS-17898)
- Fixed the issue that System.ArgumentException is raised on loading an Html file
  coming from LinkedIn email.(TFS-86576)

# Release version 4.0.20142.418 - 09/07/2014

## C1.WPF.Maps

### Improvements:

- Add MaxLong, MaxLat, MaxZoom, MinLong, MinLat, MinZoom properties into C1Maps.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that ArgumentException is thrown on assigning an absolute URI
  to the Source property.(TFS-84204)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that html text is not rendered correctly.(TFS-84441)
- Fixed the issue that caret is not hide when set HideCaret to true.(TFS-51843)

## C1.WPF.Toolbar

### Bug Fixes

- [C1Toolbar] Fixed the issue that selected tab is not opened on clicking
  tabstrip of C1Toolbar at design-time.(TFS-33257)

# Release version 4.0.20142.417 - 09/01/2014

## C1.WPF

### Bug fixes

- [C1ComboBox] Fixed the issue that selected item getting reset in
  C1ComboBox after the view is changed.(TFS-79861)
- [C1NumericBox] Fixed the issue that Shift+Tab does not exit
  C1NumericBox to the previous input control.(TFS-77195)
- [C1NumericBox] Fixed the issue that formatting is incorrect in
  C1NumericBox.(TFS-35023)
- [C1TabControl] Fixed the issue that tabItem cannot be moved to first
  position if underlying datasource is used.(TFS-83123)
- [C1TabControl] Fixed the issue that TabStrip menu is shown at incorrect
  position when "FlowDirection" is set to RightToLeft and "TabStripPlacement"
  is set to Right.(TFS-83446)
- [C1Window] Fixed the issue that Long item names of C1Chart placed
  in C1Windows are protruding out of window.(TFS-75616)

## C1.WPF.Chart

### Bug fixes

- Fixed exception when hiding y-axis in polar chart.(TFS-67642)

## C1.WPF.DataGrid

### Bug fixes

- [DataGrid] Fix the issue that NullReferenceException occurs when new row
  is added if underlying data source contains an indexed property(TFS-82210)

## C1.WPF.DateTime

### Bug Fixes

- fixed mouse handling issues (Tfs 83380).

## C1.WPF.Extended

### Bug fixes

- [C1PropertyGrid] Fix issue that notSupportedException occurs when 'String'
  ItemArray is adding to DataRow by collection editor.(TFS-84163)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that exception occurs on opening PDF File.(TFS-80263)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that C1RichTextBox RTF export shows extra line space
  in bullet points.(TFS-78505)
- Fixed the issue that character spacing cannot be restored by
  pressing Crtl + Z key if selected texts are changed large font size.(TFS-66942)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that Underline and Strikethrough button are auto
  selected when click on the inserted picture.(TFS-77511)

## C1.WPF.Theming

### Bug Fixes:

- [C1PdfViewer] Fix the issue that Two Pages icon still shown in C1PdfViewer
  toolbar when theme is Cosmopolitan, CosmopolitanDark, Office2013White,
  Office2013LightGray, Office2013DarkGray.(TFS-79360)

## C1.WPF.Tile

### Bug fixes

- NullReferenceException occurs when the DataContext of the C1Tiles, whose CommandBinding is set in code, is changed (Tfs issue 83390).

# Release version 4.0.20142.416 - 08/18/2014

## C1.WPF.DataGrid

### Bug fixes

- [DataGrid] Fix the issue that values are changed while entering decimal
  data with some scenario in C1DataGrid(TFS-18697)

## C1.WPF.FlexGrid

### Bug fixes

- Changes were incorrectly committed when changing the focus
  if the grid was inside a popup.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that indexOutOfRangeException occurs on clicking the Page Number.
  (TFS-79810)
- Fixed the issue that search occurrence count is not correctly displayed in
  C1PDFViewer.(TFS-79638)
- Fixed the issue that text selection does not work if Japanese text and numbers
  are put into a table.(TFS-79618)
- Fixed the issue that Text selection does not work correctly in signed pdf document
  when Find action is performed.(TFS-80438)

# Release version 4.0.20142.413 - 08/07/2014

## C1.WPF

### Bug fixes

- [C1NumericBox] Fixed the issue that 'BackSpace' key doesn't work when delete
  the number before decimal point.(TFS-79387)
- [C1NumericBox] Fixed the issue that unable to enter '-0.3' or any value
  between -1 and 0 in C1NumericBox.(TFS-79350)

## C1.WPF.DataGrid

### Bug fixes

- Unhandled exception raised when rendering.
- Exception raised when using C1ValidationBehavior with DataTable as source.
- Virtualized columns width was incorrect when printing.

# Release version 4.0.20142.411 - 07/28/2014

## C1.WPF

### Bug fixes

- [C1Window] Fixed the issue that the size of the C1Window does not consist
  with the size of content.(TFS-76311)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that argumentOutOfRangeException occurs when dragging
  selected texts after 'Find' action is performed.(TFS-76268)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that space is added to double byte characters
  when exporting to RTF.(TFS-77079)

# Release version 4.0.20142.410 - 07/21/2014

## C1.WPF

### Bug fixes

- [C1TreeView] Fixed the issue that autoSearch property does not work for Japanese
  characters.(TFS-3826)
- [C1NumericBox] Fixed the issue that invalid inputs are displayed in the context
  menu of C1NumericBox and Argument Exception occurs when it is clicked.(TFS-15335)

## C1.WPF.Chart

### Bug fixes.

- Plot area removed correctly after removing corresponding axis(TFS 71470).

## C1.WPF.Extended

### Bug fixes

- [C1PropertyGrid] Fix issue that propertyGrid formatting not applied
  (TFS-68513).

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that "Zoom In" button is still enabled although Zoom
  value is set maximized value "800%" at first time.(TFS-74256)
- Fixed the issue that found word is not selected on clicking Find Next
  if Pdf file contains Japanese and English text.(TFS-74433)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that delete key does not delete the space
  before table.(TFS-33515)
- Fixed the issue that deleting table content using delete key
  would reduce the table to a single cell.(TFS-33426)

# Release version 4.0.20142.409 - 07/08/2014

## C1.WPF.DataGrid

### Bug fixes

- Filter items were not changed when Language is changed in the application.

## C1.WPF.OutlookBar

### Bug fixes

- [C1Outlookbar] Fix issue that unlike previous build , ShowFewerButton does
  not work in c1Outlookbar.(TFS-73856)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that some words cannot be able to select when Find action is performed.(#73800)
- Fix issue that unlike previous build, 'Zoom In' button is still enabled although
  Zoom value is set maximized value '800%' at first time.(#73883)

# Release version 4.0.20142.408 - 07/07/2014

## C1.WPF

### Breaking changes

- Removed "http://schemas.componentone.com/wpf/Basic" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

### Bug fixes

- [C1TreeView] Fixed the issue that treeview items can be seen partially when
  moving focus to items using keyboard navigation(41003)

### Improvements

- added missing translations for different cultures

## C1.WPF.Chart

### Breaking changes

- Removed "http://schemas.componentone.com/xaml/c1chart" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

## C1.WPF.Chart3D

### Breaking Changes

- Removed "http://schemas.componentone.com/xaml/c1chart" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

## C1.WPF.DataGrid

### Breaking changes

- Removed "http://schemas.componentone.com/wpf/DataGrid" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

### Bug fixes

- Exception raised when pressing Enter key in the filter drop-down.

### Improvements

- added missing localized resources.

## C1.WPF.DateTime

### Breaking changes

- Removed "http://schemas.componentone.com/wpf/DateTimeEditors" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

## C1.WPF.Docking

### Breaking changes:

- Removed "http://schemas.componentone.com/wpf/C1Docking" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

## C1.WPF.Extended

### Breaking changes

- Removed "http://schemas.componentone.com/wpf/C1Extended" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

## C1.WPF.FlexGridFilter

### Improvements:

- Added Romanian resources.

## C1.WPF.Gauge

### Breaking changes:

- Removed "http://schemas.componentone.com/wpf/C1Gauge" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

## C1.WPF.Maps

### Breaking changes

- Removed "http://schemas.componentone.com/wpf/C1Maps" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

## C1.WPF.MediaPlayer

### Breaking changes

- Removed "http://schemas.componentone.com/wpf/C1MediaPlayer" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

## C1.WPF.OutlookBar

### Improvements:

- Added localized resources for different cultures.

## C1.WPF.PdfViewer

### Breaking changes

- Removed "http://schemas.componentone.com/wpf/PdfViewer" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

### Bug Fixes:

- Fixed the issue that XamlParseException occurs on loading certain pdf file in c1PdfViewr.(#64607)
- Fixed the issue that Unable to print more than 2000 pages from C1PDFViewer.(#33096)
- Fixed the issue that Inflating error is raised on loading the certain pdf file.(#33728)
- Fixed the issue that when Orientation is set to Horizontal, 'next page' button is not working at toolbar. (72899)

## C1.WPF.ReportViewer

### Breaking changes:

- Removed "http://schemas.componentone.com/wpf/C1ReportViewer" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

### Bug Fixes:

- Fixed the issue that TwoMode button is still selected after changing another
  view mode in c1ReportViewer.(TFS-73530)
- Fixed the issue that "Two Pages" mode cannot be selected by using
  key board navigation and mouse click.(TFS-73580)
- Fixed the issue that InvalidOperationException occurs
  when finding texts in c1ReportViewer if headerfooter template is used (#73510)
- Fixed the issue that 'NullReferenceException' occurs when
  clicking zoom out button after changing zoom value 0% to any viewmode
  in c1reportviewer if pageTemplate is used.(#73544)
- Fixed the issue 'UnhandledException' occurs
  when typing in 'Find' textbox after loading pdf file
  into C1ReportViewer if zoom value is less than 25% (#73627)

## C1.WPF.RichTextBox

### Breaking changes:

- Removed "http://schemas.componentone.com/wpf/C1RichTextBox" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

## C1.WPF.RichTextBox.Toolbar

### Improvements:

- Added Romanian resources, added missing translations for different cultures.

## C1.WPF.Schedule

### Breaking changes

- Removed "http://schemas.componentone.com/wpf/Schedule" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

### Improvements:

- Added Romanian resources, added missing translations for different cultures.

## C1.WPF.SpellChecker

### Breaking changes:

- Removed "http://schemas.componentone.com/wpf/C1SpellChecker" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

### Improvements

- Added Romanian resources.

## C1.WPF.Tile

### Breaking changes

- Removed "http://schemas.componentone.com/wpf/Tile" namespace definition.
  Use "http://schemas.componentone.com/winfx/2006/xaml" instead.

# Release version 4.0.20142.407 - 07/02/2014

## C1.WPF

### Bug fixes

- [C1DropDown] Fixed the issue that C1DropDown's Header and Content are have a
  gap in between when Scaling is applied to the control.(TFS-56430)
- [C1Window] Fixed the issue that C1Window does not open again when page is
  refreshed in an xbap application.(TFS-71368)
- [C1NumericBox] Fixed the issue that numeric values are not correctly increased
  or decreased in clicking the spinner button of Numeric Input Box.(TFS-72578)

## C1.WPF.Extended

### Bug fixes

- [C1PropertyGrid] Fix issue that InvalidOperationException is thrown when click
  CollectionEditor menuItem in C1PropertyGrid(TFS-61434).

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that ArgumentException is raised when typed text in search box.(#72422)
- Fixed the issue that certain pdf file does not render correctly.(#60880)
- Fixed the issue that CryptographicException thrown when loading certain pdf file(#66968)

## C1.WPF.SpellChecker

### Bug fixes:

- Fixed the issue that blank space appeared in context menu while right click
  on misspelled word.(TFS-56484)

# Release version 4.0.20142.406 - 06/30/2014

## C1.WPF

### Bug fixes

- [C1ComboBox] Fixed the issue that C1ComboBox inside C1DataGrid shows
  unconverted value.(TFS-70629)
- C1ListViewer.BringIntoView() method was not working correctly.
- C1ListViewer.MinZoom and MaxZoom were not honored when setting Zoom property programatically.
- [C1TabControl] Fixed the issue that MouseLeftButtonUp event is not fired
  in C1TabControl.(TFS-72034)

## C1.WPF.Automation

### Bug fixes

- System.NullReferenceException occured when element Visibility is set to Collapsed (TFS-71674).

## C1.WPF.DataGrid

### Bug fixes

- Exception raised when pressing Tab key.
- Filter drop-down shown incorrectly.
- Exception raised when merging cells and grouping at the same time.
- Header dissapear after printing when it is a TextBlock.

## C1.WPF.DataGrid.Filters

### Bug fixes:

- Filters tab navigation improved.

## C1.WPF.Extended

### Bug fixes

- NullReferenceException is thrown if SelectedObject is set to an object instance
  whose class definition consist of a ColorPalette(TFS-16375).

## C1.WPF.FlexGrid

### Bug fixes

- Right border missing when printing.

### Improvements

- Improved the performance of AutoSizeColumns(allCells).

## C1.WPF.FlexGridFilter

### Bug Fixes

- Column header content was centered incorrectly when using filters.
- fixed undescore handling in filter drop-down (Tfs 63482).

### Improvements:

- Added Simplified Chinese and Traditional Chinese resources.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed issue that some texts are not rendered correctly in C1PdfViewer.(#71642)
- Fixed issue that SelectedText property does not work in c1PdfViewer.(#71638)
- Fixed issue that unable to navigate hyperlinks in PDFViewer.(#67532)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that "DraftViewTool" and "PrintViewTool" icons are not
  displayed correctly at bottom RichTextBoxToolBar.(TFS-71997)
- Fixed the issue that when typing -9 in zoom textbox,
  value reset to 100%.(TFS-72027)

## C1.WPF.Schedule

### Improvements:

- Added Simplified Chinese and Traditional Chinese resources.

# Release version 4.0.20142.403 - 06/23/2014

## C1.WPF

### Improvements

- [C1RadialMenu] Add new C1RadialMenu Control. It represents a touch-friendly
  alternative to the traditional context menu. Please reference the behavior of
  C1RadialMenu in XAML.

## C1.WPF.DataGrid

### Bug fixes

- Avoid hidding drop-down of column header when it is closed.

## C1.WPF.FlexGridFilter

### Bug Fixes

- Filtering null values was not working correctly.

## C1.WPF.Maps

### Bug fixes:

- Remove useless TilesMode proeprty.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed issue that embedded font does not been applied.(#70739,#70874,#71080)

### Improvements:

- - Reconstructing C1PdfViewer by using C1ListViewer on WPF and SL.
- Adding touch support and improving scrolling smoothness.
- Remove the "Two Pages" button from PdfViewerToolbar.
- The behavior of rendering multiple pages is the same as Winrt's. (vertical rendering)
- As Winrt's C1PdfViewer, adding ViewportGap and Orientation property.

## C1.WPF.RichTextBox.Toolbar

### Improvements:

- Add view tab that includes C1PrintViewLargeTool, C1DraftViewLargeTool,
  C1ZoomInTool, C1ZoomOutTool, C1Zoom100PercentTool, C1OnePageTool, C1TwoPagesTool
  and C1FitWidthTool to C1RichTextBoxToolBar.
- Add C1StrikethoughTool to the home tab of C1RichTextBoxToolBar.

## C1.WPF.Schedule

### Breaking Changes

- Removed obsolete C1Scheduler properties:
  VisualIntervals,
  VisualIntervalGroups,
  VisualIntervalsView.

# Release version 4.0.20141.402 - 06/17/2014

## C1.WPF

### Bug fixes

- C1DragHelper inertia was not working when two helpers were attachedto the same
  ui-element and one of them expected inertia whereas the other do not.
- [C1NumericBox] Fixed the issue that increment number is not shown and
  application stopped working when clicking increment button in C1NumericBox.(TFS-69299)
- [C1NumericBox] Fixed the issue that input from keyboard does not get reflected
  when C1NumericBox is used in Editor of C1FlexGrid.(TFS-69309)
- [C1NumericBox] Fixed the issue that validation error is still displayed for the
  valid data while comparing the values of two C1NumericBox controls.(TFS-69330)
- [C1NumericBox] Fixed the issue that negative value(-0.05) cannot be entered
  although range value is set from -1000.00 to 1000.00.(TFS-69333)
- [C1NumericBox] Fixed the issue that cursor position is not correctly maintained
  in c1NumericBox control after pressing "Space" key.(TFS-69408)
- [C1NumericBox] Fixed the issue that typed number is shown converted position
  when Format property is set.(TFS-69427)
- [C1NumericBox] Fixed the issue that C1NumericBox doesn't allowed to enter more
  than one negative number.(TFS-69495)
- [C1TabControl] Fixed the issue that automation support for the controls which
  is embedded within C1TabControl.(TFS-68660)

## C1.WPF.DataGrid

### Bug fixes

- DataGridNumericConverter changed to convert DBNull values to null.

## C1.WPF.FlexGridFilter

### Bug Fixes

- Exception raised when filtering.
- Getting cell values was not working correctly when the binding of the column was using XPath.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that C1PdfViewer is automatically scrolled down on double clicking a word.(TFS-69317)
- Fixed the issue that circle bullets are replaced with rectangles in c1PdfViewer.(TFS-69432)

## C1.WPF.TileView

### Bug fixes

- [C1TileView] When moving TileViewItem, item is moved in inconsistent
  order.(TFS-69891)

# Release version 4.0.20141.401 - 06/09/2014

## C1.WPF

### Bug fixes

- C1ListViewer raises an exception when BringIndexIntoView() method is called.
- [C1NumericBox] Fixed the issue that ArgumentException is raised when
  selecting "Kanji" text from C1NumericBox context menu.(TFS-68583)
- C1TapHelper Holding event implemented for these platforms.

## C1.WPF.DataGrid

### Bug fixes

- Viewport.CellsRange was raising an exception if the range was invalid, now it returns null.

## C1.WPF.Extended

### Bug fixes

- C1BasicColorPicker keyboard navigation fixed.

## C1.WPF.FlexGrid

### Bug fixes

- Improved the performance of Row.GetData() method.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that text of bullet list are shown in larger font size.(TFS-67913)
- Fixed the issue that logo images and graphic line are missing.(TFS-67932)
- Fixed the issue that exception occurs when loading certain pdf file.(TFS-64879)

# Release version 4.0.20141.400 - 05/26/2014

## C1.WPF

### Bug fixes

- C1ListViewer was not honoring Horizontal and VerticalAlignment properties of the items.

## C1.WPF.DataGrid.Summaries

### Bug fixes

- DataGridGroupWithSummaryRowPresenter template was not displaying the background set by the user.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that C1DockTabControl does not fill the
  C1DockControl when 'Save' and 'Load' methods of 'C1DockControl' are used.(TFS-64655)

## C1.WPF.Extended

### Bug fixes

- [C1PropertyGrid] SubProperties of type ObservableCollection
  are not displayed correctly in C1PropertyGrid(TFS-47538)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that image of pdf file appears smudged when viewed in C1PdfViewer.(TFS-64196)
- Fixed the issue that circle bullets are replaced with rectangles (TFS-67027)
- Fixed the issue that NullReferenceException occurs when loading pdf file containing input controls.(TFS-67138)
- Fixed the issue that dotted line is replaced with square characters.(TFS-67250)
- Fixed the issue that CryptographicException occurs when loading password protected pdf file.(TFS-67198)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that ArgumentNullException occurred when removed link from
  hyperlink text after removed underline from it.(TFS-63328)

# Release version 4.0.20141.399 - 05/12/2014

## C1.WPF

### Bug fixes

- [C1NumericBox] Fixed the issue that incorrect Tab Order when using C1Controls.
  (TFS-64694)
- [C1ComboBox] Fixed the issue that incorrect Item Selection with Condition
  property as 'Contains'.(TFS-64874)
- [C1TreeView] Fixed the issue AutoSearch not working for selected keyboard language
  (TFS-61298)

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that Close button is displayed even after
  setting 'CanUserHide' to 'False' for C1DockTabControl.(TFS-64722)

### Improvements

- [C1DockControl] Request to add support to move the DockTabControl containing
  multiple TabItems.(TFS-48540)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that characters are too close and nearly overlapped in loaded pdf file.(TFS-65171)
- Fixed the issue that unlike previous build, Table UI , logo image, checkbox, barcode,
  header text are not displayed.(TFS-65374)

# Release version 4.0.20141.398 - 05/03/2014

## C1.WPF

### Bug fixes

- C1DragHelper property Origin of DragStarted event args was returning a wrong value
  when performed with the finger.

## C1.WPF.DataGrid

### Bug fixes

- Tab KeyPress event was incorrecly handled when no cell with a focusable control was found.
- Printed data grid was not considering the height of the rows.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that some characters are shown in bigger font size in paragraph.(TFS-64917)
- Fixed the issue that some characters do not show PdfViewer.(TFS-64926)
- Fixed the issue that some characters render incorrectly in PdfViewer.(TFS-64954,63001)
- Fixed the issue that some white vertical lines are appeared upper the texts in C1PdfViewer.(TFS-64971)

# Release version 4.0.20141.397 - 04/28/2014

## C1.WPF

### Bug fixes

- Property path setter and getter were modified to support nested indexed path's
  as well as Default Visual Basic properties.

## C1.WPF.FlexGrid

### Bug fixes

- Recycle templated cells to improve performance and avoid memory leaks (TFS 47354)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that "Search" function does not work correctly.(TFS-64697)
- Fixed the issue that uncorrect text renders in text box.(TFS-64707)
- Fixed the issue that uncorrect text renders in PdfViewer.(TFS-64704,TFS-64863)
- Fixed the issue that some formula and texts and table are not shown correctly in c1PdfViewer.(TFS-64730)

## C1.WPF.ReportViewer

### Bug Fixes:

- Fixed the issue that exception occurs when loading PDF file.(TFS-47505)

# Release version 4.0.20141.396 - 04/24/2014

## C1.WPF

### Bug fixes

- [C1NumericBox] Fixed the issue that ArgumentOutOfRangeException occurs when
  deleting the initial value '0' in c1NumericBox.(TFS-64508)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that checkboxes are displayed as unknown characters.(TFS-64441)
- Fixed the issue that incorrect characters rendering.(TFS-64457,TFS-64459,TFS-64468,TFS-64482,TFS-64495,TFS-64483,TFS-64521,TFS-64522,TFS-64674)
- Fixed the issue that font size render too large when load certain file.(TFS-64462,TFS-64467,TFS-64510)
- Fixed the issue that incorrect text location and overlapped text rendering.(TFS-64460,TFS-64472,TFS-64511,TFS-64562,TFS-64647,TFS-64649)
- Fixed the issue that IndexOutOfRangeException occurs on dragging the mouse on Japanese Kanji characeter.
  (TFS-64404)
- Fixed the issue that PdfViewer can not scroll text into view.(TFS-64519,TFS-64523,TFS-64632)
- Fixed the issue that strange block renders in PdfViewer.(TFS-64444)
- Fixed the issue that text missing and small in PdfViewer.(TFS-64585)
- Fixed the issue that correct word cannot be selected while searching texts on loading chinese pdf file.(TFS-64646)

# Release version 4.0.20141.395 - 04/21/2014

## C1.WPF

### Bug fixes

- [C1NumericBox] Fixed the issue that zero could not be entered after a decimal
  point in C1Numericbox even is the set format is 'F2' or 'N2'.(TFS-63178)
- [C1NumericBox] Fixed the issue that cursor does not shifts its position if the
  digit which occurs after the decimal point is typed again after the decimal for the
  second time.(TFS-63470)
- [C1MaskTextBox] Fixed the issue that 'VerticalScrollBar' doesn't fully
  shown as C1MaskTextBox's height.(TFS-63405)

## C1.WPF.DataGrid

### Bug fixes

- Focus was set incorrectly when an outside control get the focus and EndEdit method is called.
- Unselect row when Ctrl key was pressed and selection mode is multi-row.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that text are not correctly selected on searching the value in pdf file.
  (TFS-63384)(TFS-63398)(TFS-63691)
- Fixed the issue that watermark text are not correctly displayed in loaded pdf file.(TFS-63402)
- Fixed the issue that some words and numbers are changed large font size in C1PdfViewer.
  (TFS-63397)(TFS-63469)
- Fixed the issue that text are not correctly aligned
  when Chinese and English characters are on the same page(TFS-63431)
- Fixed the issue that IndexOutOfRangeException occurs on loading pdf file.(TFS-63480)
- Fixed the issue that some text overlapped when loading certain pdf file.(TFS-63514)
- Fixed the issue that exception occurs on opening certain pdf file.(TFS-63840)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that image's width cannot be controlled when loading image from
  web path at first time if c1RichTextBox instance present on the child form.(TFS-63378)
- Fixed the issue that HTML is not rendered correctly in the RichTextBox
  on first load.(TFS-61561)

## C1.WPF.TileView

### Bug fixes

- [C1TileView] Unlike previous build, ArgumentNullException
  occurs when clearing all c1TileViewItem if one item is maximized.(TFS-63559)

# Release version 4.0.20141.394 - 04/07/2014

## C1.WPF.DataGrid

### Bug fixes

- Row validation background disappears when scrolling up and down.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that text are overlapped in scanned pdf.(TFS-61707)
- Fixed the issue that text IndexOutOfRangeException occurs on loading the pdf file.
  (TFS-61708)(TFS-62919)(TFS-61726)
- Fixed the issue that text NullReferenceExecption occurs on loading the pdf file.(TFS-62873)
- Fixed the issue that texts are not shown on loading Pdf file.(TFS-61729)
- Fixed the issue that some texts are getting lost except from first characters in Vietnamese pdf file
  (TFS-61731)
- Fixed the issue that some texts are overlapped on loading Pdf file.(TFS-62861)
- Fixed the issue that spaces disappear.(TFS-62867)
- Fixed the issue that long time to load a file.(TFS-63083)
- Fixed the issue that some texts inside the table
  are shown in larger font size when loading pdf file.(TFS-63001)
- Fixed the issue that texts in specific rectangle are not shown in C1PdfViewer.(TFS-63039)
- Fixed the issue “Find text” textbox is not able to search text
  on loading the pdf file containing both English and Japanese text.
  (TFS-62879)(TFS-63053)(TFS-62939)(TFS-63290)(TFS-63297)
- Fixed the issue that some words are become large font size in c1PdfViewer.(TFS-61728)
- Fixed the issue that blank pages are shown in C1PdfViewer.(TFS-63009)
- Fixed the issue that header text is shown improperly in c1PdfViewer.(TFS-63266)
- Fixed the issue that some texts are missing on loading report type 'RPC' format in C1ReportViewer.(TFS-63300)
- Fixed the issue that NullReferenceException occurs when trying to go to page 31 in c1PdfViewer.(TFS-63283)

## C1.WPF.ReportViewer

### Bug Fixes:

- Fixed the issue that texts are not displayed correctly
  when loading pdf file in C1ReportViewer(TFS-62877)

# Release version 4.0.20141.393 - 03/31/2014

## C1.WPF

### Bug fixes

- Request to remove Extra control from Toolbox and change to correct
  icon insides Toolbox(TFS-34271)
- [C1TreeView] C1TreeView SelectedItem is not updated when selected with touch
  on a touch machine.(TFS-51385)
- GetPropertyValue extension was not evaluating the path correctly when it has the
  following structure "[xxx.xxx]".
- C1ListBox problem with scrollbar's visibility fixed.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Fixed the issue that docking diamond disappear on setting
  WindowResize mode to CanResizeWithGrip.(TFS-48911)

## C1.WPF.Extended

### Bug fixes

- Request to remove Extra control from Toolbox and change to correct
  icon insides Toolbox(TFS-34271)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that ArgumentException is thrown when open certain pdf file.(TFS-61429)
- Fixed the issue that overlapped text shown.(TFS-61659)
- Fixed the issue few chinese characters are not rendered correctly.(TFS-49010)
- Fixed the issue Japanese pdf file is not rendered properly in C1PdfViewer.(TFS-47215)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that C1RichTextBox shows zoomed image with increased
  height and width from HTML.(TFS-57504)

# Release version 4.0.20141.391 - 03/18/2014

## C1.WPF

### Bug fixes

- [C1ComboBox] Fixed the issue that when set 'AutoComplete=False', C1ComboBox's
  dropdown is not close while click on C1ComboBox's textbox in secondtime.(TFS-57202)
- [C1TabControl] When select the last tabitem and 'TabStripPlacement' property
  chages 'Left/Right' , all tabitems are not shown.(TFS-56475)
- [C1NumericBox] Fixed the issue that IsTabStop property doesn't work.(TFS-55599)
- [C1TabControl] Fixed the issue that exception occurs if C1TabItems are added
  after closing tabitems while UpdateSourceCollection=False.(TFS-50752)
- [C1TabControl] Fixed the issue that TabStrip gets empty on selecting Last Tab
  from selection menu when Tab is Active and not in View.(TFS-47609)
- ScrollBar style modified to fix visual error when IsEnabled=False.

## C1.WPF.Automation

### Bug fixes

- Merged the Automation of C1TabControl and C1TabItem to main folder.(TFS-52057)
- Fixed SelectedIndex issue in C1TabControl automation.(TFS-51130)

### Improvements

- Added automation peers for C1DataGrid.

## C1.WPF.DataGrid

### Bug fixes

- Clipping issue fixed when resizing the browser and star columns were present.
- Focus is not shown in the cell when AddNewRow is clicked.(TFS-51185)
- Tab navigation was not considering merged cells.
- Enter, Backspace and Escape key strokes was being handled incorrectly when performed
  in the row details.
- When ctrl+v is pressed and clipboard dialog is displayed garbled character was entered.
- Exception raised when tabbing in the filter row.
- When ctrl+c is pressed and clipboard dialog is displayed garbled character was entered.
- Override default Tab key behavior for filter row, in order to follow columns order and display hidden cells.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockTabControl] Fixed the issue that unhandled exception thrown on
  dragging the splitter bar.(TFS-56183)
- [C1DockControl] Fixed the issue that DockTabControl's area is appeared
  when changing DockMode property sliding to floating state.(TFS-55654)
- [C1DockTabControl] Fixed the issue that two clicks require to close
  C1DockTabItem after opening TabStripMenu at floating mode.(TFS-51525)
- [C1DockControl] Fixed the issue that Multiple Dropdown lists could be opened
  at the same time in C1DockControl.(TFS-50852)

## C1.WPF.Extended

### Breaking changes

- C1SpectrumColorPicker template parts changed.
- Type of the property ExpandDirection of the controls C1Expander and C1Accordion was
  changed from C1.Silverlight.Extended.ExpandDirection to C1.Silverlight.C1ExpandDirection.

### Bug fixes

- C1SpectrumColorPicker keyboard navigation was not working.

### Improvements

- Animations added to C1Accordion.
- C1SlideContentControl control added.

## C1.WPF.FlexGrid

### Improvements

- Take row visibility into account when rendering alternate rows.

## C1.WPF.FlexGridFilter

### Bug Fixes

- Added support for DBNull values in filter (in addition to regular null values)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that unlike previous build, logo image is covered up by unknown
  multi color lines.(TFS-55871)
- Fixed the issue that unlike previous build, some formula symbols are replaced by
  rectangle in c1PdfViewer.(TFS-55899)
- Fixed the issue that 'NullReferenceException' is observed on loading certain pdf file.
  (TFS-55844)
- Fixed the issue that unlike previous build, some bracket is not shown in C1PdfViewer.
  (TFS-52279)
- Fixed the issue that unlike previous build, NullReferenceException occurs when trying
  to go to next page.(TFS-54416)
- Fixed the issue that red cross are shown instead of images in C1PdfViewer.(TFS-51666)
- Fixed the issue that text render incorrectly in C1PDfViewer.(TFS-51663)
- Fixed the issue that formatException occurs when loading scanned image pdf file.(TFS-51681)
- Fixed the issue that circle bullets are shown on smaller size in C1PdfViewer.
  (TFS-51759)
- Fixed the issue that unlike previous build, text in logo image are displayed in
  reverse order.(TFS-51729)
- Fixed the issue that unlike previous build, Images are displayed at incorrect
  position in c1PdfViewer.(TFS-51755)
- Fixed the issue that logo image is overlapped by black rectangle in C1PdfViewer.
  (TFS-51917)
- Fixed the issue that unlike previous build, bullets are replaced with rectangles.
  (TFS-50952)
- Fixed the issue that customer's pdf file do not load in C1PdfViewer.(TFS-23668)
- Fixed the issue that C1PDFViewer can not veiw properly certain pdf file.(TFS-29951)
- Fixed the issue that background color is not rendered & few text appears garbled
  when loading specific pdf file.(TFS-43306)
- Fixed the issue that gray background is shown instead of gradient background.
  (TFS-49683)
- Fixed the issue that certain pdf file does not load in C1PdfViewer.(TFS-50044)
- Fixed the issue that all the spaces infront of the found text are selected when
  typing in the "Search" box after loading the Japanese pdf file.(TFS-51100)
- Fixed the issue that Text is displayed with incorrect background color when
  loading the pdf file in C1PdfViewer.(TFS-33008)
- Fixed the issue that Pdf Not Displaying Properly.(TFS-21476)
- Fixed the issue that image are converted to gray scale when open with C1PDFViewer.
  (TFS-23932)
- Fixed the issue that unlike previous build ,bullets are replaced with unknown characters.
  (TFS-51312)
- Fixed the issue that number renders incorrectly.(TFS-51263)
- Fixed the issue that text font size are getting increased.(TFS-51448)
- Fixed the issue that targetInvocationException is raised on loading the certain pdf file.
  (TFS-34549)
- Fixed the issue that unlike previous build, typed text in "Search" box is not
  selected in C1PdfViewer if pdf file containing Chinese characters is loaded.(TFS-50832)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that underline is not removed after removing
  existing hyperlink.(TFS-57184)
- Fixed the issue that no word is pasted when pressing Ctrl+v after
  pressing Ctrl+x twice or more.(TFS-33108)
- Fixed the issue that strikethrough line does not work after conversion
  to "Rtf".(TFS-48586)
- Fixed the issue that image present in loaded RTF file cannot be
  deleted.(TFS-50685)
- Fixed the issue that C1RTB causing application to throw stackoverflow
  exception.(TFS-19417)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that duplicate signal shown in C1RichTextToolbar.(TFS-50502)

## C1.WPF.SpellChecker

### Bug fixes:

- [C1SpellChecker] In 'BadWordFound' event, 'e.Cancel=true' thrown the exception.(TFS-24778)

# Release version 4.0.20133.382 - 01/31/2014

## C1.WPF

### Bug fixes

- [C1NumericBox] 'IsTabStop' property does not work correctly.(TFS-50236)

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Height of the rows was considering the details when expoted to excel.

## C1.WPF.Extended

### Bug fixes

- C1SpectrumColorPicker moving the pointer with the keyboard was not working properly.
- C1HexColorBox cursor is set a the wrong position when ShowSharpPrefix is set to true.

# Release version 4.0.20133.381 - 01/27/2014

## C1.WPF

### Bug fixes

- [C1ListViewer] HorizontalContentAlignment and VerticalContentAlignment properties
  were bound to analogous properties of the items, and the default values were set
  to Left and Center.
- [C1TreeView] [SL4][SL5][WPF][C1TreeView] Unlike previous build , C1TreeViewItems
  are invisible when changing Built-in Theme.(TFS-49075)
- [C1TabControl] Fixed the issue that next button is still shown when all
  C1TabItems are collapsed.(TFS-49820)
- Properties propagation was overwriting the properties set through a style which
  is based on another style.
- Content of the ScrollViewer is clipped incorrectly when Padding property is set.
- C1FilePicker multi-select was not working fine after calling ClearSelection() method.
- [C1ComboBox] Fixed the issue that disabled items can be selected via keyboard in
  databound C1ComboBox.(TFS-49788)

## C1.WPF.Automation

### Improvements

- Added automation peers for the next controls (supported patterns in the brackets):
  C1TimeEditor (Value, RangeValue)
  C1DatePicker (Value, ExpandCollapse)
  C1DateTimePicker (Value)
  C1TileBase (Invoke)
  C1Calendar (Selection)
  C1CalendarItem
  DaySlotPresenter (SelectionItem)

## C1.WPF.DataGrid

### Bug fixes

- Paste feature was modified to paste the clipboard content in the current cell when
  it is not formatted.
- Avoid entering in edit mode when Ctrl key is pressed.
- Column dragging indicators were misplaced when setting FlowDirection="RightToLeft".

## C1.WPF.DateTime

### Improvements:

- Added automation support for .Net 4.0 version. Requires C1.WPF.Automation assembly reference.
  Supported automation patterns:
  C1TimeEditor (Value, RangeValue)
  C1DatePicker (Value, ExpandCollapse)
  C1DateTimePicker (Value)

## C1.WPF.Extended

### Bug fixes

- [C1SpectrumColorPicker] Dragging the pointer was not working properly.

## C1.WPF.FlexGrid

### Bug fixes

- Avoid entering in edit mode when double click in a cell that already was in edit mode.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that numbers render out of circle.(TFS-50321)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that ArgumentOutOfRange Exception occurs in loading html
  file into C1RichTextBox.(TFS-49798)
- Fixed the issue that "Index and length must refer to a location within
  the string" exception throw when copy and paste some specific text.(TFS-49818)
- Fixed the issue that XamlParse Exception occurs when setting the
  string containing <span> tag to C1RichTextBox.Html.(TFS-49793)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that "XamlParseException" is raised on creating the
  ControlTemplate for RichTextBoxToolbar through MS Blend.(TFS-47803)

## C1.WPF.Schedule

### Improvements:

- Added automation support for .Net 4.0 version. Requires C1.WPF.Automation assembly reference.
  Supported automation patterns:
  C1Calendar (Selection)
  C1CalendarItem
  C1CalendarItemPresenter
  DaySlotPresenter (SelectionItem)

## C1.WPF.Tile

### Improvements:

- Added support for Invoke automation pattern in .Net 4.0 version. Requires C1.WPF.Automation assembly reference.

# Release version 4.0.20133.380 - 01/20/2014

## C1.WPF

### Bug fixes

- [C1TabControl] Fixed the issue that IE does not respond when clicking 'Next'
  button at C1TabControl in which TabItem is hidden.(TFS-49486)
- [C1ComboBox] Fixed the issue that 'NullReferenceException' exception occurred
  when running the BasicControls sample.(TFS-49506)
- [C1ComboBox] Fixed the issue that full class name of the underlying data
  source is displayed when item with empty text is selected.(TFS-49667)
- [C1TreeView] Unlike previous build , Horizontal scrollbar does not work
  although AutoScrollMode is set to "Both" and C1TreeViewItem content does not fit
  in the current ViewPort.(TFS-49066)
- [C1TreeView] Unlike previous build , ArgumentNullException occurs when
  leaving the edit mode in EditTemplate of C1TreeView.(TFS-49351)

## C1.WPF.Maps

### Bug fixes:

- Fix the issue that TargetZoomSpeed can't work well.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that win32 exception occurs when trying to select text of signed pdf
  .(TFS-49675)
- Fixed the issue that image/graphic is shown with black background.(TFS-35635)
- Fixed the issue that pdf is not rendered properly in C1PDFViewer.(TFS-24581)
- Fixed the issue that keyNotFoundException is raised on loading the Pdf file.
  (TFS-20258)
- Fixed the issue that pdF File is not rendered properly.(TFS-30107)

# Release version 4.0.20133.378 - 01/13/2014

## C1.WPF

### Bug fixes

- [C1TabControl] Fixed the issue that unable to move Tabs with Single Click
  on Navigation button with Hidden TabItems.(TFS-46163)
- [C1TreeView] Unlike previous build , C1TreeViewItems cannot be expanded
  by setting IsExpanded property in code.(TFS-49053)
- [C1TreeView] Unlike previous build , C1TreeViewItems cannot be expanded
  by setting IsExpanded property in code.(TFS-49057)
- [C1TreeView] Unlike previous build , SelectedBackground is not fully
  displayed in C1TreeView.(TFS-49056)

### Improvements

- [C1TreeView] Add SelectionChanging event for C1TreeView.(TFS-46500)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that red cross is displayed when loading certain files.
  (TFS-49005,TFS-49008)

## C1.WPF.Schedule

### Improvements

- added support for cases when working time should last from one day to another.
  If CalendarHelper.EndDayTime property value less than CalendarHelper.StartDayTime property value,
  working time will be represented as 2 time intervals - from day start to CalendarHelper.EndDayTime
  and from CalendarHelper.StartDayTime to day end.
  The C1Scheduler control honors this setting when ShowWorkTimeOnly property is true.
  Note, when ShowWorkTimeOnly is true, the C1Scheduler always shows the full hour.
  So some free time might be included into the view.

# Release version 4.0.20133.377 - 01/06/2014

## C1.WPF

### Bug fixes

- [C1ComboBox] Fixed the issue that binding isn't working correctly when
  'SelectedValuePath' is bound to the 'Tag' property of C1ComboBoxItem.(TFS-48397)

### Improvements

- [C1TreeView] Implement Virtualization for C1TreeView.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue unlike previous build,unlike previous build, some texts become
  large font size in C1PdfViewer.(TFS-48565)
- Fixed the issue unlike previous build,unlike previous build, text are not clearly
  shown in scanned pdf.(TFS-48560)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that UpdateSourceTrigger set to "PropertyChanged" value does
  not work correctly.(TFS-30551)

## C1.WPF.Schedule

### Improvements

- the C1Scheduler.BeforeViewChange event is fired before the view is changed with the C1Scheduler.ChangeStyle command.
- added new method to the C1Scheduler control:
  protected virtual void OnChangeStyleCommand(ExecutedRoutedEventArgs args);
  Handles the C1Scheduler.ChangeStyle command.
  Override this method to alter the default behavior.

# Release version 4.0.20133.376 - 12/30/2013

## C1.WPF

### Bug fixes

- C1FilePicker was raising exception when setting FilterIndex property.
- [C1ComboBox] Fixed the issue that dropdown is overlapped on the About Box dialog
  when setting 'IsDropDownOpen=True' in design time.(TFS-47565)

## C1.WPF.DataGrid.Summaries

### Bug fixes

- Exported summary cells were showing incorrect values when copy and paste.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue unlike previous build, applied underline styles are missing in some
  titles.(TFS-48185)
- Fixed the issue unlike previous build, German texts are not shown in C1PdfViewer.
  (TFS-48172)
- Fixed the issue unlike previous build, dotted lines are missing in C1PdfViewer.
  (TFS-48195)
- Fixed the issue unlike previous build, text are not displayed in C1PdfViewer
  if these are added inside the box or rectangle.(TFS-48208)
- Fixed the issue pdfParserException raised on viewing certain Pdf file(Support
  ASCIIHexDecode,RunLengthDecode).(TFS-40257)
- Fixed the issue unable to view scanned pdf file in C1PDFViewer.(TFS-33170)

## C1.WPF.ReportViewer

### Bug Fixes:

- Fixed the issue that Unlike previous build, NullReferenece exception occurs on
  loading HTML file(TFS-48280)

# Release version 4.0.20133.375 - 12/23/2013

## C1.WPF

### Bug fixes

- C1FilePicker was displaying the name of a selected file after calling ClearSelection
  and setting Multiselect.
- [C1ComboBox] Fix the issue that cursor does not remain in C1ComboBox after
  selecting the item.(TFS-47762)
- [C1ComboBox] Fix the issue that keyboard navigation does not work correctly
  if any item of underlying datasource contains empty space.(TFS-46962)

## C1.WPF.FlexGrid

### Bug fixes

- Editing value was not committed when using a combobox inside a template cell.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue unlike previous build , Japanese text are not displayed in
  C1PdfViewer.(TFS-47752)
- Fixed the issue 'NullReferenceException' occurred when drag Annotation dialog
  box .(TFS-47858)
- Fixed the issue Blurry text found when viewing the certain pdf file in C1PdfViewer.
  (TFS-44145)
- Fixed the issue Unlike previous build , Image is overlapped by the sign in
  c1PdfViewer.(TFS-47925)
  C1.Silverlight.PdfViewer.dll Build Number .

# Release version 4.0.20133.374 - 12/16/2013

## C1.WPF

### Bug fixes

- [C1ComboBox] Fix the issue that C1ComboBox is not working correctly if used
  inside CellEditingTemplate of C1FlexGrid.(TFS-45227)
- [C1DropDown] Fix the issue that when C1Expander's IsExpanded property set 'False',
  the dropdown of C1DropDown is still appeared.(TFS-41911)
- [C1ComboBox] Fix the issue that text is not consistently displayed after dropdown
  is opened and closed if ItemStringFormat is set.(TFS-47472)

## C1.WPF.DataGrid

### Bug fixes

- Error committing value in DataGridTemplateColumn when root of the template was a panel.
- Selecting all the cells and copying to the clipboard was not working fine.

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Explicitly defined summary row height is not honored in exported file.
- Aggregate values appear in exported group headers even if C1GroupingWithSummariesBehavior
  is not set for the exporting DataGrid.

### Improvements:

- [Breaking change]If KeepRowHeights export option is set to true then an exported row height is retrieved
  from each certain grid row (DataGridRow.ActualHeight property), instead of from the
  DataGrid.RowHeight property.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue wrong text render when loading certain file.(TFS-47556)
- Fixed the issue unlike previous build , some words and numbers are crashed.
  (TFS-47457)
- Fixed the issue unlike previous build, some texts are not shown in specific rectangle
  area.(TFS-47481)
- Fixed the issue unlike previous build , some numbers become large font.
  (TFS-47525)
- Fixed the issue that larger font size are shown and some text are cut off
  (TFS-47450)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that extra Japanese character are showed among text when
  Japanese text rtf file is imported to C1RichTextBox.(TFS-47535)
- Fixed the issue that "Delete cells" option doesn't deletes first cell in
  that row.(TFS-47537)

## C1.WPF.Schedule

### Improvements

- added new C1SchedulerSettings.UseMouseWheelForGroupNavigation property. Set it to true to alter default
  mouse wheel behavior in the TimeLineView. By default mouse wheel in the TimeLine view is used for horizontal scrolling to different DateTime intervals.
  When UseMouseWheelForGroupNavigation is true and there are some invisible groups, mouse wheel will navigate C1Scheduler
  in the vertical direction to other group items.
  ([37755-139][SL Schedule] Request to suggest a way to enable Vertical Scrolling with MouseWheel when Grouping is enabled in TimeLine View)

# Release version 4.0.20133.373 - 12/09/2013

## C1.WPF

### Bug fixes

- [C1DropDownButton] Fix the issue that IsDropDownOpen property does not work. (TFS-47177)
- [C1ComboBox] Fix the issue that ItemStringFormat property is not ignored even
  though ItemTemplate is set.(TFS-47160)
- [C1ComboBox] Dropdown list position is wrong when opening C1ComBoxBox if
  Handedness of tablet PC settings is set to Right-Handed.(TFS-35506)
- [C1ComboBox] Fix the issue that after typing the first character in C1ComboBox
  and selecting the list item, 'SelectedIndexChanged' event is fired twice.(TFS-47270)
- C1HyperlinkButton disabled state was not dimmed at design-time.
- ScrollViewer template changed to render corners more accurately.

### Improvements

- C1FilePicker.InitialDirectory property added.

## C1.WPF.DataGrid

### Bug fixes

- Freezing separator was not working fine when FlowDirection="RightToLeft".
- Copy and Paste to clipboard modified to include a leading column per indent level
  so that group rows with summaries can be exported to excel.

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Some symbols like '\', '{' and '}' in aggregate value strings are not shown in an
  exported file.

## C1.WPF.Maps

### Bug fixes:

- Request to add About box link in context-menu of C1MultiscaleImage.(TFS-41539)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that C1PdfViewer cannot select and find the text on custom create
  pdf file(19965)
- Fixed the issue that C1PdfViewer cannot render wrong text when load certain file.
  (TFS-47139)(TFS-47140)
- Fixed the issue that C1PdfViewer cannot render wrong text when load certain file.
  (TFS-47157)
- Fixed the issue that when set Theme 'ShinyBlue', text in 'Find' textbox
  is cut off(TFS-45462)
- Fixed the issue that C1PdfViewer does not print images when print through physical printer.
  (TFS-44065)

## C1.WPF.ReportViewer

### Bug Fixes:

- Fixed the issue that when set Theme 'ShinyBlue', text in 'Find' textbox
  is cut off(TFS-45462)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that Chinese characters appear garbled when loaded from
  a RTF file.(TFS-41696)
- Fixed the issue that when paste the text from MS Word to C1RichTextBox
  with Shift+Insert Key, new duplicate text is appeared.(TFS-47279)

# Release version 4.0.20133.372 - 12/02/2013

## C1.WPF

### Bug fixes

- 'IsEnabled=False' property set in Style tag that not applied on some wpf
  controls.(TFS-42144)
- [C1DropDownButton] Fix the issue that although C1DropDownButton's Visibility set
  'Hidden/Collapsed', dropdown is still appeared.(TFS-42108)
- [C1ComboBox] Fix the issue that FormatException is thrown on selecting the item
  from C1ComboBox with ItemStringFormat property set.(TFS-46956)

## C1.WPF.DataGrid

### Bug fixes

- Error in the layout when pressing Ctrl+V twice.

## C1.WPF.DataGrid.Summaries

### Bug fixes

- Summary cell was showing nothing by default, ResultFormat property default value
  was changed to "{0}".
- Unhandled exception is thrown when '&' character is included in ResultFormat property of DataGridAggregate.
- Aggregate result was not taking double-braces into account.

### Improvements:

- DataGridSummaryRow provides the aggregate results as text to be used in clipboard operations.

## C1.WPF.Gauge

### Bug Fixes:

- Fix the issue that unable to bind Interval property of C1GaugeLabel to a
  property in a class.(TFS-46909)

## C1.WPF.Maps

### Bug fixes:

- Change the attached property name "LatLong" to "LongLat" of C1MapCanvas class.(TFS-32762)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that Unlike previous build, it takes longer time to see the
  pdf content(46856)
- Fixed the issue that garble text render when load japanese file.(TFS-46461,TFS-46462)

# Release version 4.0.20133.371 - 11/25/2013

## C1.WPF

### Bug fixes

- Fix the issue that even on setting CurrentUICulture to English, display is in Japanese.(TFS-43302)

### Improvements

- C1ProgressBar added.

## C1.WPF.DataGrid

### Bug fixes

- Selection of columns was not working properly when the last row was added or removed.
- Clipboard feature was copying data even when mode was None.

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Wrong alignment of aggregate values in group headers.

### Improvements:

- If DataGridAggregate's formatting is defined via the ResultFormat property, instead of
  ResultTemplate, then formatted values will be exported exactly as they shown in C1DataGrid .

## C1.WPF.DataGrid.Summaries

### Improvements:

- DataGridAggregate.ResultFormat property added to allow specifying the result as a
  formatted string, which can be exported to excel.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockTabControl] Can't drag the last tab item from one floating C1DockTabControl
  to another floating C1DockTabControl.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that text overlapped when loaded certain text.(46315)
- Fixed the issue that lines of text are missing in loaded pdf file.(46310)
- Fixed the issue that incomplete dynamic bit lengths tree xxx occurs on loading
  the pdf file containing the input controls.(44649)
- Fixed the issue that Inflating error is raised on loading the certain pdf
  file.(33728)
- Fixed the issue that C1.C1Zip.ZLib.ZStreamException occurs when pdf file with
  graphic is opened(33003)
- Fixed the issue that Win32 exception raised on loading
  AcroForm pdf file if RenderMode=System.(46458)
- Fixed the issue that the page are overlapped and are bigger than the container.
- Fixed the issue that incorrect links are displayed in the RequestNavigate event
  (45697)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that garbled character is appeared when delete the first
  character of 4byte Japanese text.(TFS-46203)

# Release version 4.0.20133.369 - 11/18/2013

## C1.WPF.DataGrid

### Bug fixes

- Bug related to the groups when setting ItemsSource in a grid that was previously
  grouped with a different source.
- Resizing a column was not working correctly when FlowDirection="RightToLeft".

## C1.WPF.FlexGrid

### Bug fixes

- HitTest did not work correctly with Visuals that were not FrameworkElement objects (TFS 43347)
- Selecting template cells when the original event was handled was not working properly.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that in C1PdfViewer, wrong character is displayed.(TFS-29618)
- Fixed the issue that in C1PdfViewer, extra spaces is displayed.(TFS-44523)
  (TFS-33260)
- Fixed the performance issue with pdfviewer when RenderMode= System.
- Fixed the issue that circle bullet icons are replaced with rectangles.
  (TFS-46038)

## C1.WPF.ReportViewer

### Bug Fixes:

- Fixed the issue that wrong page text rendering when changed viewer mode.
  (TFS-45716)
- Fixed the issue that Some found occurence are not highlighted
  when searching in 'Find' textbox (TFS-46029)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that "Top" Padding is removed on setting "Bottom" padding and
  vice versa for Table Cells in C1RichTextBox.(TFS-41281)
- Fixed the issue that exception is thrown on setting "SelectionLength"
  property at design-time.(TFS-36382)

# Release version 4.0.20133.367 - 11/11/2013

## C1.WPF

### Breaking Changes

- C1ListViewer.ItemTap, ItemClick and ItemHold events were marked as "Obsolete",
  use ItemTapped and ItemHolding instead.

### Bug fixes

- C1ListViewer items whose width was bigger than the viewport was being clipped.
- C1ListViewerItem and C1ListBoxItem properties Horizontal/VerticalContentAlignment
  were not honored.
- [C1ComboBox] Fixed the issue that C1ComboBox dropdown is filckering and
  Application hangs if reopen the dropdown when Condition property is set.(TFS-45274)
- [C1ComboBox] Fixed the issue that SelectedIndex property does not correctly
  work after pasting the text.(TFS-45995)
- [C1ComboBox] Fixed the issue that user cannot enter the text in C1ComboBox.
- [C1ComboBox] Fixed the issue that user could not enter Japanese text into
  C1ComboBox.(TFS-45454)
- [C1ComboBox] Fixed the issue that setting the 'ItemFormatString' property does
  not set the format in Edit mode.(TFS-44912)
- [C1ComboBox] Fixed the issue that Condition="Contains" property setting
  does not work when C1ComboBox is reopened.(TFS-45268)
- [C1HyperlinkButton] Keep mouse over brush when the foreground is changed.
- [C1Window] Fix the issue that C1Window does not get displayed when application
  is run from tray icon.(TFS-44347)
- [C1ListViewer] Layout changed to stretch items when the width of the
  items is not specified.
- [C1ListViewer] MouseOverBrush was not being applied correctly.
- [C1ComboBox] Fixed the issue that subsequent typed text are not shown in
  C1ComboBox after clearing the text by pressing "Esc" key.(TFS-45366)
- [C1ComboBox] Fixed the issue that combobox item selection through keyboard
  does not work correctly if Condition="Contains".(TFS-45417)
- [C1ProgressBar] IndeterminateForeground was not being applied.
- [C1HyperlinkButton] IsEnabled and Foreground properties were not working.
- [C1NumericBox, C1MaskedTextBox] Controls now honour the FrameworkElement.Language
  property. The Culture property is marked as obsolete.
- [C1ComboBox] 'XamlParseException' is thrown if C1ComboBox content contains
  DoubleQuotes (") character.(TFS-44522)
- [C1DropDown] Unlike previous build, drop-down displays at incorrect position
  on resizing the window.(TFS-41272)
- [C1TabControl] Change of the C1TabControl.TabStripPlacement property value
  may distort control layout under some specific conditions.
- [C1ComboBox] 'XamlParseException' is thrown if C1ComboBox content contains
  Ampersand ('&') character.(TFS-43132)
- [C1TabControl] C1TabControl with a global close button causes an infinite
  measure/arrange loop when minimized to a length that doesn't fit a single tab.

### Improvements

- C1TapHelper.Holding event added.
- C1ListBox now accept selecting an item by clicking it or tapping it.
- C1ListViewer now support loading items on demand.

## C1.WPF.Automation

### Bug fixes

- Silverlight 5 automation assembly can't be loaded even if it's referenced in an application
  project.
- An application may become irresponsive in case where an automation assembly can't be found.

## C1.WPF.DataGrid

### Bug fixes

- Render problem after collapsing group rows detected.
- First key stroke was ignored in template column when entering in edit mode.
- Selecting multiple rows by dragging row headers was not working properly.
- Dragging a frozen column header was not working properly.
- Allow sorting by clicking the column header in the grouping area when CanUserGroup is set to false.
- Avoid setting filter when is the same as the previous one.
- Selection logic was not working fine when ctrl key was pressed.
- Avoid grouping the same column (or two columns with the same group field) twice.

### Improvements

- Selection of rows by dragging the row headers.
- C1DataGrid default template improved.

## C1.WPF.DateTime

### Bug Fixes

- Fixed focus issue when C1DatePicker is placed into WPF ToolBar (Tfs issue 42861).

## C1.WPF.Docking

### Bug Fixes:

- [C1DockTabControl] When in the Sliding mode, if control is resized to a zero length
  then it becomes impossible to resize it back.
- [C1DockTabControl] When dragging a single tab item of a floating C1DockTabControl,
  the latter doesn't move behind the mouse pointer.
- [C1DockTabControl] Closing of a last tab of a floating C1DockTabControl doesn't cause
  closing of the latter. Now it gets DockMode = DockMode.Floating in this case.

## C1.WPF.Extended

### Bug fixes

- [C1Book] Fix the issue that C1Book is distorted on changing ‘CurrentPage’
  property when ShowPageFold is set to 'Always'.(TFS-43991)
- [C1PropertyGrid] 'Reset Button' is not appeared even 'ShowResetButton'
  checkbox is ON.(TFS-14100)
- C1Reflector AutoUpdate property was not being honored.
- [C1PropertyGrid] Unlike Silverlight C1PropertyGrid, ellipsis button is not
  observed for ‘Items’ property and ‘Items’ collection editor is not available.(TFS-40437)
- ColorPicker keyboard navigation fixed.

## C1.WPF.FlexGrid

### Bug fixes

- Printed grid was not honoring MinHeight property.
- In the Japanese version only, require pressing enter twice to finish edit mode (TFS 41823).
- Checkbox state was not changed correctly after entering in edit mode.
- Auto-sizing a column with the mouse was causing the sort operation to be executed incorrectly.
- Selection was not performed when templated cells contain elements that handle mouse events.

## C1.WPF.FlexGrid.GroupPanel

### Improvements

- Scroll grid horizontally while dragging columns off the grid (TFS 42448)

## C1.WPF.FlexGridFilter

### Bug Fixes

- Fixed problem persisting condition filters for nullable types (TFS 45112)

## C1.WPF.Maps

### Bug fixes:

- Fix the issues that Bing maps key can't take effect on C1Maps.

## C1.WPF.OutlookBar

### Bug fixes

- [C1Outlookbar] Unlike previous build, icons are not displayed in
  contextmenu of databound C1Outlookbar.(TFS-42026)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that circle bullets are shown as the square bullets
  when WingDings font and bullets are rendered in C1PdfViewer.(TFS-42827)
- Fixed the issue that extra spaces appear when load certain pdf file.(TFS-45523)
- Fixed the issue that spaces disappear when load certain pdf file.(TFS-45525)
- Fixed the issue that bulleted list items are not correctly rendered
  in C1PdfViewer.(TFS-45715)
- Fixed the issue that text clipped when load certain file.(TFS-41690)
- Fixed the issue that certain text can not be found.(TFS-43910)
- Fixed the issue that FreeText can not show.(TFS-42910)
- Fixed the issue that when the acroform pdf file is loaded in C1PdfViewer,
  ListBox and ComboBox shown blank instead of displaying their respective items in them.
  (TFS-42904).
- To support password textbox and readonly textbox for formField .(TFS-42902).
- Fixed the issue that text overlapped and clipped when load certain text file.
  (TFS-41690)(TFS-41981)
- Fixed the issue that Border style is missing in input controls of loaded pdf file.
  (TFS-43664).
- Fixed the issue that When the acroform pdf file is loaded in C1PdfViewer,
  text cannot enter in the blank cell of the table.(TFS-42907)
- Fixed the issue that RequestNavigate event which link self file does not fire.
  (TFS-43305)
- Fixed the issue that Unhandled exception [Input string was not in correct format xxx ]
  occurs.(TFS-42803)
- Fixed the issue that thrown nullreference exception on loading pdf file.(TFS-42804)
- Fixed the issue that thrown unhandled exception on loading pdf file.(TFS-42805)
- Fixed the issue that it does not scroll down to show the found result.(TFS-42909)
- Fixed the issue that Signature and Paragraph are missing in load pdf file.(TFS-42821)

## C1.WPF.ReportViewer

### Bug Fixes:

- Fixd the issue that 'System.ExecutionEngineException' exception occurred when
  choose 'One Page' in zoom dropdown in toolbar.(TFS-44071)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that RemoveShortcut method does not work on Shift+Insert
  key combination.(TFS-44859)

## C1.WPF.Schedule

### Bug Fixes

- fixed issue with CalendarHelper.EndDayTime set to 24:00
  (http://our.componentone.com/groups/topic/c1scheduler-showworktimeonly-calendarhelper-enddaytime/).

### Improvements

- embedded dialogs honor C1Scheduler.FlowDirection property value (Tfs issue 37061).
- added new properties to the C1SchedulerSettings class:
  public Size AppointmentDialogSize { get; set; }
  Gets or sets the size of the Appointment dialog.
  Note, Appointment dialog is resizable, so this property might be changed at run time if end-user resizes the window.
  public Size AppointmentDialogMinSize { get; set; }
  Gets or sets the minimum size of the Appointment dialog.
  These properties are honored both for default and custom EditAppointmentTemplate.
- added support for touch scrolling. On touch-enabled devices end-user can scroll C1Scheduler by sliding scrollable area.
  The default C1Scheduler control templates have been updated to support touch scrolling. That includes adding
  ScrollViewerTouchBehavior to ScrollViewers and setting C1SchedulerPresenter.PanningDirection property according to the scroll orientation.
  Note, if C1SchedulerPresenter.PanningDirection property is not set,
  all touch interactions will be used for selection and touch scrolling might not work.
  If you use custom control templates and need the same touch support, look at changes in default xaml and update your templates in the same way.

## C1.WPF.Theming

### Bug Fixes:

- Added Theming.Office2013 assembly with the White, LightGray and DarkGray themes included.
- In Theming.Office2013 foreground was not propagated because the usage of an implicit style
  whose forground was set.

## C1.WPF.Tile

### Bug fixes

- Unlike C1FlipTile, ‘DropShadowEffect’ is not affected in C1Tile and C1SlideTile (Tfs issue 43463).
  Added the new TemplatePart to the C1Tile control. If control template contains element with "contentGrid" name,
  the C1Tile control will clip this element to bounds so that to don't allow animated content get out of control bounds.
  If this template part does not exist in the control template, then the C1TileControl will clip itself.

# Release version 4.0.20132.359 - 09/30/2013

## C1.WPF

### Bug fixes

- [C1DragDropManager] Some items could not be dragged when the source was inside a Popup.
- [C1HyperlinkButton] Add licensing check to C1HyperLinkButton.
- [C1DropDown] When click expand button of C1DropDown in Browser application ,
  'SecurityException' exception occurred.(TFS-41752)
- [C1DataGrid] Filter popup does not detect boundary when setting
  �FlowDirection � RightToLeft�.(TFS-42248)

## C1.WPF.Extended

### Bug fixes

- [C1Book] Page fold is not displayed correctly on turning pages using ‘Page Up’
  key when hovering mouse over book page.(TFS-41091)
- C1ColorPicker was not showing current selected color in basic tab.

### Improvements

- C1SpectrumColorPicker improved to avoid changing hue when it is indeterminate.

## C1.WPF.Maps

### Breaking Changes:

- Remove ParentMaps property from C1MapCanvas/C1MapItemsLayer/C1MapTilesLayer/
  C1MapToolsLayer/C1MapVirtualLayer/C1VectorLayer classes.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that unknown white line is displayed
  in the header of loaded pdf file.(TFS-41693)
- Fixed the issue that when customer's pdf file is viewed in C1PDfViewer ,
  then 'Invalid file format' error is observed.(TFS-42043)
- Fixed the issue that extra spaces are inserted.(TFS-42436)
- Fixed the issue last word of the sentence is not displayed in loaded pdf file.(41690)
- Fixed the issue that text are overlapped.(40275)

### Improvements:

- Provide formfield support to C1PDFViewer.
- Provide annotation support to C1PDFViewer.

## C1.WPF.Toolbar

### Bug Fixes

- C1ToolBarSplitButton.Click event fires correctly(TFS 42602).

# Release version 4.0.20132.358 - 09/23/2013

## C1.WPF.DataGrid.Filters

### Bug fixes:

- DataGridFilterRow was not honoring CanUserFilter property of DataGridColumn.

# Release version 4.0.20132.357 - 09/16/2013

## C1.WPF

### Bug fixes

- [C1ComboBox] Unlike previous build, C1ComboBox is not cleared after some
  scenarios.(TFS-41757)
- [C1ListBox] SelectedItems property was not working properly.

## C1.WPF.Maps

### Improvements:

- Add InertialScrolling to C1Maps control in order to enable/disable inertial scrolling.

## C1.WPF.OutlookBar

### Bug fixes

- [C1OutlookBar] Unlike previous build, each item
  of bounded data value is displayed twice in C1OutlookItem headers.(TFS-41702)
- [C1OutlookBar] Unlike previous build, data is not correctly displayed
  in header of C1OutlookItem present in unbound C1OutlookBar.(TFS-41700)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that text are overlapped in loaded pdf file
  when pdf file is loaded into C1PdfViewer.

## C1.WPF.RichTextBox

### Improvements:

- Add Ignore property to DocumentHistory which is used to indicates whether
  the action is stored in DocumentHistory or not when change the document.

# Release version 4.0.20132.355 - 09/09/2013

## C1.WPF

### Bug fixes

- [C1ComboBox] Unlike previous build, when 'Condition' property is set to
  'Contains', incorrect behavior is observed.(TFS-41613)

## C1.WPF.DataGrid

### Bug fixes

- When two colums had the same "Binding" and the underlying data source was grouped by
  that field, two grouped fields were shown in the grouping area.

## C1.WPF.Maps

### Bug fixes:

- The position of C1VectorLayer updated correctly after panning(TFS-41501).

## C1.WPF.PdfViewer

### Bug Fixes:

- [C1PdfViewer] Unlike previous build, some characters are missing
  when pdf file is loaded into C1PdfViewer.(TFS-41517)
- [C1PdfViewer] Unlike Silverlight C1PdfViewer, Pressing up/down arrow keys from
  keyboard causes zooming.(TFS-40944)

# Release version 4.0.20132.353 - 09/02/2013

## C1.WPF

### Bug fixes

- [C1ListViewer] items dissapear when theme is changed.

## C1.WPF.Extended

### Bug fixes

- [C1Book] C1BookItems cannot be added through Collection Editor.(TFS-26931)

### Improvements

- C1Accordion exception raised when changing the theme applied.

## C1.WPF.OutlookBar

### Bug fixes

- [C1OutlookBar] Unlike previous build, dynamically added items are
  not correctly displayed.(TFS-41100)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that image mask render incorrectly. (TFS-41221)(TFS-41228)
- Fixed the issue that text are overlapped and some char render incorrectly. (TFS-41052)
- Fixed the issue that PDFViewer raise an exception when load a certain file. (TFS-41417)

# Release version 4.0.20132.352 - 08/26/2013

## C1.WPF

### Improvements

- [C1DropDown] Dropdown flicker on changing �DropDownHeight� and �DropDownWidth�
  when drop-down is opened.(TFS-40961)

## C1.WPF.DataGrid

### Bug fixes

- Exception raised when opening the filter of a combo box column whose ItemsSource is loaded on demand.

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that image background render black in C1PdfViewer. (TFS-41044)

## C1.WPF.Schedule

### Improvements

- added new public method to the C1Scheduler control:
  public void NavigateToGroup(int index);
  If the C1Scheduler control is grouped, this method makes sure that the group with the specified index is visible in the UI.
  Parameter index - the index of group in the C1Scheduler.GroupItems collection.
  The sample of using:
  // C1Scheduler.GroupBy = "Category"
  // find group by category
  SchedulerGroupItem group = sched1.GroupItems[sched1.DataStorage.CategoryStorage.Categories[12]];
  // navigate to the found group
  sched1.NavigateToGroup(sched1.GroupItems.IndexOf(group));

# Release version 4.0.20132.351 - 08/19/2013

## C1.WPF

### Bug fixes

- [C1TapHelper] Tapped event was not fired correctly in SL and WPF3.5.

## C1.WPF.DataGrid

### Bug fixes

- Tapping in an editing control causes editing to be finished unexpectedly.
- Reordering columns in the grouping panel causes an exception if the column is not sorted.
- Column headers indicators are misplaced when dragging them if the windows is not maximized.

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Export time non-linearly grows with grid rows increase in case of big number of columns.
  The performance improvement is actually made in C1Excel.

## C1.WPF.Extended

### Improvements

- [C1PropertyGrid] Add PropertyBorderBrush, PropertyBorderThickness
  and EditorPadding property into C1PropertyGrid.

## C1.WPF.OutlookBar

### Bug fixes

- [C1OutlookBar] Unlike previous build, image path is displayed instead
  of LargeIcon and SmallIcon.(TFS-40614)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that image is not display in C1PdfViewer. (TFS-40812)
- Fixed the issue that text location render incorrectly.(TFS-40947)
- Fixed the issue that background render incorrectly.(TFS-40711)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that it navigates to the Home page when pressing 'Backspace'
  key in C1RichTextBox of 'Import & Export' sample.(TFS-33201)
- Fixed the issue that line breaks are missing when html file is loaded in
  C1RichTextBox.(TFS-40974)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that watermark is not shown when "Insert Image" dialog
  is opened.(TFS-40616)

## C1.WPF.Theming

### Bug Fixes:

- Themes are not applied to C1MaskedTextBox.

# Release version 4.0.20132.350 - 08/12/2013

## C1.WPF

### Bug fixes

- [C1ComboBox] When C1ComboBox's Condition property is set to 'Contains', cursor
  move to the initial point as soon as type the text.(TFS-40603)

## C1.WPF.DataGrid

### Bug fixes

- Grouping feature not working when dragging a second column in the grouping area.
- Exception raised when cancelling the editing of a row.
- Group header was not being displayed correctly in the grouping area.
- French translation improved.
- Tapping in the filter frame was causing sort operation to be executed unexpectedly.
- Checkbox state was not changed when tapped with the finger in DataGridCheckBoxColumn.

## C1.WPF.Maps

### Bug fixes:

- Fix the issue that C1Maps is not correctly rendered when 'Zoom' is
  increased/decreased.(TFS-40475)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that text in the page are not fully displayed. (TFS-40485)

### Improvements:

- Add BlackoutWords property that make specific text as black out.(TFS-29415)

# Release version 4.0.20132.349 - 08/05/2013

## C1.WPF

### Bug fixes

- C1TapHelper.Tapped was being raised twice when the gesture was performed
  with the finger and IsManipulationEnabled set to false.

### Improvements

- C1TapHelper.RightTapped event added.

## C1.WPF.DataGrid

### Bug fixes

- Remove validation error from new row when the editing is canceled.

### Improvements

- Allow grouping without sorting.
- CanceledNewRow and CanceledRowEdit events added.

## C1.WPF.Extended

### Bug fixes

- [C1Book] Incorrect behavior is showed when PageMode is changed from
  OnePage to TwoPage at the run time.(TFS-40301)
- [C1Book] Incorrect property description is showed for 'PageMode.TwoPage'.(TFS-40300)

## C1.WPF.FlexGrid

### Bug fixes

- Selecting a second range of cells by pressing ctrl key and dragging the selection was not working correctly.

## C1.WPF.FlexGrid.GroupPanel

### Initial Release

- The C1FlexGridGroupPanel class provides a UI for manipulating groups in a bound
  C1FlexGrid control.
- The C1FlexGridGroupPanel is an independent element that is connected to a
  C1FlexGrid through the "FlexGrid" property.
- The C1FlexGridGroupPanel shows a panel and allows users to create groups by
  dragging column headers from the grid into the panel. Users can reorder the
  groups by dragging the group markers, or sort and remove groups by clicking
  the group markers.
- The appearance of the group markers is automatically determined by the grid
  that is connected to the C1FlexGridGroupPanel. You don't have to select any
  fonts or brushes.
- The XAML below shows how you would create a C1FlexGridGroupPanel and connect
  it to a C1FlexGrid:
  <!-- Add a grouping UI to the _flex control -->
  <c1:C1FlexGridGroupPanel
  x:Name="_groupPanel" Grid.Row="0" Background="WhiteSmoke"
  FlexGrid="{Binding ElementName=_flex}"
  WatermarkText="Drag column headers here to create groups."
  MaxGroups="8"
  HideGroupedColumns="True"
  DragMarkerColor="#312DFF" />

## C1.WPF.OutlookBar

### Bug fixes

- [C1OutlookBar] Unlike previous build, LargeIcon is not shown when
  it is bounded.(TFS-40229)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that images are not rendered correctly.(TFS-40353)
- Fixed the issue that images are not rendered correctly.(TFS-40449)
- Fixed the issue that images are not rendered.(TFS-40121)
- Fixed the issue that images are not rendered.(TFS-40125)

# Release version 4.0.20132.344 - 07/29/2013

## C1.WPF

### Bug fixes

- [C1ComboBox] Unlike MS ComboBox, the text is not displayed when entering the
  1st character though it is in C1ComboBox dropdown list With
  'Condition' - StartsWith property.(TFS-33090)
- [C1ComboBox][C1NumericBox] Unlike Silverlight controls, �FocusBrush�
  color does not have effect on WPF controls.(TFS-39776)
- [C1ComboBox] Exception "Cannot Undo or Redo while undo unit is open" is thrown
  on pressing Ctrl+Z after entering the text which is not in the drop down list with
  "Condition" - Contains property.(TFS-33619)
- [C1ComboBox] Unlike MS ComboBox,it does not delete the character one by one in
  C1ComboBox.(TFS-33104)
- [C1ComboBox] Although the typed character exists in the dropdown list , the
  value is not selected in C1ComboBox.(TFS-33098)
- [C1ComboBox] Unlike MS ComboBox,the selected item is changed when pressing
  End/Home key while the dropdown list is opening.(TFS-33091)
- [C1ComboBox] Unlike MS-ComboBox, selecteditem is still shown in content of
  c1ComboBox although it is removed.(TFS-31637)

## C1.WPF.DataGrid

### Bug fixes

- StackOverflow exception thrown when multi-value filter contains more than 60.000 values to compare.
- Colums were not being auto-generated when the ItemsSource was a DataTable without rows.
- Error icon on the new row was not disappearing after commiting the row.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockTabControl] Dragging a C1DockTabControl with a single tab item onto a content
  of another C1DockTabControl may cause an exception.
- [C1DockTabControl] Control width may unexpectedly change on vertical resizing using
  a splitter.
- [C1DockControl] ‘Items’ editor is disappeared on opening drop-down when
  C1DockControl exists on the same page.(TFS-39866)
- [C1DockTab] C1DockTabControl is not displayed at design time if
  'DockMode' is floating.(TFS-19878)
- [C1DockControl] Unlike Silverlight control, C1DockTabItem is not able
  to reorder when C1DockTabControl is in Floating mode(TFS-39886)
- [C1DockControl]CenterDockingIndicator is not shown for float dock
  item and not disappeared when parent control tabitem is changed(TFS-36508)
- [DockControl] InvalidOperation exception 'Operation is not valid due to ...' is raised
  when docking the item inside its content(TFS-35724)
- [C1DockControl] C1DockControl is displayed with full size on
  placing it onto the page.(TFS-33707)

### Improvements

- [C1DockControl] Would like to save/load layout of floating C1DockTabControl.(TFS-29209)

## C1.WPF.Extended

### Bug fixes

- C1ColorPicker buttons made larger in order to be touched more easily.
- [C1Book] c1BookItem’s Background is not affected if setting color by
  setter.(TFS-32422)
- [C1Book] Unlike Silverlight, c1BookItems can be turned even setting
  ‘IsEnabled’ to ‘False’.(TFS-32356)

## C1.WPF.FlexGrid

### Bug fixes

- GetClipString and SetClipString methods now respect invisible rows (TFS 39945).

## C1.WPF.Maps

### Bug fixes:

- Fix the issue that layer items are missing to show in drop-down
  when opened 'Layers' editor of C1Maps.(TFS-39233)

## C1.WPF.OutlookBar

### Bug fixes

- [C1OutlookBar]The newly added items are not displayed in the customized menu.(TFS-33676)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that rendered with C1Report display incorrectly.(TFS-34807)
- Fixed the issue that images are not rendered correctly.(TFS-34281)

## C1.WPF.RichTextBox

### Breaking Changes

- Integrate rtf filter into C1RichTextBox assembly. Please remove the extra
  RtfFilter assembly in your application from now on.

### Bug fixes:

- Fixed the issue that more than 1 row is inserted when insert one new row in
  merged table.(TFS-36681)
- Fixed the issue that multiple cells are inserted if the table cells are
  merged.(TFS-34458)
- Fixed the issue that focus cursor does not get into user's view after adding new
  row by pressing TAB key.(TFS-39835)
- Fixed the issue that text from other control cannot be dropped into
  C1RichTextBox even when setting AllowDrop to True.(TFS-36396)
- Fixed the issue that Although hyperlink is removed from C1RichTextBox,
  it is not actually removed in it's html.(TFS-36675)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that "Insert Image" / "Insert Hyperlink" dialogs are not
  opened on clicking "Picture" or "Hyperlink" icon from collapsed toolbar group.(TFS-38127)

## C1.WPF.TileView

### Bug fixes

- [C1TileView] Bottom border of C1TileViewItem is clipped on
  setting ‘ScrollbarVisibility = Visible’.(TFS-36520)

# Release version 4.0.20132.342 - 07/18/2013

## C1.WPF

### Breaking Changes

- [C1TextBoxBase, C1MaskedTextBox] Default control's template doesn't include
  anymore a ScrollViewer named ContentElement with Border named PART_ContentHost inside;
  instead, it includes single ScrollViewer named PART_ContentHost.
  The controls are still able to work with old fashion templates.
- C1MouseHelper obsolete drag events removed, use C1DragHelper instead.

### Bug fixes

- C1ListViewer.IsSwipeEnabled default value set to false.
- [C1TabControl] Unlike previous build, SelectedIndex property does not work.(TFS-39903)
- [C1TreeView] Unlike previous build, DropDown Box is closed when clicking
  on expand button of C1TreeView.(TFS-39753)
- [All C1TextBoxBase based controls, like C1MaskedTextBox and C1NumericBox]
  Text can't be scrolled by mouse wheel.
- [C1Window] Although 'IsActive' property is set to false, C1Window is opened in
  the active state.(TFS-37240)
- [C1TabControl] C1TabControl is distorted on setting �TabStripPlacement�
  property in a certain scenario.(TFS-39481)
- [C1ComboBox] Unlike previous build, binding DropDownDirection property does
  not work after opening combobox.(TFS-39591)
- [C1Window] Unlike previous build, 'NullReferenceException' is occurred on
  setting C1 theme when running �Themes2010� sample.(TFS-39596)
- [C1ComboBox] Unlike previous build, filter dropdown icon is not
  displayed.(TFS-39581)
- ScrollViewerTouchBehavior was raising an exception when the Theme was changed.
- [Menu] Second level submenu opens overlapped or far away from its respective
  main menu.(TFS-36748)
- [C1ComboBox] Unlike MS ComboBox, selected text is displayed in reversed order
  after setting �FlowDirection � RightToLeft�.(TFS-37265)
- [C1TabControl] Unlike previous build, fist tab item is not shown as default selected item.(TFS-35846)
- C1Window could not be resized inwards with the finger.
- [C1ComboBox] Unlike MS ComboBox, selected text is displayed in reversed order
  after setting �FlowDirection � RightToLeft�.(TFS-37265)
- [C1NumericBox] Pressing d digit key when a current value is 0.d and is fully selected
  doesn't change the value to d.
  [Xaml][C1TabControl] Unhandled exception is occurred at design-time when drop
  C1TabControl on the design page in a certain scenario.(TFS-36112)
- [C1TreeView] When SelectionMode is set to Multiple, selected
  item does not get unselected by clicking again that item.(TFS-37383)
- [C1TreeView] Setting TextWrapping property on C1TreeViewItem does not work and text is not wrapped.(TFS-37049)
- [C1ComboBox] Exception "Specified argument was out of the range of valid values"
  is thrown on moving up to the invisible items.(TFS-36346)
- [C1TabControl] Unlike previous build, tab item selection gets lost after clicking
  "Pin" button and sorting applied.(TFS-35184)
- CornerRadius of templated ScrollViewer was not being clipped correctly.

### Improvements

- [C1DropDown] DropDown height does not extend beyond the Window.(TFS-31384)
- Added ScrollViewerTouchBehavior in order to give MS ScrollViewer the
  capability of being scrolled with the finger over the scrolling area.
- C1ComboBox, C1ListBox, C1TreeView, C1PropertyGrid touch support added.

## C1.WPF.DataGrid

### Breaking changes

- Group and sort features are enabled in a column whose SortMemberPath is null or empty
  string, set CanUserSort=False and CanUserGroup=False in order to disable these features.
- Filter feature is enabled in a column whose FilterMemberPath is null or empty
  string, set CanUserFilter=False in order to disable this feature.
- Editing feature of a bound column is enabled even if the mode of the binding is
  different from TwoWay, set IsReadOnly=True to disable this feature.

### Bug fixes

- 2 clicks was required to toggle the checkbox of a checkbox column.
- Avoid selecting DataGridColumnHeaderRow when Ctrl+A is pressed.
- Row header selected on mouse up event in order to work with C1DragDropManager.
- Current value lost when editing DataGridComboBoxColumn.
- Exception thrown when opening the combo box of a DataGridComboBoxColumn.
- DataGridHyperlinkColumn recycling was not working correctly.
- DataGridMultiValue filter was not working fine when previously a "Equals" predicate was set.
- Binding.Mode of the cells belonging to any DataGridBoundColumn, whose IsReadOnly property
  is set to true, is set to OneWay in order to avoid an exception thrown when the source
  property has no setter.
- DataGridCheckBoxColumn cells were not persisting values.
- Filters were not working fine when the ItemsSource was a DataTable.DefaultView.
- ImageColumn sorting/grouping feature was disabled by default.

### Improvements

- C1ValidationBehavior improved to refresh errors when INotifyPropertyChanged is raised.
- DataItem property added to the CreatingRow event args.
- ColumnHeaderOptionsVisibility property added in order to make the drop-down always visible.
- DataGridColumn.CanUserGroup property added.
- DataGridColumn.SortMemberPath and FilterMemberPath default value is taken from
  Binding.Path when they are not explicitly defined.
- DataGridColumn.Binding.Mode TwoWay value is not necessary any longer to edit the
  cells of the column.
- Touch support added in cells panel.

## C1.WPF.DataGrid.Excel

### Bug Fixes

- Date and numeric values can be exported using a format different from shown by C1DataGrid.
- Group header values may be incorrectly aligned.

## C1.WPF.DataGrid.Summaries

### Bug fixes

- Sum and Avg aggregate functions were not calculating the value correctly when a null
  value was set in any of the cells.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] Pane selector is shown in the
  above monitor and can’t select anything.(TFS-36220)
- [C1DockControl] A floating tab appears when C1DockTabControl is docked
  and changed to Sliding mode.(TFS-38967)
- [C1DockControl] Dock options menu is not closed even when C1DockTabControl
  is hidden by ‘Hide’ button.(TFS-39181)
- [C1DockControl] ‘NullReferenceException’ occurs on setting ‘DockMode – Floating’ at design-time.(TFS-38023)
- [C1DockControl] ‘InvalidOperationException’ is thrown when dragging
  C1DockTabControl which has data bound tabs.(TFS-37983)
- [C1DockControl] Sliding C1DockTabControl is not shown correctly at first
  time when there is more than one sliding tab.(TFS-38322)
- [C1DockControl] Unlike previous build, a line appears after C1DockTabControl
  is changed from ‘Sliding’ to ‘Floating’ state.(TFS-37771)
- [C1DockControl] C1DockTabControl is not retained its property setting after changed
  to Floating state by dragging the header.(TFS-38046)
- [DockControl] ‘Hidden’ option is shown in menu though CanUserHide property is set as ‘False’.(TFS-36218)
- [C1DockControl] Unlike previous build, ‘Sliding’ tab is shown at incorrect place on closing.(TFS-37720)
- [C1DockControl] Unlike previous build, when drag one C1DockTabItem
  from Floating C1DockTabControl, other tab items are lost.(TFS-37788)
- [C1DockControl] Unlike previous build, a line appears after
  C1DockTabControl is changed from ‘Sliding’ to ‘Floating’ state.(TFS-37771)
- [C1DockControl] Unlike previous build, docked tab still remain when
  C1DockTabControl is changed from ‘Docked’ to ‘Floating’ state.(TFS-37382)
- [DockControl] InvalidOperation exception 'Operation is not valid due to ...' is raised
  when docking the item inside its content(TFS-35724)
- [C1DockControl] Left and right panels are not stable when resizing inside
  C1DockControl after docked a C1DockTabControl(TFS-36455)
- [C1DockControl] Multiple issues observed when opening ‘Items’ collection editor of DockControl.(TFS-36430)
- [DockControl] DockTabItems Become Less Responsive as Items are added within.(TFS-34528)
- [DockControl] Dragging out a TabControl from the DockControl but the tab still in the dockcontrol.
- [DockControl] ‘Hidden’ option is shown in menu though CanUserHide property is set as ‘False’.(TFS-36218)
- [DockControl] Exception is observed on docking a C1DockTabControl to the center
  indicator of the internal docktabcontrol.(TFS-37317)
- [DockControl] Can’t prevent undocking of dock items.(TFS-35681)

## C1.WPF.Extended

### Bug fixes

- [C1PropertyGrid] Property DisplayName of MemberAttribute is not being displayed correctly in the property grid of silverligh
  control explorer.
- [C1Book] C1Book is disappeared when 'CurrentPage' property set odd number and
  set 'IsFirstPageOnTheRight=false' in runtime.(TFS-38417)
- [C1PropertyGrid] Remove PropertyGroup from VS ToolBox.(TFS-37439)
- [C1Book] Inconsistent CurrentPage value is shown in property grid and XAML tag.(TFS-37643)

## C1.WPF.FlexGrid

### Bug fixes

- Column/Row could no be resized by dragging its header separator and sorting was performed
  incorrectly on double clicking the resize separator.
- Sorting was performed incorrectly when outline bar buttons were pressed.
- Avoid scrolling horizontally when the gesture started over a row header, and vertically
  when the gesture is performed over a column header.
- Entering in edit mode by performing a double-click was not working fine.
- Sort action was incorrectly performed on mouse down, instead of mouse click,
  and when double-click was performed in the auto-resize zone.
- Avoid selecting when a row header is being resized.
- Click,Row/ColumnResized events were not being fired.
- Printing did not account for footer rows correctly (TFS 37350)

## C1.WPF.Gauge

### Bug Fixes:

- Fixed the issue that InvalidOperationException:'Specified value of type
  System.Windows.Media...' is raised on resizing C1Knob after moving it.(TFS-33944)

## C1.WPF.Maps

### Bug fixes:

- StackOverflow exception raised if map is unloaded while moving because of the inertia.
- Pan feature was not working when the mouse was pressed(without moving) in the pan tools.
- Tool's slider was not showing the correct zoom when set in xaml.
- Map was enlarged when clicking 'Zoom out' button twice, and panning was not stopped
  when mouse is released outside the panning control.
- Fix the issue that images of the placemarks don't show and polylines
  don't return to their set thickness on zooming in/out(TFS-36620).
- Fix the issue that clicking the navigation pan doesn't take any effect.

## C1.WPF.OutlookBar

### Improvements

- [OutlookBar] Request to simplify LargeIcon and SmallIcon implementation.(TFS-18451)

## C1.WPF.PdfViewer

### Bug Fixes:

- Fixed the issue that controls are missing in loaded pdf file.(TFS-39938)
- Fixed the issue that shows blank page after clicked 'TwoPages' button and
  image does not show correctly.(TFS-37916)
- Fixed the issue that occur an exception on loading the pdf file
  containing input elements.(TFS-39825)
- Fixed the issue that watermark text are not correctly displayed in loaded pdf
  file.(TFS-39832)
- Fixed the issue that the colours in pdf are inverted when pdf file containing
  scanned image is loaded.(TFS-39829)
- Fixed the issue that character‘E’is shown instead of dash ‘-‘.(TFS-35192)
- Fixed the issue that the symbol does not show correctly.(TFS-35950)
- Correct the display position of pdf control.(TFS-37721)
- Fixed the issue that the find text are not showed in the view
  when clicking 'find next' button on toolbar.(TFS-37759)
- Fixed the issue that the text spacing is be enlarged on clicking the mouse
  on the text.(TFS-36916)(TFS-36105)

### Improvements:

- Add parsing text field (using the "Tx" mechanism in the PDF file).
- Add FindNext and FindPrevious methods to get the occurrence of FindText
  in the specialized pages.

## C1.WPF.ReportViewer

### Bug Fixes:

- Correct the display position of pdf control.(TFS-37721)
- Fixed the issue that the find text are not showed in the view
  when clicking 'find next' button on toolbar.(TFS-37759)
- Fixed the issue that NullReferenceException is thrown when loading
  'mhtml' file and find text.(TFS-37976)

### Improvements:

- Add parsing text field (using the "Tx" mechanism in the PDF file).

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that rows appear to increase in size after deleting the cell
  content.(TFS-35627)
- Fixed the issue that table navigation with Tab does not continue when a cell
  contains bulleted/numbered list.(TFS-35641)
- Fixed the issue that Unlike MSWord, table cell is resizing when typing
  in a table.(TFS-35638)
- Fixed the issue that width setting is not correctly applied in loaded html
  file.(TFS-39798)
- Fixed the issue that when press 'Tab' key to navigate table cell, cell do not
  scroll into view.(TFS-35394)
- Table column width is not changed in % when removing/re-adding columns with
  undo/redo.(TFS-35166)
- Fixed the issue that incorrect observation for using <a> tag for Html
  property.(TFS-35811)
- Fixed the issue that focus cannot set at the last column if Table's width is
  greater than 150%.(TFS-38928)
- Fixed the issue that when table is copied and pasted in the another table,
  table is not pasted correctly.(TFS-39424)
- Fixed the issue that RichTextBox does not support multipage printing.(TFS-36795)
- Fixed the issue that cannot 'Cut' the table in RichTextBox via
  RichTextBoxToolbar.(TFS-34031)
- Fixed the issue that when html string is converted to Document using HtmlFilter,
  font size is changed.(TFS-37612)

## C1.WPF.RichTextBox.Toolbar

### Bug fixes:

- Fixed the issue that incorrect dialog pop up when finding non-existing
  word after existing word is found in RTB.(TFS-38416)

## C1.WPF.Schedule

### Bug Fixes

- Bug 37867 - Unlike previous build, 'SerializationException' is occur when recurrence appointment is export to binary file.

### Improvements

- performance related changes for the cases, when there are too many appointments in the visible area
  (http://our.componentone.com/groups/topic/increase-performance/#post-238894).
  Performance is a bit better, but still limited.
  This is limitation. The most of time is taken by the WPF/Silverlight layout system,
  not by the C1Scheduler control, there is no much room for further improvements here.

## C1.WPF.Theming

### Bug Fixes:

- Unlike VS 2010, only 'C1ThemeCosmopolitan' can be added to the VS toolbox(TFS-33256).

## C1.WPF.TileView

### Bug fixes

- [C1TileView][Touch] Finger tip sliding is not performed in the
  C1TileViewItem.(TFS-37859)

## C1.WPF.Zip

### Bug Fixes:

- Fix the issue that filename containing Japanese characters is output
  with garbled characters after compression.(TFS-18883)

# Release version 4.0.20131.329 - 05/30/2013

## C1.WPF.Docking

### Bug Fixes:

- [C1DockControl] In DockingSamples, Dock Tab 1 on the right edge of the Window, exception will be thrown.
- [C1DockControl] Entire dock pane disappears after dragging the pane out and place it back to its original position.(TFS-36215)

## C1.WPF.Gauge

### Bug Fixes:

- Fixed the issue that pointer is not able to drag when "InteractionMode" property
  is set to "Drag" or "ClickOrDrag" at run-time in C1Knob and C1RegionKnob.(TFS-35726)

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that C1RichTextBox is not scrolled correctly when
  selecting text by dragging mouse.(TFS-36594)
- Fixed the issue that Row is not correctly inserted when there is horizontal
  and vertical merged cells in table.(TFS-36581)

## C1.WPF.Schedule

### Bug Fixes

- Bug 37194 - Regression issue - recurring appointments cannot be fetched
  through Appointment.Conflicts property.

# Release version 4.0.20131.327 - 05/27/2013

## C1.WPF

### Bug fixes

- C1ListBox scrollbars corner radius was not displayed correctly.

## C1.WPF.Docking

### Improvements

- [C1DockControl] Enhancements of DockControl for V2.(TFS-35765,35766)

## C1.WPF.PdfViewer

### Improvements:

- Add DocumentInfo property to get the information of current document.

## C1.WPF.Schedule

### Improvements

- improved performance when working with recurring appointments (Tfs issue 37012).

# Release version 4.0.20131.326 - 05/20/2013

## C1.WPF

### Bug fixes

- C1ListBox vertical and horizontal scrollbars visibilities are not updated correctly
  when zoom mode was disabled.

## C1.WPF.DataGrid

### Bug fixes

- C1RowIndexHeaderBehavior was refreshing cells incorrectly.
- Avoid setting current row by clicking row header if Row.IsSelectable is false.

### Improvements

- DataGrid.Refresh() method parameter refreshRows added.

## C1.WPF.Docking

### Improvements

- [C1DockControl] Improve the style of the inner/outer drop indicators.(TFS-35767)

# Release version 4.0.20131.325 - 05/13/2013

## C1.WPF

### Bug fixes

- [C1TabControl]Unlike VS2010,the last item gets selection when navigating
  the items through its tabstrip menu with Down arrow key.(TFS-33877)
- [C1Menu] fixed ApplicationCommands support (Tfs issue 16974).
- C1ListBox scrolling issue was fixed, it occurred when setting ItemsSource for second time.

## C1.WPF.DataGrid

### Improvements

- DataGridRow.Refresh() method parameters refreshRow, refreshCells, refreshRowHeader added.

## C1.WPF.Extended

### Bug fixes

- [C1PropertyGrid] Add a new property which will enable multiple-selection
  and changing the common properties of the objects.(TFS-29517)

## C1.WPF.PdfViewer

### Improvements:

- Add GoToBookmark method which is used to jump to a specified bookmark.

# Release version 4.0.20131.324 - 05/06/2013

## C1.WPF.FlexGrid

### Bug fixes

- GetPageImages method was returning elements whose dimensions were different from the
  specified pageSize and the ScaleMode was different from ActualSize.
  Now all the returned pages dimensions are equal to the specified pageSize parameter.

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that text indentation is not maintained after copy paste.(TFS-36075)
- Fixed the issue that line breaks are removed after pasting from the clipboard.(TFS-36107)
- Fixed the issue that the whole table cannot be selected after table cell at
  the last row is deleted.(TFS-36147)

# Release version 4.0.20131.323 - 04/29/2013

## C1.WPF.Docking

### Improvements

- [C1DockControl] 'Items Collection' is closed when opening the dropdown for choosing item.(TFS-35710)

## C1.WPF.Extended

### Bug fixes

- Events of the content of C1AccordionItem were not being raised because IsHitTestVisible was set to false.

## C1.WPF.FlexGrid

### Improvements

- Keep collapsed state when ChildItemsCollection is set and the collection is modified

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that Table with merged cells not get deleted when using
  Selection.Delete(true,true) method.(TFS-35828)
- Fixed the issue that only first cell/row got pasted when copying
  the nested table.(TFS-35865)
- Fixed the issue that row cannot be selected if any cell from that row is
  deleted using "Delete Cells" menu item from C1RichTextBoxToolbar.(TFS-33018)
- Fixed the issue that extra table cell is added when copy/paste
  the merged table.(TFS-35822)
- Fixed the issue that redo action does not work at once on TextEditor Area.(TFS-33812)

# Release version 4.0.20131.322 - 04/22/2013

## C1.WPF

### Bug fixes

- [C1NumericBox] The value in C1NumericBox can be cut and pasted though "IsReadOnly" property is set to True.
- [C1NumericBox] The decimal numbers cannot be entered with Round-trip "R" format.
- [C1TabControl] Unlike previous build and MS-TabControl, tab item selection gets lost
  when the underlying data source is sorted.
- [C1TabControl] Unlike previous build, first tab item is always selected after closing a tab item.(TFS-35621)
- C1DragDropManager source marker was not clipped correctly when scrolling inside a scrollviewer.

### Improvements

- Romania language resources added.

## C1.WPF.DataGrid

### Bug fixes

- Incorrect selection set when dragging and scrolling at the same time.

### Improvements

- Romania language resources added to C1DataGrid.

## C1.WPF.Docking

### Improvements

- Romania language resources added.

## C1.WPF.Extended

### Improvements

- Romania language resources added.

## C1.WPF.MediaPlayer

### Improvements

- Romania language resources added.

## C1.WPF.PdfViewer

### Improvements:

- Romania language resources added.

## C1.WPF.ReportViewer

### Improvements

- Romania language resources added.

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that "OutOfMemoryException was unhandled" exception was
  thrown when apply paste action on second times for shape image.(TFS-34800)
- Fixed the issue that OutofMemoryException "Insufficient memory to continue..."
  is occurred when copying equation and pasting it twice.(TFS-35417)

## C1.WPF.RichTextBox.Toolbar

### Improvements:

- Fixed the issue that New Table is able to reselect and add again
  during selection apply on existing table.(TFS-33690)

# Release version 4.0.20131.321 - 04/15/2013

## C1.WPF.DataGrid

### Bug fixes

- Unknow column header is shown when dragging the mouse in an empty zone of the grouping area.

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that cannot 'Cut' the table in RichTextBox via
  RichTextBoxToolbar.(TFS-35673)

# Release version 4.0.20131.320 - 04/10/2013

## C1.WPF

### Bug fixes

- [C1ComboBox]'SelectedIndex' property does not work correctly after setting
  'Condition' and 'IsDropDownOpen' properties.(TFS-34627)

## C1.WPF.DataGrid

### Bug fixes

- Auto-generation of columns was not working fine when the underlying item type was
  "System.ServiceModel.DomainServices.Client.Entity".
- An exception was thrown when dragging in the grouping area.
- MouseLeftButtonUp event was not being raised in cell's presenters.

## C1.WPF.Docking

### Bug Fixes:

- [C1DockTabControl]Unlike previous build,C1DockTabControl is
  missing in Design time if drag and drop C1DockTabControl.(TFS-34820)

## C1.WPF.Extended

### Bug fixes

- C1ColorPicker FontSize was not being updated correctly at runtime.

# Release version 4.0.20131.319 - 04/08/2013

## C1.WPF

### Bug fixes

- C1DropDownButton exception raised when IsOpen is set to true before the template is applied.
- [C1TabControl] Unlike previous build, current item of C1TabControl is
  not synchronized with the underlying data source.(TFS-35515)
- [C1TabControl] Unlike previous build, second item is not selected after
  first item is pinned and removed.(TFS-35375)

## C1.WPF.DataGrid

### Bug fixes

- Value of a checkbox of a column was changed with the keyboard when the column was read-only.
- Incorrect value was returned by a cell belonging to a FilterRow.
- DBNull values were displayed as Nan rather than empty string.
- Exception raised when removing a row by pressing Del key at the same time the
  selection is performed with the mouse.

### Improvements

- CanUserSelectByDragging property added.

## C1.WPF.RichTextBox

### Bug fixes:

- Fixed the issue that GetHtml method adds line breaks after each word.(TFS-35364)

# Release version 4.0.20131.317 - 04/01/2013

## C1.WPF

### Bug fixes

- C1ListBoxItem selected state was not reflected correctly when selection was set
  before template was applied.

## C1.WPF.DataGrid

### Bug fixes

- CurrentColumn was not being set correctly when the columns are auto-generated as a
  consequence of the introduction of a new row.

## C1.WPF.Pdf

### Bug Fixes

